
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 16.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _key_pressed=R4
	.DEF _counter=R6
	.DEF _cring=R8
	.DEF _x=R10
	.DEF _result=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  _ext_int0_isr
	JMP  _ext_int1_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_char10:
	.DB  0x4,0x4,0x4,0x4,0x1F,0xE,0x4,0x0
_char11:
	.DB  0x4,0xE,0x1F,0x4,0x4,0x4,0x0,0x0
_char12:
	.DB  0x18,0x1C,0x1E,0x1F,0x1E,0x1C,0x18,0x0
_char13:
	.DB  0x0,0x0,0x1,0x2,0x14,0x8,0x0,0x0
_shmtable:
	.DB  0xB,0xA,0xA,0x9,0x9,0x9,0x8,0x9
	.DB  0x9,0xA,0xB,0x9,0x14,0x14,0x15,0x15
	.DB  0x16,0x16,0x16,0x16,0x15,0x15,0x14,0x13
	.DB  0xB,0xA,0xA,0x9,0x9,0x9,0x8,0x9
	.DB  0x9,0xA,0xB,0xA,0x14,0x14,0x15,0x15
	.DB  0x16,0x16,0x16,0x16,0x15,0x15,0x14,0x13
	.DB  0xC,0xB,0xB,0xA,0xA,0xA,0x9,0xA
	.DB  0xA,0xB,0xC,0xA,0x13,0x13,0x14,0x14
	.DB  0x15,0x15,0x15,0x15,0x14,0x14,0x13,0x12
_miltable:
	.DB  0x14,0x13,0x13,0x13,0x14,0x14,0x15,0x15
	.DB  0x15,0x15,0x14,0x14,0xA,0xB,0xA,0xC
	.DB  0xB,0xB,0xA,0xA,0xA,0x9,0xA,0xA
	.DB  0x13,0x12,0x14,0x14,0x15,0x15,0x16,0x16
	.DB  0x16,0x16,0x15,0x15,0xB,0xC,0xA,0xB
	.DB  0xA,0xA,0x9,0x9,0x9,0x8,0x9,0x9
	.DB  0x14,0x13,0x14,0x14,0x15,0x15,0x16,0x16
	.DB  0x16,0x16,0x15,0x15,0xA,0xB,0x9,0xB
	.DB  0xA,0xA,0x9,0x9,0x9,0x8,0x9,0x9
_tbl10_G103:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G103:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0xE
_0x4:
	.DB  0x40
_0x5:
	.DB  0x1
_0x20B:
	.DB  0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x30,0x0
_0x37F:
	.DB  0x10,0x0,0xA,0x0,0x0,0x0,0x0,0x0
_0x0:
	.DB  0x50,0x41,0x53,0x53,0x57,0x4F,0x52,0x44
	.DB  0x20,0x52,0x45,0x53,0x45,0x54,0x2E,0x2E
	.DB  0x0,0xFF,0x0,0x39,0x33,0x36,0x35,0x39
	.DB  0x39,0x34,0x36,0x36,0x30,0x0,0x4F,0x4B
	.DB  0x0,0x64,0x69,0x67,0x69,0x74,0x61,0x6C
	.DB  0x20,0x6C,0x6F,0x63,0x6B,0x0,0x3C,0x6D
	.DB  0x61,0x68,0x64,0x69,0x20,0x20,0x6D,0x69
	.DB  0x72,0x7A,0x61,0x65,0x69,0x3E,0x0,0x49
	.DB  0x6E,0x73,0x65,0x72,0x74,0x20,0x50,0x61
	.DB  0x73,0x73,0x77,0x6F,0x72,0x64,0x0,0x2A
	.DB  0x0,0x55,0x73,0x65,0x72,0x20,0x69,0x73
	.DB  0x20,0x4C,0x69,0x6D,0x69,0x74,0x0,0x43
	.DB  0x6F,0x6E,0x65,0x63,0x74,0x20,0x54,0x65
	.DB  0x6C,0x65,0x70,0x68,0x6F,0x6E,0x0,0x70
	.DB  0x6C,0x65,0x61,0x73,0x65,0x20,0x77,0x61
	.DB  0x69,0x74,0x65,0x0,0x6E,0x65,0x77,0x20
	.DB  0x50,0x61,0x73,0x73,0x3A,0x0,0x63,0x6F
	.DB  0x6E,0x66,0x69,0x72,0x6D,0x20,0x6E,0x65
	.DB  0x77,0x20,0x50,0x61,0x73,0x73,0x0,0x50
	.DB  0x61,0x73,0x73,0x77,0x6F,0x72,0x64,0x20
	.DB  0x43,0x68,0x61,0x6E,0x67,0x65,0x64,0x0
	.DB  0x65,0x72,0x72,0x6F,0x72,0x0,0x53,0x65
	.DB  0x74,0x20,0x50,0x61,0x73,0x73,0x77,0x6F
	.DB  0x72,0x64,0x0,0x55,0x73,0x65,0x72,0x20
	.DB  0x43,0x6F,0x6E,0x74,0x72,0x6F,0x6C,0x0
	.DB  0x20,0x25,0x30,0x32,0x75,0x3A,0x25,0x30
	.DB  0x32,0x75,0x20,0x20,0x20,0x20,0x25,0x30
	.DB  0x32,0x75,0x3A,0x25,0x30,0x32,0x75,0x0
	.DB  0x4F,0x6E,0x20,0x54,0x69,0x6D,0x65,0x20
	.DB  0x20,0x4F,0x66,0x66,0x54,0x69,0x6D,0x65
	.DB  0x0,0x52,0x65,0x6C,0x61,0x79,0x31,0x20
	.DB  0x20,0x52,0x65,0x6C,0x61,0x79,0x32,0x0
	.DB  0x52,0x65,0x6C,0x61,0x79,0x33,0x0,0x4F
	.DB  0x4E,0x0,0x4F,0x46,0x46,0x0,0x50,0x61
	.DB  0x73,0x73,0x77,0x6F,0x72,0x64,0x20,0x77
	.DB  0x68,0x65,0x6E,0x0,0x41,0x63,0x63,0x65
	.DB  0x73,0x73,0x20,0x52,0x65,0x6C,0x61,0x79
	.DB  0x73,0x0,0x55,0x73,0x65,0x72,0x5F,0x31
	.DB  0x0,0x55,0x73,0x65,0x72,0x5F,0x32,0x0
	.DB  0x55,0x73,0x65,0x72,0x5F,0x33,0x0,0x55
	.DB  0x73,0x65,0x72,0x5F,0x54,0x69,0x6D,0x65
	.DB  0x0,0x55,0x73,0x65,0x72,0x5F,0x50,0x68
	.DB  0x6F,0x6E,0x65,0x0,0x41,0x64,0x6D,0x69
	.DB  0x6E,0x0,0x55,0x73,0x65,0x72,0x2D,0x31
	.DB  0x0,0x55,0x73,0x65,0x72,0x2D,0x32,0x0
	.DB  0x55,0x73,0x65,0x72,0x2D,0x33,0x0,0x55
	.DB  0x73,0x65,0x72,0x2D,0x54,0x69,0x6D,0x65
	.DB  0x0,0x55,0x73,0x65,0x72,0x2D,0x50,0x68
	.DB  0x6F,0x6E,0x65,0x0,0x59,0x2F,0x4D,0x4D
	.DB  0x2F,0x44,0x44,0x2D,0x48,0x48,0x3A,0x4D
	.DB  0x4D,0x3A,0x53,0x53,0x0,0x4F,0x4B,0x20
	.DB  0x20,0x55,0x73,0x65,0x72,0x20,0x41,0x64
	.DB  0x6D,0x69,0x6E,0x0,0x4F,0x4B,0x20,0x20
	.DB  0x20,0x55,0x73,0x65,0x72,0x20,0x31,0x0
	.DB  0x4F,0x4B,0x20,0x20,0x20,0x55,0x73,0x65
	.DB  0x72,0x20,0x32,0x0,0x4F,0x4B,0x20,0x20
	.DB  0x20,0x55,0x73,0x65,0x72,0x20,0x33,0x0
	.DB  0x4F,0x4B,0x20,0x42,0x61,0x73,0x65,0x64
	.DB  0x20,0x6F,0x6E,0x20,0x54,0x69,0x6D,0x65
	.DB  0x0,0x20,0x54,0x68,0x69,0x73,0x20,0x70
	.DB  0x61,0x73,0x73,0x77,0x6F,0x72,0x64,0x0
	.DB  0x69,0x73,0x20,0x61,0x20,0x74,0x69,0x6D
	.DB  0x65,0x20,0x6C,0x69,0x6D,0x69,0x74,0x0
	.DB  0x31,0x20,0x2C,0x20,0x32,0x20,0x2C,0x20
	.DB  0x33,0x0,0x52,0x65,0x6C,0x61,0x79,0x20
	.DB  0x31,0x20,0x4F,0x4E,0x0,0x52,0x65,0x6C
	.DB  0x61,0x79,0x20,0x32,0x20,0x4F,0x4E,0x0
	.DB  0x52,0x65,0x6C,0x61,0x79,0x20,0x33,0x20
	.DB  0x4F,0x4E,0x0,0x45,0x72,0x72,0x6F,0x72
	.DB  0x20,0x70,0x61,0x73,0x73,0x77,0x6F,0x72
	.DB  0x64,0x0,0x77,0x61,0x72,0x6E,0x69,0x6E
	.DB  0x67,0x0,0x4B,0x65,0x79,0x70,0x61,0x64
	.DB  0x20,0x64,0x69,0x73,0x61,0x62,0x6C,0x65
	.DB  0x64,0x0,0x25,0x30,0x32,0x75,0x3A,0x25
	.DB  0x30,0x32,0x75,0x3A,0x25,0x30,0x32,0x75
	.DB  0x0,0x25,0x30,0x32,0x75,0x2F,0x25,0x30
	.DB  0x32,0x75,0x2F,0x25,0x30,0x32,0x75,0x0
	.DB  0x25,0x30,0x32,0x75,0x20,0x25,0x30,0x32
	.DB  0x75,0x20,0x25,0x30,0x32,0x75,0x0,0x53
	.DB  0x65,0x63,0x75,0x72,0x69,0x74,0x79,0x0
	.DB  0x44,0x61,0x74,0x65,0x26,0x54,0x69,0x6D
	.DB  0x65,0x0,0x44,0x69,0x73,0x70,0x6C,0x61
	.DB  0x79,0x0,0x52,0x65,0x6C,0x61,0x79,0x20
	.DB  0x6D,0x6F,0x64,0x0,0x52,0x69,0x6E,0x67
	.DB  0x20,0x50,0x68,0x6F,0x6E,0x65,0x0,0x52
	.DB  0x69,0x6E,0x67,0x20,0x50,0x68,0x6F,0x6E
	.DB  0x65,0x3A,0x0,0x25,0x33,0x64,0x0,0x4D
	.DB  0x6F,0x6D,0x65,0x6E,0x74,0x20,0x66,0x6F
	.DB  0x72,0x3A,0x0,0x4D,0x6F,0x6D,0x65,0x6E
	.DB  0x74,0x0,0x50,0x65,0x72,0x6D,0x61,0x6E
	.DB  0x65,0x6E,0x74,0x0,0x52,0x65,0x6C,0x61
	.DB  0x79,0x20,0x31,0x0,0x52,0x65,0x6C,0x61
	.DB  0x79,0x20,0x32,0x0,0x52,0x65,0x6C,0x61
	.DB  0x79,0x20,0x33,0x0,0x52,0x65,0x6C,0x61
	.DB  0x79,0x20,0x30,0x2A,0x0,0x42,0x72,0x69
	.DB  0x67,0x68,0x74,0x6E,0x65,0x73,0x73,0x0
	.DB  0x54,0x69,0x6D,0x65,0x53,0x63,0x72,0x65
	.DB  0x65,0x6E,0x0,0x7F,0x0,0x7E,0x0,0x42
	.DB  0x72,0x69,0x67,0x68,0x74,0x6E,0x65,0x73
	.DB  0x73,0x3A,0x0,0x54,0x69,0x6D,0x65,0x53
	.DB  0x63,0x72,0x65,0x65,0x6E,0x3A,0x0,0x25
	.DB  0x33,0x75,0x0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2080003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _tel_key
	.DW  _0x3*2

	.DW  0x01
	.DW  _Brightcount
	.DW  _0x4*2

	.DW  0x01
	.DW  _sw1
	.DW  _0x5*2

	.DW  0x0B
	.DW  _0x40
	.DW  _0x0*2+19

	.DW  0x0D
	.DW  _0x40+11
	.DW  _0x0*2+33

	.DW  0x11
	.DW  _0x40+24
	.DW  _0x0*2+46

	.DW  0x07
	.DW  _0x180
	.DW  _0x0*2+298

	.DW  0x07
	.DW  _0x180+7
	.DW  _0x0*2+305

	.DW  0x07
	.DW  _0x180+14
	.DW  _0x0*2+312

	.DW  0x0A
	.DW  _0x180+21
	.DW  _0x0*2+319

	.DW  0x0B
	.DW  _0x180+31
	.DW  _0x0*2+329

	.DW  0x06
	.DW  _0x1AF
	.DW  _0x0*2+340

	.DW  0x07
	.DW  _0x1AF+6
	.DW  _0x0*2+346

	.DW  0x07
	.DW  _0x1AF+13
	.DW  _0x0*2+353

	.DW  0x07
	.DW  _0x1AF+20
	.DW  _0x0*2+360

	.DW  0x0A
	.DW  _0x1AF+27
	.DW  _0x0*2+367

	.DW  0x0B
	.DW  _0x1AF+37
	.DW  _0x0*2+377

	.DW  0x09
	.DW  _0x2CD
	.DW  _0x0*2+631

	.DW  0x0A
	.DW  _0x2CD+9
	.DW  _0x0*2+640

	.DW  0x08
	.DW  _0x2CD+19
	.DW  _0x0*2+650

	.DW  0x0A
	.DW  _0x2CD+27
	.DW  _0x0*2+658

	.DW  0x0B
	.DW  _0x2CD+37
	.DW  _0x0*2+668

	.DW  0x08
	.DW  _0x31B
	.DW  _0x0*2+724

	.DW  0x08
	.DW  _0x31B+8
	.DW  _0x0*2+732

	.DW  0x08
	.DW  _0x31B+16
	.DW  _0x0*2+740

	.DW  0x09
	.DW  _0x31B+24
	.DW  _0x0*2+748

	.DW  0x08
	.DW  0x04
	.DW  _0x37F*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

	.DW  0x02
	.DW  __base_y_G104
	.DW  _0x2080003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/****************************************************
;
;  LOOK AVR
;mahdi mirzaei
;    1389
;
;
;Chip type           : ATmega32
;Program type        : Application
;Clock frequency     : 16,000000 MHz
;
;****************************************************/
;
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <string.h>
;#include <stdlib.h>
;#include <ctype.h>
;#include <delay.h>
;#include <stdio.h>
;#include <lcd.h>
;#include <i2c.h>
;#include <ds1307.h>
;#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=7
   .equ __scl_bit=6
   .equ __lcd_port=0x1B ;PORTA
; 0000 001C #endasm
;
;#define  relay1          PORTD.1
;#define  relay2          PORTD.4
;#define  relay3          PORTD.5
;#define  light           PORTD.0
;#define  light_LCD       PORTC.5
;#define  alarm           PORTD.6
;#define  conect_tel      PORTA.3
;#define  data_in         PINC &0x0F
;
;/************************************** **************************************************/
;bit  S=0;
;int  key_pressed=16,
;     counter=10,
;     cring=0,
;     x=0,
;     result,
;     user,
;     i,
;     j,
;     T0,
;     T1,
;     T2,
;     T3,
;     T4,
;     T5;
;char disp[6][13],
;     pass_in[11]="",
;     str_key_pressed[1],
;     main_password_load[11]="",
;     num_pass=0,
;     tel_pas_ok=0,
;     tel_pas_load[11]="",
;     tel_pas_in[11]="",
;     tel_key=14,

	.DSEG
;     tel_dtmf[1],
;     result_tel,
;     Brightcount=64,
;     sw1=1,
;     sw2=0,
;     buffer[16];
;unsigned char hour,
;              mino,
;              sec,
;              syear,
;              smonth,
;              sday;
;struct date
; {
;  unsigned char day;
;  unsigned char month;
;  unsigned char year;
; };
;struct date shmdate,mildate ;
;flash unsigned char char10[8] = { 0x4, 0x4, 0x4, 0x4, 0x1F, 0xE, 0x4,0x0 },
;                    char11[8] = { 0x4, 0xE, 0x1F, 0x4, 0x4, 0x4, 0x0,0x0 },
;                    char12[8] = { 0x18, 0x1C, 0x1E, 0x1F, 0x1E, 0x1C, 0x18,0x0 },
;                    char13[8] = { 0x0, 0x0, 0x1, 0x2, 0x14, 0x8, 0x0,0x0 },
;                    shmtable[6][12]= {
;                                      {11,10,10,9,9,9,8,9,9,10,11,9},
;                                      {20,20,21,21,22,22,22,22,21,21,20,19},
;                                      {11,10,10,9,9,9,8,9,9,10,11,10},
;                                      {20,20,21,21,22,22,22,22,21,21,20,19},
;                                      {12,11,11,10,10,10,9,10,10,11,12,10},
;                                      {19,19,20,20,21,21,21,21,20,20,19,18}
;                                     },
;                    miltable[6][12]= {
;                                       {20,19,19,19,20,20,21,21,21,21,20,20},
;                                       {10,11,10,12,11,11,10,10,10,9,10,10},
;                                       {19,18,20,20,21,21,22,22,22,22,21,21},
;                                       {11,12,10,11,10,10,9,9,9,8,9,9},
;                                       {20,19,20,20,21,21,22,22,22,22,21,21},
;                                       {10,11,9,11,10,10,9,9,9,8,9,9}
;                                      };
;
;eeprom int relay_mod[4]={1,1,1,1},
;           countring=3;
;eeprom char main_pass[11]="0" ,
;            user_1_pass[11]="1",
;            user_2_pass[11]="2",
;            user_3_pass[11]="3",
;            pass_time_str[12]="NNNNNNNNN0N",
;            phone_pass[11]="4";
;eeprom unsigned char relay_user[6][3]={{1,1,1},{1,1,1},{1,1,1},{1,1,1},{1,1,1},{1,1,1}},
;                     user_en[5][5]={{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0}};
;
;/************************************** **************************************************/
;void miltosham(unsigned char ym,unsigned char mm,unsigned char dm);
;void shamtomil(unsigned char ys ,unsigned char ms,unsigned char ds);
;void frest_page(void);
;char refresh_key(char st,char x,char y);
;void clear(void);
;void meno(void);
;void Security_meno(void);
;void Set_Password(void);
;void User_Control (void);
;void User_Control_active (void);
;void User_Control_Time (void);
;void User_Control_relay (void);
;int chek_pass(void);
;char user_c_t_ok(char use);
;void compar_time();
;void compar_pass(void);
;void pass_in_clean(void);
;void key(void);
;void change_pas();
;void pass_time(void);
;void clock(void);
;void sound(unsigned int hz,int ms);
;void tel_conect(void);
;void relay(int r);
;void Date_Time(void);
;void sw_meno(char ud,char con);
;void display_meno(char sw_1,char sw_2);
;void Display(void);
;void Brightness(void);
;void TimeScreen(void);
;void d_char(unsigned char flash *pc,unsigned char char_code);
;void Relay_seting(void);
;void Relay_set(void);
;void Moment(void);
;void Ring_Phone(void);
;
;/**************************************************************************************************/
;
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 009B  {

	.CSEG
_timer1_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 009C   TCNT1H=0x0B;
	CALL SUBOPT_0x0
; 0000 009D   TCNT1L=0xDC;
; 0000 009E   if(relay_mod[0]) if(relay1) if(T1>=relay_mod[0]) {T1=0; relay1=0;} else T1++;
	CALL SUBOPT_0x1
	SBIW R30,0
	BREQ _0x6
	SBIS 0x12,1
	RJMP _0x7
	CALL SUBOPT_0x1
	LDS  R26,_T1
	LDS  R27,_T1+1
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x8
	LDI  R30,LOW(0)
	STS  _T1,R30
	STS  _T1+1,R30
	CBI  0x12,1
	RJMP _0xB
_0x8:
	LDI  R26,LOW(_T1)
	LDI  R27,HIGH(_T1)
	CALL SUBOPT_0x2
; 0000 009F   if(relay_mod[1]) if(relay2) if(T2>=relay_mod[1]) {T2=0; relay2=0;} else T2++;
_0xB:
_0x7:
_0x6:
	CALL SUBOPT_0x3
	SBIW R30,0
	BREQ _0xC
	SBIS 0x12,4
	RJMP _0xD
	CALL SUBOPT_0x3
	LDS  R26,_T2
	LDS  R27,_T2+1
	CP   R26,R30
	CPC  R27,R31
	BRLT _0xE
	LDI  R30,LOW(0)
	STS  _T2,R30
	STS  _T2+1,R30
	CBI  0x12,4
	RJMP _0x11
_0xE:
	LDI  R26,LOW(_T2)
	LDI  R27,HIGH(_T2)
	CALL SUBOPT_0x2
; 0000 00A0   if(relay_mod[2]) if(relay3) if(T3>=relay_mod[2]) {T3=0; relay3=0;} else T3++;
_0x11:
_0xD:
_0xC:
	CALL SUBOPT_0x4
	SBIW R30,0
	BREQ _0x12
	SBIS 0x12,5
	RJMP _0x13
	CALL SUBOPT_0x4
	LDS  R26,_T3
	LDS  R27,_T3+1
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x14
	LDI  R30,LOW(0)
	STS  _T3,R30
	STS  _T3+1,R30
	CBI  0x12,5
	RJMP _0x17
_0x14:
	LDI  R26,LOW(_T3)
	LDI  R27,HIGH(_T3)
	CALL SUBOPT_0x2
; 0000 00A1   if(relay_mod[3]) if(light)  if(T4>=relay_mod[3]) {T4=0; light=0;}  else T4++;
_0x17:
_0x13:
_0x12:
	CALL SUBOPT_0x5
	SBIW R30,0
	BREQ _0x18
	SBIS 0x12,0
	RJMP _0x19
	CALL SUBOPT_0x5
	LDS  R26,_T4
	LDS  R27,_T4+1
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x1A
	LDI  R30,LOW(0)
	STS  _T4,R30
	STS  _T4+1,R30
	CBI  0x12,0
	RJMP _0x1D
_0x1A:
	LDI  R26,LOW(_T4)
	LDI  R27,HIGH(_T4)
	CALL SUBOPT_0x2
; 0000 00A2   if(T0) T0--;
_0x1D:
_0x19:
_0x18:
	CALL SUBOPT_0x6
	BREQ _0x1E
	LDI  R26,LOW(_T0)
	LDI  R27,HIGH(_T0)
	CALL SUBOPT_0x7
; 0000 00A3   if(T5) T5--;
_0x1E:
	LDS  R30,_T5
	LDS  R31,_T5+1
	SBIW R30,0
	BREQ _0x1F
	LDI  R26,LOW(_T5)
	LDI  R27,HIGH(_T5)
	CALL SUBOPT_0x7
; 0000 00A4  }
_0x1F:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;/**************************************************************************************************/
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 00A7  {
_ext_int0_isr:
	CALL SUBOPT_0x8
; 0000 00A8   if (conect_tel==0)
	SBIC 0x1B,3
	RJMP _0x20
; 0000 00A9     {
; 0000 00AA      if (light_LCD)
	SBIS 0x15,5
	RJMP _0x21
; 0000 00AB        {
; 0000 00AC         TCNT1H=0x0B;
	CALL SUBOPT_0x0
; 0000 00AD         TCNT1L=0xDC;
; 0000 00AE         T0=counter;
	CALL SUBOPT_0x9
; 0000 00AF        }
; 0000 00B0      else if (!T0)
	RJMP _0x22
_0x21:
	CALL SUBOPT_0x6
	BRNE _0x23
; 0000 00B1        {
; 0000 00B2         light_LCD=1;
	SBI  0x15,5
; 0000 00B3         i=100;
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0xA
; 0000 00B4         delay_ms(1200);
	LDI  R30,LOW(1200)
	LDI  R31,HIGH(1200)
	CALL SUBOPT_0xB
; 0000 00B5        }
; 0000 00B6     }
_0x23:
_0x22:
; 0000 00B7  }
_0x20:
	RJMP _0x37E
;/**************************************************************************************************/
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 00BA  {
_ext_int1_isr:
	CALL SUBOPT_0x8
; 0000 00BB   if (user_c_t_ok(4))
	LDI  R30,LOW(4)
	CALL SUBOPT_0xC
	BREQ _0x26
; 0000 00BC     {
; 0000 00BD      if (!T5) cring=0;
	LDS  R30,_T5
	LDS  R31,_T5+1
	SBIW R30,0
	BRNE _0x27
	CLR  R8
	CLR  R9
; 0000 00BE      if(T5<5)
_0x27:
	LDS  R26,_T5
	LDS  R27,_T5+1
	SBIW R26,5
	BRGE _0x28
; 0000 00BF        {
; 0000 00C0         T5=8;
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	STS  _T5,R30
	STS  _T5+1,R31
; 0000 00C1         cring++;
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
; 0000 00C2         if (cring>=countring)
	LDI  R26,LOW(_countring)
	LDI  R27,HIGH(_countring)
	CALL __EEPROMRDW
	CP   R8,R30
	CPC  R9,R31
	BRLT _0x29
; 0000 00C3           {
; 0000 00C4            light_LCD=0;
	CBI  0x15,5
; 0000 00C5            conect_tel=1;
	SBI  0x1B,3
; 0000 00C6            cring=0;
	CLR  R8
	CLR  R9
; 0000 00C7            T5=0;
	LDI  R30,LOW(0)
	STS  _T5,R30
	STS  _T5+1,R30
; 0000 00C8            T0=counter;
	CALL SUBOPT_0x9
; 0000 00C9           }
; 0000 00CA        }
_0x29:
; 0000 00CB     }
_0x28:
; 0000 00CC  }
_0x26:
_0x37E:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;/**************************************************************************************************/
;void main(void)
; 0000 00CF  {
_main:
; 0000 00D0   PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 00D1   DDRA=0x08;
	LDI  R30,LOW(8)
	OUT  0x1A,R30
; 0000 00D2   PORTB=0xFE;
	LDI  R30,LOW(254)
	OUT  0x18,R30
; 0000 00D3   DDRB=0x0F;
	LDI  R30,LOW(15)
	OUT  0x17,R30
; 0000 00D4   PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 00D5   DDRC=0x20;
	LDI  R30,LOW(32)
	OUT  0x14,R30
; 0000 00D6   PORTD=0x0C;
	LDI  R30,LOW(12)
	OUT  0x12,R30
; 0000 00D7   DDRD=0xF3;
	LDI  R30,LOW(243)
	OUT  0x11,R30
; 0000 00D8   TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 00D9   TCNT0=0x00;
	OUT  0x32,R30
; 0000 00DA   OCR0=0x00;
	OUT  0x3C,R30
; 0000 00DB   TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00DC   TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
; 0000 00DD   TCNT1H=0x0B;
	CALL SUBOPT_0x0
; 0000 00DE   TCNT1L=0xDC;
; 0000 00DF   ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
; 0000 00E0   ICR1L=0x00;
	OUT  0x26,R30
; 0000 00E1   OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00E2   OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00E3   OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00E4   OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00E5   TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 00E6   ASSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x22,R30
; 0000 00E7   TCCR2=0x6B;
	LDI  R30,LOW(107)
	OUT  0x25,R30
; 0000 00E8   TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 00E9   OCR2=64;
	LDI  R30,LOW(64)
	OUT  0x23,R30
; 0000 00EA   GICR|=0xC0;
	IN   R30,0x3B
	ORI  R30,LOW(0xC0)
	OUT  0x3B,R30
; 0000 00EB   MCUCR=0x0A;       //    
	LDI  R30,LOW(10)
	OUT  0x35,R30
; 0000 00EC   MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 00ED   GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 00EE   ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00EF   SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00F0   rtc_init(0,1,0);
	CALL SUBOPT_0xD
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _rtc_init
; 0000 00F1   lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
; 0000 00F2   d_char(char10,0);
	LDI  R30,LOW(_char10*2)
	LDI  R31,HIGH(_char10*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _d_char
; 0000 00F3   d_char(char11,1);
	LDI  R30,LOW(_char11*2)
	LDI  R31,HIGH(_char11*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _d_char
; 0000 00F4   d_char(char12,2);
	LDI  R30,LOW(_char12*2)
	LDI  R31,HIGH(_char12*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _d_char
; 0000 00F5   d_char(char13,3);
	LDI  R30,LOW(_char13*2)
	LDI  R31,HIGH(_char13*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _d_char
; 0000 00F6   conect_tel=0;
	CBI  0x1B,3
; 0000 00F7   light_LCD=1;
	SBI  0x15,5
; 0000 00F8   if(!PINB.4 && !PINB.5)
	SBIC 0x16,4
	RJMP _0x33
	SBIS 0x16,5
	RJMP _0x34
_0x33:
	RJMP _0x32
_0x34:
; 0000 00F9     {
; 0000 00FA      for(i=0;i<600 && !PINB.4 && !PINB.5;i++)delay_ms(10);
	CALL SUBOPT_0xE
_0x36:
	CALL SUBOPT_0xF
	CPI  R26,LOW(0x258)
	LDI  R30,HIGH(0x258)
	CPC  R27,R30
	BRGE _0x38
	SBIC 0x16,4
	RJMP _0x38
	SBIS 0x16,5
	RJMP _0x39
_0x38:
	RJMP _0x37
_0x39:
	CALL SUBOPT_0x10
	CALL SUBOPT_0x11
	RJMP _0x36
_0x37:
; 0000 00FB if(!PINB.4 && !PINB.5)
	SBIC 0x16,4
	RJMP _0x3B
	SBIS 0x16,5
	RJMP _0x3C
_0x3B:
	RJMP _0x3A
_0x3C:
; 0000 00FC        {
; 0000 00FD         lcd_gotoxy(0,0);
	CALL SUBOPT_0x12
; 0000 00FE         lcd_putsf("PASSWORD RESET..");
	__POINTW1FN _0x0,0
	CALL SUBOPT_0x13
; 0000 00FF         for(i=0;i<16;i++)
	CALL SUBOPT_0xE
_0x3E:
	CALL SUBOPT_0xF
	SBIW R26,16
	BRGE _0x3F
; 0000 0100           {
; 0000 0101            lcd_gotoxy(i,1);
	CALL SUBOPT_0x14
; 0000 0102            lcd_putsf("\xff");
	CALL SUBOPT_0x15
; 0000 0103            lcd_gotoxy(i+1,1);
	CALL SUBOPT_0x16
; 0000 0104            lcd_putchar(2);
	CALL SUBOPT_0x17
; 0000 0105            delay_ms(200);
	CALL SUBOPT_0x18
; 0000 0106           }
	CALL SUBOPT_0x11
	RJMP _0x3E
_0x3F:
; 0000 0107         strcpy(pass_in,"9365994660");
	CALL SUBOPT_0x19
	__POINTW1MN _0x40,0
	CALL SUBOPT_0x1A
; 0000 0108         for(i=0;i<10;i++)
_0x42:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0x43
; 0000 0109           {
; 0000 010A            main_pass[i]=pass_in[i];
	CALL SUBOPT_0xF
	SUBI R26,LOW(-_main_pass)
	SBCI R27,HIGH(-_main_pass)
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_pass_in)
	SBCI R31,HIGH(-_pass_in)
	LD   R30,Z
	CALL __EEPROMWRB
; 0000 010B            delay_ms(10);
	CALL SUBOPT_0x10
; 0000 010C           }
	CALL SUBOPT_0x11
	RJMP _0x42
_0x43:
; 0000 010D         main_pass[10]='/0';
	__POINTW2MN _main_pass,10
	LDI  R30,LOW(48)
	CALL __EEPROMWRB
; 0000 010E         lcd_clear();
	CALL _lcd_clear
; 0000 010F         lcd_gotoxy(7,0);
	CALL SUBOPT_0x1C
; 0000 0110         lcd_putsf("OK");
	__POINTW1FN _0x0,30
	CALL SUBOPT_0x13
; 0000 0111         delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	CALL SUBOPT_0xB
; 0000 0112        }
; 0000 0113     }
_0x3A:
; 0000 0114   while(!PINB.4 && !PINB.5);
_0x32:
_0x44:
	SBIC 0x16,4
	RJMP _0x47
	SBIS 0x16,5
	RJMP _0x48
_0x47:
	RJMP _0x46
_0x48:
	RJMP _0x44
_0x46:
; 0000 0115 
; 0000 0116   PORTB=0xF0;
	LDI  R30,LOW(240)
	OUT  0x18,R30
; 0000 0117   lcd_clear();
	CALL _lcd_clear
; 0000 0118   strcpy(buffer,"digital lock");
	CALL SUBOPT_0x1D
	__POINTW1MN _0x40,11
	CALL SUBOPT_0x1A
; 0000 0119   for(i=0;i<12;i++)
_0x4A:
	CALL SUBOPT_0xF
	SBIW R26,12
	BRGE _0x4B
; 0000 011A     {
; 0000 011B      lcd_gotoxy(i+2,0);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1F
; 0000 011C      lcd_putchar(buffer[i]);
	CALL SUBOPT_0x20
; 0000 011D      lcd_gotoxy(i+3,0);
	LDS  R30,_i
	SUBI R30,-LOW(3)
	ST   -Y,R30
	CALL SUBOPT_0x1F
; 0000 011E      if(i<11)
	CALL SUBOPT_0xF
	SBIW R26,11
	BRGE _0x4C
; 0000 011F        {
; 0000 0120         lcd_putsf("\xff");
	CALL SUBOPT_0x15
; 0000 0121         sound(3000,100);
	CALL SUBOPT_0x21
; 0000 0122        }
; 0000 0123      delay_ms(200);
_0x4C:
	CALL SUBOPT_0x18
; 0000 0124     }
	CALL SUBOPT_0x11
	RJMP _0x4A
_0x4B:
; 0000 0125   strcpy(buffer,"<mahdi  mirzaei>");
	CALL SUBOPT_0x1D
	__POINTW1MN _0x40,24
	CALL SUBOPT_0x1A
; 0000 0126   for(i=0;i<16;i++)
_0x4E:
	CALL SUBOPT_0xF
	SBIW R26,16
	BRGE _0x4F
; 0000 0127     {
; 0000 0128      lcd_gotoxy(i,1);
	CALL SUBOPT_0x14
; 0000 0129      lcd_putchar(buffer[i]);
	CALL SUBOPT_0x20
; 0000 012A      lcd_gotoxy(i+1,1);
	CALL SUBOPT_0x16
; 0000 012B      lcd_putsf("\xff");
	CALL SUBOPT_0x15
; 0000 012C      sound(3000,100);
	CALL SUBOPT_0x21
; 0000 012D      delay_ms(200);
	CALL SUBOPT_0x18
; 0000 012E     }
	CALL SUBOPT_0x11
	RJMP _0x4E
_0x4F:
; 0000 012F   delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	CALL SUBOPT_0xB
; 0000 0130   T0=0;
	CALL SUBOPT_0x22
; 0000 0131   #asm("sei")
	sei
; 0000 0132   frest_page();
	RCALL _frest_page
; 0000 0133  }
_0x50:
	RJMP _0x50

	.DSEG
_0x40:
	.BYTE 0x29
;/**************************************************************************************************/
;void miltosham(unsigned char ym,unsigned char mm,unsigned char dm)
; 0000 0136  {

	.CSEG
_miltosham:
; 0000 0137   unsigned char k,t1,t2;
; 0000 0138   k=ym%4;
	CALL SUBOPT_0x23
;	ym -> Y+6
;	mm -> Y+5
;	dm -> Y+4
;	k -> R17
;	t1 -> R16
;	t2 -> R19
; 0000 0139   if(k==3) k=2;
	CPI  R17,3
	BRNE _0x51
	LDI  R17,LOW(2)
; 0000 013A   k*=2;
_0x51:
	LSL  R17
; 0000 013B   t1=miltable[k][mm-1];
	CALL SUBOPT_0x24
	LPM  R16,Z
; 0000 013C   t2=miltable[k+1][mm-1];
	CALL SUBOPT_0x25
	ADIW R30,1
	CALL SUBOPT_0x26
	SUBI R30,LOW(-_miltable*2)
	SBCI R31,HIGH(-_miltable*2)
	CALL SUBOPT_0x27
	LPM  R19,Z
; 0000 013D   if(mm<3 || (mm==3 && dm<=miltable[k][mm-1]))
	LDD  R26,Y+5
	CPI  R26,LOW(0x3)
	BRLO _0x53
	CPI  R26,LOW(0x3)
	BRNE _0x54
	CALL SUBOPT_0x24
	LPM  R30,Z
	LDD  R26,Y+4
	CP   R30,R26
	BRSH _0x53
_0x54:
	RJMP _0x52
_0x53:
; 0000 013E     shmdate.year=ym+78;
	LDD  R30,Y+6
	SUBI R30,-LOW(78)
	RJMP _0x367
; 0000 013F   else
_0x52:
; 0000 0140     shmdate.year=ym+79;
	LDD  R30,Y+6
	SUBI R30,-LOW(79)
_0x367:
	__PUTB1MN _shmdate,2
; 0000 0141   if(dm<=t1)
	LDD  R26,Y+4
	CP   R16,R26
	BRLO _0x58
; 0000 0142     {
; 0000 0143      shmdate.day=dm+t2;
	MOV  R30,R19
	ADD  R30,R26
	CALL SUBOPT_0x28
; 0000 0144      shmdate.month=(mm+8)%12+1;
	ADIW R30,8
	RJMP _0x368
; 0000 0145     }
; 0000 0146   else
_0x58:
; 0000 0147     {
; 0000 0148      shmdate.day=dm-t1;
	CALL SUBOPT_0x29
	CALL SUBOPT_0x28
; 0000 0149      shmdate.month=(mm+9)%12+1;
	ADIW R30,9
_0x368:
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	CALL __MODW21
	SUBI R30,-LOW(1)
	__PUTB1MN _shmdate,1
; 0000 014A     }
; 0000 014B  }
	RJMP _0x210000C
;/**************************************************************************************************/
;void shamtomil(unsigned char ys ,unsigned char ms,unsigned char ds)
; 0000 014E  {
_shamtomil:
; 0000 014F   unsigned char k,t1,t2;
; 0000 0150   k = ys%4;
	CALL SUBOPT_0x23
;	ys -> Y+6
;	ms -> Y+5
;	ds -> Y+4
;	k -> R17
;	t1 -> R16
;	t2 -> R19
; 0000 0151   if(k==0)
	CPI  R17,0
	BRNE _0x5A
; 0000 0152     k=2;
	LDI  R17,LOW(2)
; 0000 0153   else
	RJMP _0x5B
_0x5A:
; 0000 0154     k=k+k;
	LSL  R17
; 0000 0155   t1=shmtable[k - 2][ms-1];
_0x5B:
	CALL SUBOPT_0x25
	SBIW R30,2
	CALL SUBOPT_0x26
	CALL SUBOPT_0x2A
	LPM  R16,Z
; 0000 0156   t2=shmtable[k-1][ms-1];
	CALL SUBOPT_0x25
	SBIW R30,1
	CALL SUBOPT_0x26
	CALL SUBOPT_0x2A
	LPM  R19,Z
; 0000 0157   if(ms<10 || (ms==10 && ds <= shmtable[k-2][ms-1]))
	LDD  R26,Y+5
	CPI  R26,LOW(0xA)
	BRLO _0x5D
	CPI  R26,LOW(0xA)
	BRNE _0x5E
	CALL SUBOPT_0x25
	SBIW R30,2
	CALL SUBOPT_0x26
	CALL SUBOPT_0x2A
	LPM  R30,Z
	LDD  R26,Y+4
	CP   R30,R26
	BRSH _0x5D
_0x5E:
	RJMP _0x5C
_0x5D:
; 0000 0158     mildate.year=ys-79;
	LDD  R30,Y+6
	LDI  R31,0
	SUBI R30,LOW(79)
	SBCI R31,HIGH(79)
	RJMP _0x369
; 0000 0159   else
_0x5C:
; 0000 015A     mildate.year=ys-78;
	LDD  R30,Y+6
	LDI  R31,0
	SUBI R30,LOW(78)
	SBCI R31,HIGH(78)
_0x369:
	__PUTB1MN _mildate,2
; 0000 015B   if(ds <= t1)
	LDD  R26,Y+4
	CP   R16,R26
	BRLO _0x62
; 0000 015C     {
; 0000 015D      mildate.day=ds+t2;
	MOV  R30,R19
	ADD  R30,R26
	CALL SUBOPT_0x2B
; 0000 015E      mildate.month=(ms+1)%12+1;
	ADIW R30,1
	RJMP _0x36A
; 0000 015F     }
; 0000 0160   else
_0x62:
; 0000 0161     {
; 0000 0162      mildate.day=ds-t1;
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2B
; 0000 0163      mildate.month=(ms+2)%12+1;
	ADIW R30,2
_0x36A:
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	CALL __MODW21
	SUBI R30,-LOW(1)
	__PUTB1MN _mildate,1
; 0000 0164     }
; 0000 0165  }
_0x210000C:
	CALL __LOADLOCR4
	ADIW R28,7
	RET
;/**************************************************************************************************/
;void frest_page(void)
; 0000 0168  {
_frest_page:
; 0000 0169   pass_in_clean();
	CALL _pass_in_clean
; 0000 016A   while (1)
_0x64:
; 0000 016B     {
; 0000 016C      key();
	CALL SUBOPT_0x2C
; 0000 016D      if(key_pressed==14)
	BRNE _0x67
; 0000 016E        {
; 0000 016F         lcd_clear();
	CALL _lcd_clear
; 0000 0170         T0=0;
	CALL SUBOPT_0x22
; 0000 0171        }
; 0000 0172      if(key_pressed==12)
_0x67:
	CALL SUBOPT_0x2D
	BRNE _0x68
; 0000 0173        {
; 0000 0174         light_LCD=1;
	SBI  0x15,5
; 0000 0175         clear();
	RCALL _clear
; 0000 0176         lcd_gotoxy(0,0);
	CALL SUBOPT_0x12
; 0000 0177         lcd_putsf("Insert Password");
	__POINTW1FN _0x0,63
	CALL SUBOPT_0x13
; 0000 0178        }
; 0000 0179      if(key_pressed==15 && x>0)
_0x68:
	CALL SUBOPT_0x2E
	BRNE _0x6C
	CLR  R0
	CP   R0,R10
	CPC  R0,R11
	BRLT _0x6D
_0x6C:
	RJMP _0x6B
_0x6D:
; 0000 017A        {
; 0000 017B         compar_pass() ;
	CALL _compar_pass
; 0000 017C        }
; 0000 017D      if(!T0) clock();
_0x6B:
	CALL SUBOPT_0x6
	BRNE _0x6E
	CALL _clock
; 0000 017E     }
_0x6E:
	RJMP _0x64
; 0000 017F  }
;/**************************************************************************************************/
; void key(void)
; 0000 0182  {
_key:
; 0000 0183    while (T0)
_0x6F:
	CALL SUBOPT_0x6
	BREQ _0x71
; 0000 0184     {
; 0000 0185      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 0186      delay_ms(50);
; 0000 0187      if(key_pressed>9) break;
	CALL SUBOPT_0x30
	BRLT _0x71
; 0000 0188      if(key_pressed>=0 && key_pressed<=9 && x<10)
	CLR  R0
	CP   R4,R0
	CPC  R5,R0
	BRLT _0x74
	CALL SUBOPT_0x30
	BRLT _0x74
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R10,R30
	CPC  R11,R31
	BRLT _0x75
_0x74:
	RJMP _0x73
_0x75:
; 0000 0189        {
; 0000 018A         itoa(key_pressed,str_key_pressed);
	ST   -Y,R5
	ST   -Y,R4
	LDI  R30,LOW(_str_key_pressed)
	LDI  R31,HIGH(_str_key_pressed)
	CALL SUBOPT_0x31
; 0000 018B         strcat(pass_in,str_key_pressed);
	CALL SUBOPT_0x19
	LDI  R30,LOW(_str_key_pressed)
	LDI  R31,HIGH(_str_key_pressed)
	CALL SUBOPT_0x32
; 0000 018C         x++;
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
; 0000 018D        }
; 0000 018E      for(i=0;i<x;i++)
_0x73:
	CALL SUBOPT_0xE
_0x77:
	CALL SUBOPT_0xF
	CP   R26,R10
	CPC  R27,R11
	BRGE _0x78
; 0000 018F        {
; 0000 0190         lcd_gotoxy(i+2,1);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x33
; 0000 0191         lcd_putsf("*");
; 0000 0192        }
	CALL SUBOPT_0x11
	RJMP _0x77
_0x78:
; 0000 0193     }
	RJMP _0x6F
_0x71:
; 0000 0194  }
	RET
;/**************************************************************************************************/
;char refresh_key(char st,char x,char y)
; 0000 0197  {
_refresh_key:
; 0000 0198    char KEY=16;
; 0000 0199    while(KEY==16 && T0)
	ST   -Y,R17
;	st -> Y+3
;	x -> Y+2
;	y -> Y+1
;	KEY -> R17
	LDI  R17,16
_0x79:
	CPI  R17,16
	BRNE _0x7C
	CALL SUBOPT_0x6
	BRNE _0x7D
_0x7C:
	RJMP _0x7B
_0x7D:
; 0000 019A    {
; 0000 019B     if(conect_tel) tel_conect();
	SBIC 0x1B,3
	RCALL _tel_conect
; 0000 019C     if (st)
	LDD  R30,Y+3
	CPI  R30,0
	BREQ _0x7F
; 0000 019D       {
; 0000 019E        lcd_gotoxy(x,y);
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 019F        _lcd_ready();
	CALL __lcd_ready
; 0000 01A0        _lcd_write_data(0x0F);
	LDI  R30,LOW(15)
	ST   -Y,R30
	CALL __lcd_write_data
; 0000 01A1       }
; 0000 01A2 
; 0000 01A3     PORTB=0xFE;
_0x7F:
	LDI  R30,LOW(254)
	CALL SUBOPT_0x34
; 0000 01A4     delay_ms(20);
; 0000 01A5     if(!PINB.4) KEY=1;
	SBIS 0x16,4
	LDI  R17,LOW(1)
; 0000 01A6     if(!PINB.5) KEY=2;
	SBIS 0x16,5
	LDI  R17,LOW(2)
; 0000 01A7     if(!PINB.6) KEY=3;
	SBIS 0x16,6
	LDI  R17,LOW(3)
; 0000 01A8     if(!PINB.7) KEY=12;
	SBIS 0x16,7
	LDI  R17,LOW(12)
; 0000 01A9 
; 0000 01AA     PORTB=0xFD;
	LDI  R30,LOW(253)
	CALL SUBOPT_0x34
; 0000 01AB     delay_ms(20);
; 0000 01AC     if(!PINB.4) KEY=4;
	SBIS 0x16,4
	LDI  R17,LOW(4)
; 0000 01AD     if(!PINB.5) KEY=5;
	SBIS 0x16,5
	LDI  R17,LOW(5)
; 0000 01AE     if(!PINB.6) KEY=6;
	SBIS 0x16,6
	LDI  R17,LOW(6)
; 0000 01AF     if(!PINB.7) KEY=13;
	SBIS 0x16,7
	LDI  R17,LOW(13)
; 0000 01B0 
; 0000 01B1     PORTB=0xFB;
	LDI  R30,LOW(251)
	CALL SUBOPT_0x34
; 0000 01B2     delay_ms(20);
; 0000 01B3     if(!PINB.4) KEY=7;
	SBIS 0x16,4
	LDI  R17,LOW(7)
; 0000 01B4     if(!PINB.5) KEY=8;
	SBIS 0x16,5
	LDI  R17,LOW(8)
; 0000 01B5     if(!PINB.6) KEY=9;
	SBIS 0x16,6
	LDI  R17,LOW(9)
; 0000 01B6     if(!PINB.7) KEY=11;
	SBIS 0x16,7
	LDI  R17,LOW(11)
; 0000 01B7 
; 0000 01B8     PORTB=0xF7;
	LDI  R30,LOW(247)
	CALL SUBOPT_0x34
; 0000 01B9     delay_ms(20);
; 0000 01BA     if(!PINB.4) KEY=14;
	SBIS 0x16,4
	LDI  R17,LOW(14)
; 0000 01BB     if(!PINB.5) KEY=0;
	SBIS 0x16,5
	LDI  R17,LOW(0)
; 0000 01BC     if(!PINB.6) KEY=15;
	SBIS 0x16,6
	LDI  R17,LOW(15)
; 0000 01BD     if(!PINB.7) KEY=10;
	SBIS 0x16,7
	LDI  R17,LOW(10)
; 0000 01BE    }
	RJMP _0x79
_0x7B:
; 0000 01BF    if(conect_tel) tel_conect();
	SBIC 0x1B,3
	RCALL _tel_conect
; 0000 01C0    sound(3000,120);
	CALL SUBOPT_0x35
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	CALL SUBOPT_0x36
; 0000 01C1    delay_ms(200);
	CALL SUBOPT_0x18
; 0000 01C2    return KEY;
	MOV  R30,R17
	LDD  R17,Y+0
	ADIW R28,4
	RET
; 0000 01C3  }
;/**************************************************************************************************/
;void relay(int r)
; 0000 01C6  {
_relay:
; 0000 01C7   if (r==1)
;	r -> Y+0
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,1
	BREQ PC+3
	JMP _0x91
; 0000 01C8     {
; 0000 01C9      if(relay_user[user][0])
	CALL SUBOPT_0x37
	SUBI R30,LOW(-_relay_user)
	SBCI R31,HIGH(-_relay_user)
	CALL SUBOPT_0x38
	BREQ _0x92
; 0000 01CA        {
; 0000 01CB         if (relay_mod[0]>0)
	CALL SUBOPT_0x1
	MOVW R26,R30
	CALL __CPW02
	BRGE _0x93
; 0000 01CC           {
; 0000 01CD            relay1=1;
	SBI  0x12,1
; 0000 01CE            sound(2000,1000);
	CALL SUBOPT_0x39
	RJMP _0x36B
; 0000 01CF           }
; 0000 01D0         else
_0x93:
; 0000 01D1           {
; 0000 01D2            relay1=!relay1;
	SBIS 0x12,1
	RJMP _0x97
	CBI  0x12,1
	RJMP _0x98
_0x97:
	SBI  0x12,1
_0x98:
; 0000 01D3            if (relay1)
	SBIS 0x12,1
	RJMP _0x99
; 0000 01D4              {
; 0000 01D5               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 01D6               delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 01D7               sound(2000,3000);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RJMP _0x36B
; 0000 01D8              }
; 0000 01D9            else
_0x99:
; 0000 01DA              {
; 0000 01DB               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 01DC               delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 01DD               sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 01DE               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 01DF               sound(2000,500);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
_0x36B:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _sound
; 0000 01E0              }
; 0000 01E1           }
; 0000 01E2        }
; 0000 01E3       else
	RJMP _0x9B
_0x92:
; 0000 01E4        {
; 0000 01E5         lcd_clear();
	CALL SUBOPT_0x3E
; 0000 01E6         lcd_gotoxy(1,0);
; 0000 01E7         lcd_putsf("User is Limit");
	CALL SUBOPT_0x3F
; 0000 01E8         sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 01E9         delay_ms(10);
	CALL SUBOPT_0x10
; 0000 01EA         sound(1500,500);
	CALL SUBOPT_0x40
; 0000 01EB         delay_ms(10);
	CALL SUBOPT_0x10
; 0000 01EC         sound(1000,700);
	CALL SUBOPT_0x41
; 0000 01ED         delay_ms(1000);
	CALL SUBOPT_0x42
; 0000 01EE        }
_0x9B:
; 0000 01EF     }
; 0000 01F0   if (r==2)
_0x91:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,2
	BREQ PC+3
	JMP _0x9C
; 0000 01F1     {
; 0000 01F2       if(relay_user[user][1])
	CALL SUBOPT_0x37
	__ADDW1MN _relay_user,1
	CALL SUBOPT_0x38
	BRNE PC+3
	JMP _0x9D
; 0000 01F3        {
; 0000 01F4          if (relay_mod[1]>0)
	CALL SUBOPT_0x3
	MOVW R26,R30
	CALL __CPW02
	BRGE _0x9E
; 0000 01F5           {
; 0000 01F6            relay2=1;
	SBI  0x12,4
; 0000 01F7            sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 01F8            delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 01F9            sound(2000,1000);
	CALL SUBOPT_0x39
	RJMP _0x36C
; 0000 01FA           }
; 0000 01FB         else
_0x9E:
; 0000 01FC           {
; 0000 01FD            relay2=!relay2;
	SBIS 0x12,4
	RJMP _0xA2
	CBI  0x12,4
	RJMP _0xA3
_0xA2:
	SBI  0x12,4
_0xA3:
; 0000 01FE            if (relay2)
	SBIS 0x12,4
	RJMP _0xA4
; 0000 01FF              {
; 0000 0200               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0201               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 0202               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0203               delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 0204               sound(2000,3000);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RJMP _0x36C
; 0000 0205              }
; 0000 0206            else
_0xA4:
; 0000 0207              {
; 0000 0208               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0209               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 020A               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 020B               delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 020C               sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 020D               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 020E               sound(2000,500);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
_0x36C:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _sound
; 0000 020F              }
; 0000 0210           }
; 0000 0211        }
; 0000 0212       else
	RJMP _0xA6
_0x9D:
; 0000 0213        {
; 0000 0214         lcd_clear();
	CALL SUBOPT_0x3E
; 0000 0215         lcd_gotoxy(1,0);
; 0000 0216         lcd_putsf("User is Limit");
	CALL SUBOPT_0x3F
; 0000 0217         sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 0218         delay_ms(10);
	CALL SUBOPT_0x10
; 0000 0219         sound(1500,500);
	CALL SUBOPT_0x40
; 0000 021A         delay_ms(10);
	CALL SUBOPT_0x10
; 0000 021B         sound(1000,700);
	CALL SUBOPT_0x41
; 0000 021C         delay_ms(1000);
	CALL SUBOPT_0x42
; 0000 021D        }
_0xA6:
; 0000 021E     }
; 0000 021F   if (r==3)
_0x9C:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,3
	BREQ PC+3
	JMP _0xA7
; 0000 0220     {
; 0000 0221       if(relay_user[user][2])
	CALL SUBOPT_0x37
	__ADDW1MN _relay_user,2
	CALL SUBOPT_0x38
	BRNE PC+3
	JMP _0xA8
; 0000 0222        {
; 0000 0223         if (relay_mod[2]>0)
	CALL SUBOPT_0x4
	MOVW R26,R30
	CALL __CPW02
	BRGE _0xA9
; 0000 0224           {
; 0000 0225            relay3=1;
	SBI  0x12,5
; 0000 0226            sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0227            delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 0228            sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0229            delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 022A            sound(2000,1000);
	CALL SUBOPT_0x39
	RJMP _0x36D
; 0000 022B           }
; 0000 022C         else
_0xA9:
; 0000 022D           {
; 0000 022E            relay3=!relay3;
	SBIS 0x12,5
	RJMP _0xAD
	CBI  0x12,5
	RJMP _0xAE
_0xAD:
	SBI  0x12,5
_0xAE:
; 0000 022F            if (relay3)
	SBIS 0x12,5
	RJMP _0xAF
; 0000 0230              {
; 0000 0231               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0232               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 0233               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0234               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 0235               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0236               delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 0237               sound(2000,3000);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RJMP _0x36D
; 0000 0238              }
; 0000 0239            else
_0xAF:
; 0000 023A              {
; 0000 023B               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 023C               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 023D               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 023E               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 023F               sound(2000,1000);
	CALL SUBOPT_0x39
	CALL SUBOPT_0x36
; 0000 0240               delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 0241               sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 0242               delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 0243               sound(2000,500);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
_0x36D:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _sound
; 0000 0244              }
; 0000 0245           }
; 0000 0246        }
; 0000 0247       else
	RJMP _0xB1
_0xA8:
; 0000 0248        {
; 0000 0249         lcd_clear();
	CALL SUBOPT_0x3E
; 0000 024A         lcd_gotoxy(1,0);
; 0000 024B         lcd_putsf("User is Limit");
	CALL SUBOPT_0x3F
; 0000 024C         sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 024D         delay_ms(10);
	CALL SUBOPT_0x10
; 0000 024E         sound(1500,500);
	CALL SUBOPT_0x40
; 0000 024F         delay_ms(10);
	CALL SUBOPT_0x10
; 0000 0250         sound(1000,700);
	CALL SUBOPT_0x41
; 0000 0251         delay_ms(1000);
	CALL SUBOPT_0x42
; 0000 0252        }
_0xB1:
; 0000 0253     }
; 0000 0254  }
_0xA7:
	RJMP _0x210000B
;/**************************************************************************************************/
;void tel_conect(void)
; 0000 0257  {
_tel_conect:
; 0000 0258   #asm("sei")
	sei
; 0000 0259   lcd_clear() ;
	CALL _lcd_clear
; 0000 025A   lcd_putsf("Conect Telephon");
	__POINTW1FN _0x0,95
	CALL SUBOPT_0x13
; 0000 025B   lcd_gotoxy(1,1);
	CALL SUBOPT_0x43
; 0000 025C   lcd_putsf("please waite");
	__POINTW1FN _0x0,111
	CALL SUBOPT_0x13
; 0000 025D   delay_ms(1000);
	CALL SUBOPT_0x42
; 0000 025E   sound(1100,1000);
	LDI  R30,LOW(1100)
	LDI  R31,HIGH(1100)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL SUBOPT_0x36
; 0000 025F   GICR=0x00;
	LDI  R30,LOW(0)
	OUT  0x3B,R30
; 0000 0260   tel_pas_in[0]='\0';
	STS  _tel_pas_in,R30
; 0000 0261   while(T0)
_0xB2:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0xB4
; 0000 0262     {
; 0000 0263      if (PINC.4)
	SBIS 0x13,4
	RJMP _0xB5
; 0000 0264        {
; 0000 0265         TCNT1H=0x0B;
	CALL SUBOPT_0x0
; 0000 0266         TCNT1L=0xDC;
; 0000 0267         T0=counter;
	CALL SUBOPT_0x9
; 0000 0268         tel_key=data_in;
	IN   R30,0x13
	ANDI R30,LOW(0xF)
	STS  _tel_key,R30
; 0000 0269         while(PINC.4) delay_ms(10);
_0xB6:
	SBIS 0x13,4
	RJMP _0xB8
	CALL SUBOPT_0x10
	RJMP _0xB6
_0xB8:
; 0000 026A if(tel_pas_ok)
	LDS  R30,_tel_pas_ok
	CPI  R30,0
	BREQ _0xB9
; 0000 026B           {
; 0000 026C            if (tel_key==11)
	LDS  R26,_tel_key
	CPI  R26,LOW(0xB)
	BRNE _0xBA
; 0000 026D              {
; 0000 026E               tel_key=14;
	LDI  R30,LOW(14)
	STS  _tel_key,R30
; 0000 026F               tel_pas_ok=0;
	LDI  R30,LOW(0)
	STS  _tel_pas_ok,R30
; 0000 0270               T0=0;
	CALL SUBOPT_0x22
; 0000 0271              }
; 0000 0272            user=4;
_0xBA:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL SUBOPT_0x44
; 0000 0273            if (tel_key==1) relay(1);
	LDS  R26,_tel_key
	CPI  R26,LOW(0x1)
	BRNE _0xBB
	CALL SUBOPT_0x45
; 0000 0274            if (tel_key==2) relay(2);
_0xBB:
	LDS  R26,_tel_key
	CPI  R26,LOW(0x2)
	BRNE _0xBC
	CALL SUBOPT_0x46
; 0000 0275            if (tel_key==3) relay(3);
_0xBC:
	LDS  R26,_tel_key
	CPI  R26,LOW(0x3)
	BRNE _0xBD
	CALL SUBOPT_0x47
; 0000 0276           }
_0xBD:
; 0000 0277         else
	RJMP _0xBE
_0xB9:
; 0000 0278           {
; 0000 0279            if (tel_key<=10)
	LDS  R26,_tel_key
	CPI  R26,LOW(0xB)
	BRSH _0xBF
; 0000 027A              {
; 0000 027B               if (tel_key==10) tel_key=0;
	CPI  R26,LOW(0xA)
	BRNE _0xC0
	LDI  R30,LOW(0)
	STS  _tel_key,R30
; 0000 027C               itoa(tel_key,tel_dtmf);
_0xC0:
	LDS  R30,_tel_key
	CALL SUBOPT_0x48
	LDI  R30,LOW(_tel_dtmf)
	LDI  R31,HIGH(_tel_dtmf)
	CALL SUBOPT_0x31
; 0000 027D               strcat(tel_pas_in,tel_dtmf);
	LDI  R30,LOW(_tel_pas_in)
	LDI  R31,HIGH(_tel_pas_in)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_tel_dtmf)
	LDI  R31,HIGH(_tel_dtmf)
	CALL SUBOPT_0x32
; 0000 027E              }
; 0000 027F            if (tel_key==11) T0=0;
_0xBF:
	LDS  R26,_tel_key
	CPI  R26,LOW(0xB)
	BRNE _0xC1
	CALL SUBOPT_0x22
; 0000 0280            if (tel_key==12)
_0xC1:
	LDS  R26,_tel_key
	CPI  R26,LOW(0xC)
	BREQ PC+3
	JMP _0xC2
; 0000 0281              {
; 0000 0282               for(i=0;i<10;i++)
	CALL SUBOPT_0xE
_0xC4:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0xC5
; 0000 0283                 {
; 0000 0284                  tel_pas_load[i]=phone_pass[i];
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_tel_pas_load)
	SBCI R31,HIGH(-_tel_pas_load)
	MOVW R0,R30
	CALL SUBOPT_0xF
	SUBI R26,LOW(-_phone_pass)
	SBCI R27,HIGH(-_phone_pass)
	CALL SUBOPT_0x49
; 0000 0285                  delay_ms(10);
	CALL SUBOPT_0x10
; 0000 0286                 }
	CALL SUBOPT_0x11
	RJMP _0xC4
_0xC5:
; 0000 0287               result_tel=strcmp(tel_pas_in,tel_pas_load);
	LDI  R30,LOW(_tel_pas_in)
	LDI  R31,HIGH(_tel_pas_in)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_tel_pas_load)
	LDI  R31,HIGH(_tel_pas_load)
	CALL SUBOPT_0x4A
	STS  _result_tel,R30
; 0000 0288               if(result_tel)
	CPI  R30,0
	BREQ _0xC6
; 0000 0289                 {
; 0000 028A                  sound(2000,400);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	CALL SUBOPT_0x36
; 0000 028B                  delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 028C                  sound(2000,400);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	CALL SUBOPT_0x36
; 0000 028D                  delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 028E                  sound(2000,400);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RJMP _0x36E
; 0000 028F                  T0=0;
; 0000 0290                 }
; 0000 0291               else
_0xC6:
; 0000 0292                 {
; 0000 0293                  if (user_c_t_ok(4))
	LDI  R30,LOW(4)
	CALL SUBOPT_0xC
	BREQ _0xC8
; 0000 0294                    {
; 0000 0295                     sound(2000,1500);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	CALL SUBOPT_0x36
; 0000 0296                     tel_pas_ok=1;
	LDI  R30,LOW(1)
	STS  _tel_pas_ok,R30
; 0000 0297                     if(relay_mod[3]) light=1;
	CALL SUBOPT_0x5
	SBIW R30,0
	BREQ _0xC9
	SBI  0x12,0
; 0000 0298                    }
_0xC9:
; 0000 0299                   else
	RJMP _0xCC
_0xC8:
; 0000 029A                    {
; 0000 029B                     sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 029C                     delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 029D                     sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 029E                     delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 029F                     sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 02A0                     delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 02A1                     sound(2000,500);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
_0x36E:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _sound
; 0000 02A2                     T0=0;
	CALL SUBOPT_0x22
; 0000 02A3                    }
_0xCC:
; 0000 02A4                 }
; 0000 02A5              }
; 0000 02A6           }
_0xC2:
_0xBE:
; 0000 02A7        }
; 0000 02A8     }
_0xB5:
	RJMP _0xB2
_0xB4:
; 0000 02A9   delay_ms(800);
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	CALL SUBOPT_0xB
; 0000 02AA   sound(2000,1500);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	CALL SUBOPT_0x36
; 0000 02AB   GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 02AC   conect_tel=0;
	CBI  0x1B,3
; 0000 02AD  }
	RET
;/**************************************************************************************************/
;void sound(unsigned int hz,int ms) //hz=frequence(hz) , ms=time(ms)
; 0000 02B0  {
_sound:
; 0000 02B1   unsigned int t;
; 0000 02B2   hz=50000/hz;
	ST   -Y,R17
	ST   -Y,R16
;	hz -> Y+4
;	ms -> Y+2
;	t -> R16,R17
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LDI  R26,LOW(50000)
	LDI  R27,HIGH(50000)
	CALL __DIVW21U
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 02B3   hz*=10;
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LDI  R30,LOW(10)
	CALL __MULB1W2U
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 02B4   for(;ms>0;ms--)
_0xD0:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __CPW02
	BRGE _0xD1
; 0000 02B5     {
; 0000 02B6      alarm=!alarm;
	SBIS 0x12,6
	RJMP _0xD2
	CBI  0x12,6
	RJMP _0xD3
_0xD2:
	SBI  0x12,6
_0xD3:
; 0000 02B7      for(t=hz;t>0;t--) delay_us(1);
	__GETWRS 16,17,4
_0xD5:
	CLR  R0
	CP   R0,R16
	CPC  R0,R17
	BRSH _0xD6
	__DELAY_USB 5
	__SUBWRN 16,17,1
	RJMP _0xD5
_0xD6:
; 0000 02B8 }
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0xD0
_0xD1:
; 0000 02B9   alarm=0;
	CBI  0x12,6
; 0000 02BA  }
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,6
	RET
;/**************************************************************************************************/
;void clear(void)
; 0000 02BD  {
_clear:
; 0000 02BE   char lengh_pass_in;
; 0000 02BF   lengh_pass_in=strlen(pass_in);
	ST   -Y,R17
;	lengh_pass_in -> R17
	CALL SUBOPT_0x19
	CALL _strlen
	MOV  R17,R30
; 0000 02C0   pass_in[lengh_pass_in-1]=0;
	CALL SUBOPT_0x25
	SBIW R30,1
	SUBI R30,LOW(-_pass_in)
	SBCI R31,HIGH(-_pass_in)
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0000 02C1   lcd_clear();
	CALL _lcd_clear
; 0000 02C2   if(x>0) x--;
	CLR  R0
	CP   R0,R10
	CPC  R0,R11
	BRGE _0xD9
	MOVW R30,R10
	SBIW R30,1
	MOVW R10,R30
; 0000 02C3   for(i=0;i<x;i++)
_0xD9:
	CALL SUBOPT_0xE
_0xDB:
	CALL SUBOPT_0xF
	CP   R26,R10
	CPC  R27,R11
	BRGE _0xDC
; 0000 02C4     {
; 0000 02C5      lcd_gotoxy(i+2,1);
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x33
; 0000 02C6      lcd_putsf("*");
; 0000 02C7     }
	CALL SUBOPT_0x11
	RJMP _0xDB
_0xDC:
; 0000 02C8  }
	LD   R17,Y+
	RET
;/**************************************************************************************************/
;void change_pas()
; 0000 02CB  {
_change_pas:
; 0000 02CC   char first_new_pass[11];
; 0000 02CD   lcd_clear();
	SBIW R28,11
;	first_new_pass -> Y+0
	CALL _lcd_clear
; 0000 02CE   pass_in_clean();
	CALL _pass_in_clean
; 0000 02CF   lcd_gotoxy(2,0);
	CALL SUBOPT_0x4B
; 0000 02D0   lcd_putsf("new Pass:");
	__POINTW1FN _0x0,124
	CALL SUBOPT_0x13
; 0000 02D1   delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 02D2   key();
	CALL SUBOPT_0x2C
; 0000 02D3   if(key_pressed==14) pass_in_clean();
	BRNE _0xDD
	CALL _pass_in_clean
; 0000 02D4   if(key_pressed==12) clear();
_0xDD:
	CALL SUBOPT_0x2D
	BRNE _0xDE
	RCALL _clear
; 0000 02D5   if(key_pressed==15)
_0xDE:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0xDF
; 0000 02D6     {
; 0000 02D7      x=0;
	CLR  R10
	CLR  R11
; 0000 02D8      strcat(pass_in,'\0');
	CALL SUBOPT_0x19
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL SUBOPT_0x32
; 0000 02D9      strcpy(first_new_pass,pass_in);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x19
	CALL _strcpy
; 0000 02DA      pass_in_clean();
	CALL _pass_in_clean
; 0000 02DB      lcd_clear();
	CALL SUBOPT_0x4C
; 0000 02DC      lcd_gotoxy(0,0);
; 0000 02DD      lcd_putsf("confirm new Pass");
	__POINTW1FN _0x0,134
	CALL SUBOPT_0x13
; 0000 02DE      delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 02DF      key();
	CALL SUBOPT_0x2C
; 0000 02E0      if(key_pressed==14)
	BRNE _0xE0
; 0000 02E1         pass_in_clean();
	CALL _pass_in_clean
; 0000 02E2      if(key_pressed==12) clear();
_0xE0:
	CALL SUBOPT_0x2D
	BRNE _0xE1
	RCALL _clear
; 0000 02E3      if(key_pressed==15)
_0xE1:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0xE2
; 0000 02E4        {
; 0000 02E5         if(!strcmp(pass_in,first_new_pass))
	CALL SUBOPT_0x19
	MOVW R30,R28
	ADIW R30,2
	CALL SUBOPT_0x4A
	CPI  R30,0
	BREQ PC+3
	JMP _0xE3
; 0000 02E6           {
; 0000 02E7            lcd_clear();
	CALL _lcd_clear
; 0000 02E8            lcd_putsf("Password Changed");
	__POINTW1FN _0x0,151
	CALL SUBOPT_0x13
; 0000 02E9            sound(2000,2000);
	CALL SUBOPT_0x3B
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	CALL SUBOPT_0x36
; 0000 02EA            delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 02EB            if (user==0)
	LDS  R30,_user
	LDS  R31,_user+1
	SBIW R30,0
	BRNE _0xE4
; 0000 02EC              {
; 0000 02ED               for(i=0;i<10;i++)
	CALL SUBOPT_0xE
_0xE6:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0xE7
; 0000 02EE                 {
; 0000 02EF                  main_pass[i]=first_new_pass[i];
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_main_pass)
	SBCI R31,HIGH(-_main_pass)
	CALL SUBOPT_0x4D
; 0000 02F0                  delay_ms(4);
; 0000 02F1                 }
	CALL SUBOPT_0x11
	RJMP _0xE6
_0xE7:
; 0000 02F2              }
; 0000 02F3            if (user==1)
_0xE4:
	CALL SUBOPT_0x4E
	SBIW R26,1
	BRNE _0xE8
; 0000 02F4              {
; 0000 02F5               for(i=0;i<10;i++)
	CALL SUBOPT_0xE
_0xEA:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0xEB
; 0000 02F6                 {
; 0000 02F7                  user_1_pass[i]=first_new_pass[i];
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_user_1_pass)
	SBCI R31,HIGH(-_user_1_pass)
	CALL SUBOPT_0x4D
; 0000 02F8                  delay_ms(4);
; 0000 02F9                 }
	CALL SUBOPT_0x11
	RJMP _0xEA
_0xEB:
; 0000 02FA              }
; 0000 02FB            if (user==2)
_0xE8:
	CALL SUBOPT_0x4E
	SBIW R26,2
	BRNE _0xEC
; 0000 02FC              {
; 0000 02FD               for(i=0;i<10;i++)
	CALL SUBOPT_0xE
_0xEE:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0xEF
; 0000 02FE                 {
; 0000 02FF                  user_2_pass[i]=first_new_pass[i];
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_user_2_pass)
	SBCI R31,HIGH(-_user_2_pass)
	CALL SUBOPT_0x4D
; 0000 0300                  delay_ms(4);
; 0000 0301                 }
	CALL SUBOPT_0x11
	RJMP _0xEE
_0xEF:
; 0000 0302              }
; 0000 0303            if (user==3)
_0xEC:
	CALL SUBOPT_0x4E
	SBIW R26,3
	BRNE _0xF0
; 0000 0304              {
; 0000 0305               for(i=0;i<10;i++)
	CALL SUBOPT_0xE
_0xF2:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0xF3
; 0000 0306                 {
; 0000 0307                  user_3_pass[i]=first_new_pass[i];
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_user_3_pass)
	SBCI R31,HIGH(-_user_3_pass)
	CALL SUBOPT_0x4D
; 0000 0308                  delay_ms(4);
; 0000 0309                 }
	CALL SUBOPT_0x11
	RJMP _0xF2
_0xF3:
; 0000 030A              }
; 0000 030B            if (user==4)
_0xF0:
	CALL SUBOPT_0x4E
	SBIW R26,4
	BRNE _0xF4
; 0000 030C              {
; 0000 030D               for(i=0;i<10;i++)
	CALL SUBOPT_0xE
_0xF6:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0xF7
; 0000 030E                 {
; 0000 030F                  phone_pass[i]=first_new_pass[i];
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_phone_pass)
	SBCI R31,HIGH(-_phone_pass)
	CALL SUBOPT_0x4D
; 0000 0310                  delay_ms(4);
; 0000 0311                 }
	CALL SUBOPT_0x11
	RJMP _0xF6
_0xF7:
; 0000 0312              }
; 0000 0313            x=0;
_0xF4:
	CLR  R10
	CLR  R11
; 0000 0314           }
; 0000 0315         else
	RJMP _0xF8
_0xE3:
; 0000 0316           {
; 0000 0317            lcd_clear();
	CALL _lcd_clear
; 0000 0318            lcd_gotoxy(5,0);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL SUBOPT_0x1F
; 0000 0319            lcd_putsf("error");
	__POINTW1FN _0x0,168
	CALL SUBOPT_0x13
; 0000 031A            sound(3000,800);
	CALL SUBOPT_0x35
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	CALL SUBOPT_0x36
; 0000 031B            delay_ms(500);
	CALL SUBOPT_0x4F
; 0000 031C            sound(3000,1200);
	CALL SUBOPT_0x35
	LDI  R30,LOW(1200)
	LDI  R31,HIGH(1200)
	CALL SUBOPT_0x36
; 0000 031D           }
_0xF8:
; 0000 031E        }
; 0000 031F     }
_0xE2:
; 0000 0320  }
_0xDF:
	ADIW R28,11
	RET
;/**************************************************************************************************/
;void Security_meno(void)
; 0000 0323  {
_Security_meno:
	PUSH R15
; 0000 0324   bit sm=0;
; 0000 0325   while(T0)
;	sm -> R15.0
	CLR  R15
_0xF9:
	CALL SUBOPT_0x6
	BREQ _0xFB
; 0000 0326     {
; 0000 0327      lcd_clear();
	CALL SUBOPT_0x50
; 0000 0328      lcd_gotoxy(2,0);
; 0000 0329      lcd_putsf("Set Password");
	__POINTW1FN _0x0,174
	CALL SUBOPT_0x13
; 0000 032A      lcd_gotoxy(2,1);
	CALL SUBOPT_0x51
; 0000 032B      lcd_putsf("User Control");
	__POINTW1FN _0x0,187
	CALL SUBOPT_0x13
; 0000 032C      lcd_gotoxy(0,sm);
	CALL SUBOPT_0x52
; 0000 032D      lcd_putchar(2);
; 0000 032E      delay_ms(20);
	CALL SUBOPT_0x53
; 0000 032F      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 0330      delay_ms(50);
; 0000 0331      if(key_pressed==14)  break;
	CALL SUBOPT_0x54
	BREQ _0xFB
; 0000 0332      if(key_pressed==10 || key_pressed==11 )sm=!sm;
	CALL SUBOPT_0x55
	BREQ _0xFE
	CALL SUBOPT_0x56
	BRNE _0xFD
_0xFE:
	LDI  R30,LOW(1)
	EOR  R15,R30
; 0000 0333      if(key_pressed==15)
_0xFD:
	CALL SUBOPT_0x2E
	BRNE _0x100
; 0000 0334        {
; 0000 0335         if (sm) User_Control();
	SBRS R15,0
	RJMP _0x101
	RCALL _User_Control
; 0000 0336         else    Set_Password();
	RJMP _0x102
_0x101:
	RCALL _Set_Password
; 0000 0337        }
_0x102:
; 0000 0338     }
_0x100:
	RJMP _0xF9
_0xFB:
; 0000 0339  }
	POP  R15
	RET
;/**************************************************************************************************/
;void User_Control_Time (void)
; 0000 033C  {
_User_Control_Time:
; 0000 033D   char uct_x=1,uct_c[1];
; 0000 033E   sprintf(buffer," %02u:%02u    %02u:%02u",user_en[user][1],user_en[user][2],user_en[user][3],user_en[user][4]);
	SBIW R28,1
	ST   -Y,R17
;	uct_x -> R17
;	uct_c -> Y+1
	LDI  R17,1
	CALL SUBOPT_0x1D
	__POINTW1FN _0x0,200
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x57
	__ADDW1MN _user_en,1
	CALL SUBOPT_0x58
	__ADDW1MN _user_en,2
	CALL SUBOPT_0x58
	__ADDW1MN _user_en,3
	CALL SUBOPT_0x58
	__ADDW1MN _user_en,4
	MOVW R26,R30
	CALL __EEPROMRDB
	CALL SUBOPT_0x59
	LDI  R24,16
	CALL _sprintf
	ADIW R28,20
; 0000 033F   while(T0)
_0x103:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x105
; 0000 0340     {
; 0000 0341      lcd_clear();
	CALL SUBOPT_0x4C
; 0000 0342      lcd_gotoxy(0,0);
; 0000 0343      lcd_putsf("On Time  OffTime");
	__POINTW1FN _0x0,224
	CALL SUBOPT_0x13
; 0000 0344      delay_ms(10);
	CALL SUBOPT_0x10
; 0000 0345      lcd_gotoxy(0,1);
	CALL SUBOPT_0xD
	CALL _lcd_gotoxy
; 0000 0346      lcd_puts(buffer);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x5A
; 0000 0347      delay_ms(30);
; 0000 0348      key_pressed=refresh_key(1,uct_x,1);
	CALL SUBOPT_0x5B
; 0000 0349      delay_ms(50);
; 0000 034A      if (key_pressed==14)  break;
	CALL SUBOPT_0x54
	BRNE _0x106
	RJMP _0x105
; 0000 034B      if(0<=key_pressed && key_pressed<=9)
_0x106:
	CLR  R0
	CP   R4,R0
	CPC  R5,R0
	BRLT _0x108
	CALL SUBOPT_0x30
	BRGE _0x109
_0x108:
	RJMP _0x107
_0x109:
; 0000 034C        {
; 0000 034D         itoa(key_pressed,uct_c);
	CALL SUBOPT_0x5C
; 0000 034E         buffer[uct_x]=uct_c[0];
	CALL SUBOPT_0x25
	SUBI R30,LOW(-_buffer)
	SBCI R31,HIGH(-_buffer)
	LDD  R26,Y+1
	STD  Z+0,R26
; 0000 034F         uct_x++;
	SUBI R17,-1
; 0000 0350         if (uct_x==3 || uct_x==12) uct_x++;
	CPI  R17,3
	BREQ _0x10B
	CPI  R17,12
	BRNE _0x10A
_0x10B:
	SUBI R17,-1
; 0000 0351         if (uct_x==6) uct_x=10;
_0x10A:
	CPI  R17,6
	BRNE _0x10D
	LDI  R17,LOW(10)
; 0000 0352         if (uct_x==15) uct_x=1;
_0x10D:
	CPI  R17,15
	BRNE _0x10E
	LDI  R17,LOW(1)
; 0000 0353         if (buffer[1]>50) {buffer[1]=48; uct_x=1;}
_0x10E:
	__GETB2MN _buffer,1
	CPI  R26,LOW(0x33)
	BRLO _0x10F
	LDI  R30,LOW(48)
	__PUTB1MN _buffer,1
	LDI  R17,LOW(1)
; 0000 0354         if (buffer[1]==50 && buffer[2]>51) {buffer[1]=48;buffer[2]=48;uct_x=2;}
_0x10F:
	__GETB2MN _buffer,1
	CPI  R26,LOW(0x32)
	BRNE _0x111
	__GETB2MN _buffer,2
	CPI  R26,LOW(0x34)
	BRSH _0x112
_0x111:
	RJMP _0x110
_0x112:
	LDI  R30,LOW(48)
	__PUTB1MN _buffer,1
	__PUTB1MN _buffer,2
	LDI  R17,LOW(2)
; 0000 0355         if (buffer[4]>53) {buffer[4]=48;uct_x=4;}
_0x110:
	__GETB2MN _buffer,4
	CPI  R26,LOW(0x36)
	BRLO _0x113
	LDI  R30,LOW(48)
	__PUTB1MN _buffer,4
	LDI  R17,LOW(4)
; 0000 0356         if (buffer[10]>50) {buffer[10]=48; uct_x=10;}
_0x113:
	__GETB2MN _buffer,10
	CPI  R26,LOW(0x33)
	BRLO _0x114
	LDI  R30,LOW(48)
	__PUTB1MN _buffer,10
	LDI  R17,LOW(10)
; 0000 0357         if (buffer[10]==50 && buffer[11]>51) {buffer[10]=48;buffer[11]=48; uct_x=11;}
_0x114:
	__GETB2MN _buffer,10
	CPI  R26,LOW(0x32)
	BRNE _0x116
	__GETB2MN _buffer,11
	CPI  R26,LOW(0x34)
	BRSH _0x117
_0x116:
	RJMP _0x115
_0x117:
	LDI  R30,LOW(48)
	__PUTB1MN _buffer,10
	__PUTB1MN _buffer,11
	LDI  R17,LOW(11)
; 0000 0358         if (buffer[13]>53) {buffer[13]=48; uct_x=13;}
_0x115:
	__GETB2MN _buffer,13
	CPI  R26,LOW(0x36)
	BRLO _0x118
	LDI  R30,LOW(48)
	__PUTB1MN _buffer,13
	LDI  R17,LOW(13)
; 0000 0359        }
_0x118:
; 0000 035A      if (key_pressed==15)
_0x107:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0x119
; 0000 035B        {
; 0000 035C         for(i=1,j=1;i<14;i++)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL SUBOPT_0xA
	CALL SUBOPT_0x5D
_0x11B:
	CALL SUBOPT_0xF
	SBIW R26,14
	BRLT PC+3
	JMP _0x11C
; 0000 035D           {
; 0000 035E            user_en[user][0]=2;
	CALL SUBOPT_0x57
	SUBI R30,LOW(-_user_en)
	SBCI R31,HIGH(-_user_en)
	MOVW R26,R30
	LDI  R30,LOW(2)
	CALL __EEPROMWRB
; 0000 035F            if (i!=3 && i!=6 && i!=7 && i!=8 && i!=9 && i!=12 )
	CALL SUBOPT_0xF
	SBIW R26,3
	BREQ _0x11E
	CALL SUBOPT_0xF
	SBIW R26,6
	BREQ _0x11E
	CALL SUBOPT_0xF
	SBIW R26,7
	BREQ _0x11E
	CALL SUBOPT_0xF
	SBIW R26,8
	BREQ _0x11E
	CALL SUBOPT_0xF
	SBIW R26,9
	BREQ _0x11E
	CALL SUBOPT_0xF
	SBIW R26,12
	BRNE _0x11F
_0x11E:
	RJMP _0x11D
_0x11F:
; 0000 0360              {
; 0000 0361               uct_c[0]=((buffer[i]-48) * 10) + (buffer[i+1]-48);
	CALL SUBOPT_0x5E
	LD   R30,Z
	CALL SUBOPT_0x5F
	LDI  R26,LOW(10)
	MULS R30,R26
	MOVW R30,R0
	MOV  R26,R30
	CALL SUBOPT_0x1B
	__ADDW1MN _buffer,1
	LD   R30,Z
	CALL SUBOPT_0x5F
	ADD  R30,R26
	STD  Y+1,R30
; 0000 0362               user_en[user][j]=uct_c[0];
	CALL SUBOPT_0x57
	SUBI R30,LOW(-_user_en)
	SBCI R31,HIGH(-_user_en)
	CALL SUBOPT_0x60
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+1
	CALL SUBOPT_0x61
; 0000 0363               j++;
; 0000 0364               i++;
	CALL SUBOPT_0x11
; 0000 0365              }
; 0000 0366           }
_0x11D:
	CALL SUBOPT_0x11
	RJMP _0x11B
_0x11C:
; 0000 0367         key_pressed=16;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	MOVW R4,R30
; 0000 0368         break;
	RJMP _0x105
; 0000 0369        }
; 0000 036A      if (key_pressed==13)
_0x119:
	CALL SUBOPT_0x62
	BRNE _0x120
; 0000 036B        {
; 0000 036C         if (uct_x<14)
	CPI  R17,14
	BRSH _0x121
; 0000 036D           {
; 0000 036E            uct_x++;
	SUBI R17,-1
; 0000 036F            if (uct_x==3 || uct_x==12) uct_x++;
	CPI  R17,3
	BREQ _0x123
	CPI  R17,12
	BRNE _0x122
_0x123:
	SUBI R17,-1
; 0000 0370            if (uct_x==6) uct_x=10;
_0x122:
	CPI  R17,6
	BRNE _0x125
	LDI  R17,LOW(10)
; 0000 0371           }
_0x125:
; 0000 0372         else uct_x=1;
	RJMP _0x126
_0x121:
	LDI  R17,LOW(1)
; 0000 0373        }
_0x126:
; 0000 0374      if (key_pressed==12)
_0x120:
	CALL SUBOPT_0x2D
	BRNE _0x127
; 0000 0375        {
; 0000 0376         if (uct_x>1)
	CPI  R17,2
	BRLO _0x128
; 0000 0377           {
; 0000 0378            uct_x--;
	SUBI R17,1
; 0000 0379            if (uct_x==3 || uct_x==12) uct_x--;
	CPI  R17,3
	BREQ _0x12A
	CPI  R17,12
	BRNE _0x129
_0x12A:
	SUBI R17,1
; 0000 037A            if (uct_x==9) uct_x=5;
_0x129:
	CPI  R17,9
	BRNE _0x12C
	LDI  R17,LOW(5)
; 0000 037B           }
_0x12C:
; 0000 037C         else uct_x=14;
	RJMP _0x12D
_0x128:
	LDI  R17,LOW(14)
; 0000 037D        }
_0x12D:
; 0000 037E     }
_0x127:
	RJMP _0x103
_0x105:
; 0000 037F  }
	LDD  R17,Y+0
_0x210000B:
	ADIW R28,2
	RET
;/**************************************************************************************************/
;void User_Control_relay (void)
; 0000 0382  {
_User_Control_relay:
	PUSH R15
; 0000 0383   bit a=0;
; 0000 0384   sw1=0;
;	a -> R15.0
	CLR  R15
	LDI  R30,LOW(0)
	STS  _sw1,R30
; 0000 0385   while(T0)
_0x12E:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x130
; 0000 0386     {
; 0000 0387      lcd_clear();
	CALL SUBOPT_0x3E
; 0000 0388      lcd_gotoxy(1,0);
; 0000 0389      lcd_putsf("Relay1  Relay2");
	__POINTW1FN _0x0,241
	CALL SUBOPT_0x13
; 0000 038A      lcd_gotoxy(1,1);
	CALL SUBOPT_0x43
; 0000 038B      lcd_putsf("Relay3");
	__POINTW1FN _0x0,256
	CALL SUBOPT_0x13
; 0000 038C      if (relay_user[user][0]==1)  {lcd_gotoxy(7,0); lcd_putchar(3);}
	CALL SUBOPT_0x37
	SUBI R30,LOW(-_relay_user)
	SBCI R31,HIGH(-_relay_user)
	CALL SUBOPT_0x63
	BRNE _0x131
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x64
; 0000 038D      if (relay_user[user][1]==1)  {lcd_gotoxy(15,0); lcd_putchar(3);}
_0x131:
	CALL SUBOPT_0x37
	__ADDW1MN _relay_user,1
	CALL SUBOPT_0x63
	BRNE _0x132
	CALL SUBOPT_0x65
	CALL SUBOPT_0x64
; 0000 038E      if (relay_user[user][2]==1)  {lcd_gotoxy(7,1); lcd_putchar(3);}
_0x132:
	CALL SUBOPT_0x37
	__ADDW1MN _relay_user,2
	CALL SUBOPT_0x63
	BRNE _0x133
	LDI  R30,LOW(7)
	CALL SUBOPT_0x66
	CALL SUBOPT_0x64
; 0000 038F      lcd_gotoxy(sw1,a);
_0x133:
	LDS  R30,_sw1
	ST   -Y,R30
	LDI  R30,0
	SBRC R15,0
	LDI  R30,1
	CALL SUBOPT_0x67
; 0000 0390      lcd_putchar(2);
; 0000 0391      delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 0392      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 0393      delay_ms(50);
; 0000 0394      if(key_pressed==14) {sw1=1; break;}
	CALL SUBOPT_0x54
	BRNE _0x134
	LDI  R30,LOW(1)
	STS  _sw1,R30
	RJMP _0x130
; 0000 0395      if(key_pressed==10 || key_pressed==11) a=!a;
_0x134:
	CALL SUBOPT_0x55
	BREQ _0x136
	CALL SUBOPT_0x56
	BRNE _0x135
_0x136:
	LDI  R30,LOW(1)
	EOR  R15,R30
; 0000 0396      if(key_pressed==12 || key_pressed==13)
_0x135:
	CALL SUBOPT_0x2D
	BREQ _0x139
	CALL SUBOPT_0x62
	BRNE _0x138
_0x139:
; 0000 0397        {
; 0000 0398         if(sw1==0)sw1=8;
	LDS  R30,_sw1
	CPI  R30,0
	BRNE _0x13B
	LDI  R30,LOW(8)
	RJMP _0x36F
; 0000 0399           else sw1=0;
_0x13B:
	LDI  R30,LOW(0)
_0x36F:
	STS  _sw1,R30
; 0000 039A         a=0;
	CLT
	BLD  R15,0
; 0000 039B        }
; 0000 039C      if(key_pressed==15)
_0x138:
	CALL SUBOPT_0x2E
	BRNE _0x13D
; 0000 039D        {
; 0000 039E         if(a==0 && sw1==0)  relay_user[user][0]=!relay_user[user][0];
	LDI  R26,0
	SBRC R15,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x13F
	LDS  R26,_sw1
	CPI  R26,LOW(0x0)
	BREQ _0x140
_0x13F:
	RJMP _0x13E
_0x140:
	CALL SUBOPT_0x37
	SUBI R30,LOW(-_relay_user)
	SBCI R31,HIGH(-_relay_user)
	CALL SUBOPT_0x68
; 0000 039F         if(a==0 && sw1==8)  relay_user[user][1]=!relay_user[user][1];
_0x13E:
	LDI  R26,0
	SBRC R15,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x142
	LDS  R26,_sw1
	CPI  R26,LOW(0x8)
	BREQ _0x143
_0x142:
	RJMP _0x141
_0x143:
	CALL SUBOPT_0x37
	__ADDW1MN _relay_user,1
	CALL SUBOPT_0x68
; 0000 03A0         if(a==1 && sw1==0)  relay_user[user][2]=!relay_user[user][2];
_0x141:
	SBRS R15,0
	RJMP _0x145
	LDS  R26,_sw1
	CPI  R26,LOW(0x0)
	BREQ _0x146
_0x145:
	RJMP _0x144
_0x146:
	CALL SUBOPT_0x37
	__ADDW1MN _relay_user,2
	CALL SUBOPT_0x68
; 0000 03A1        }
_0x144:
; 0000 03A2     }
_0x13D:
	RJMP _0x12E
_0x130:
; 0000 03A3  }
	POP  R15
	RET
;/**************************************************************************************************/
;void User_Control_active (void)
; 0000 03A6  {
_User_Control_active:
; 0000 03A7   sw2=0;
	LDI  R30,LOW(0)
	STS  _sw2,R30
; 0000 03A8   if (user_en[user][0]==1)
	CALL SUBOPT_0x57
	CALL SUBOPT_0x69
	BRNE _0x147
; 0000 03A9     sw1=1;
	LDI  R30,LOW(1)
	RJMP _0x370
; 0000 03AA   else if (user_en[user][0]==0)
_0x147:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x6A
	BRNE _0x149
; 0000 03AB     sw1=2;
	LDI  R30,LOW(2)
	RJMP _0x370
; 0000 03AC   else
_0x149:
; 0000 03AD     sw1=3;
	LDI  R30,LOW(3)
_0x370:
	STS  _sw1,R30
; 0000 03AE   while(T0)
_0x14B:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x14D
; 0000 03AF     {
; 0000 03B0      lcd_clear();
	CALL _lcd_clear
; 0000 03B1      lcd_gotoxy(15,0);
	CALL SUBOPT_0x65
; 0000 03B2      lcd_putchar(1);
	CALL SUBOPT_0x6B
; 0000 03B3      lcd_gotoxy(15,1);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x66
; 0000 03B4      lcd_putchar(0);
	CALL SUBOPT_0x6C
; 0000 03B5      delay_ms(20);
	CALL SUBOPT_0x53
; 0000 03B6      lcd_gotoxy(0,sw2);
	CALL SUBOPT_0x6D
; 0000 03B7      lcd_putchar(2);
; 0000 03B8      if (sw1==1)
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BRNE _0x14E
; 0000 03B9        {
; 0000 03BA         lcd_gotoxy(1,0);
	CALL SUBOPT_0x6E
; 0000 03BB         lcd_putsf("ON");
	__POINTW1FN _0x0,263
	CALL SUBOPT_0x13
; 0000 03BC         delay_ms(20);
	CALL SUBOPT_0x53
; 0000 03BD         lcd_gotoxy(1,1);
	CALL SUBOPT_0x43
; 0000 03BE         lcd_putsf("OFF");
	__POINTW1FN _0x0,266
	CALL SUBOPT_0x13
; 0000 03BF         if (user_en[user][0]==1) {lcd_gotoxy(14,0); lcd_putchar(3);}
	CALL SUBOPT_0x57
	CALL SUBOPT_0x69
	BRNE _0x14F
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x371
; 0000 03C0         else if (user_en[user][0]==0) {lcd_gotoxy(14,1); lcd_putchar(3);}
_0x14F:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x6A
	BRNE _0x151
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(1)
_0x371:
	ST   -Y,R30
	CALL SUBOPT_0x6F
; 0000 03C1        }
_0x151:
; 0000 03C2      else if(sw1==2)
	RJMP _0x152
_0x14E:
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BRNE _0x153
; 0000 03C3        {
; 0000 03C4         lcd_gotoxy(1,0);
	CALL SUBOPT_0x6E
; 0000 03C5         lcd_putsf("OFF");
	__POINTW1FN _0x0,266
	CALL SUBOPT_0x13
; 0000 03C6         delay_ms(20);
	CALL SUBOPT_0x53
; 0000 03C7         lcd_gotoxy(1,1);
	CALL SUBOPT_0x43
; 0000 03C8         lcd_putsf("Password when");
	__POINTW1FN _0x0,270
	CALL SUBOPT_0x13
; 0000 03C9         if (user_en[user][0]==0) {lcd_gotoxy(14,0); lcd_putchar(3);}
	CALL SUBOPT_0x57
	CALL SUBOPT_0x6A
	BRNE _0x154
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x372
; 0000 03CA         else if (user_en[user][0]==2) {lcd_gotoxy(14,1); lcd_putchar(3);}
_0x154:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x70
	BRNE _0x156
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(1)
_0x372:
	ST   -Y,R30
	CALL SUBOPT_0x6F
; 0000 03CB        }
_0x156:
; 0000 03CC      else if(sw1==3)
	RJMP _0x157
_0x153:
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BRNE _0x158
; 0000 03CD        {
; 0000 03CE         lcd_gotoxy(1,0);
	CALL SUBOPT_0x6E
; 0000 03CF         lcd_putsf("Password when");
	__POINTW1FN _0x0,270
	CALL SUBOPT_0x13
; 0000 03D0         delay_ms(20);
	CALL SUBOPT_0x53
; 0000 03D1         lcd_gotoxy(1,1);
	CALL SUBOPT_0x43
; 0000 03D2         lcd_putsf("Access Relays");
	__POINTW1FN _0x0,284
	CALL SUBOPT_0x13
; 0000 03D3         if (user_en[user][0]==2) {lcd_gotoxy(14,0); lcd_putchar(3);}
	CALL SUBOPT_0x57
	CALL SUBOPT_0x70
	BRNE _0x159
	LDI  R30,LOW(14)
	ST   -Y,R30
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x64
; 0000 03D4        }
_0x159:
; 0000 03D5      else if(sw1==4)
	RJMP _0x15A
_0x158:
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BRNE _0x15B
; 0000 03D6        {
; 0000 03D7         lcd_gotoxy(1,0);
	CALL SUBOPT_0x6E
; 0000 03D8         lcd_putsf("Access Relays");
	__POINTW1FN _0x0,284
	CALL SUBOPT_0x13
; 0000 03D9         delay_ms(20);
	CALL SUBOPT_0x53
; 0000 03DA         lcd_gotoxy(1,1);
	CALL SUBOPT_0x43
; 0000 03DB         lcd_putsf("ON");
	__POINTW1FN _0x0,263
	CALL SUBOPT_0x13
; 0000 03DC         if (user_en[user][0]==1) {lcd_gotoxy(14,1); lcd_putchar(3);}
	CALL SUBOPT_0x57
	CALL SUBOPT_0x69
	BRNE _0x15C
	LDI  R30,LOW(14)
	CALL SUBOPT_0x66
	CALL SUBOPT_0x64
; 0000 03DD        }
_0x15C:
; 0000 03DE      delay_ms(50);
_0x15B:
_0x15A:
_0x157:
_0x152:
	CALL SUBOPT_0x3D
; 0000 03DF      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 03E0      delay_ms(50);
; 0000 03E1      if(key_pressed==14) { sw2=0; sw1=1; break; }
	CALL SUBOPT_0x54
	BRNE _0x15D
	CALL SUBOPT_0x71
	RJMP _0x14D
; 0000 03E2      if(key_pressed==10) sw_meno(0,4);
_0x15D:
	CALL SUBOPT_0x55
	BRNE _0x15E
	CALL SUBOPT_0x72
; 0000 03E3      if(key_pressed==11) sw_meno(1,4);
_0x15E:
	CALL SUBOPT_0x56
	BRNE _0x15F
	CALL SUBOPT_0x73
; 0000 03E4      if(key_pressed==15)
_0x15F:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0x160
; 0000 03E5        {
; 0000 03E6         if      ((sw2==0 && sw1==1) || (sw2==1 && sw1==4)) user_en[user][0]=1;
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BRNE _0x162
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BREQ _0x164
_0x162:
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BRNE _0x165
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BREQ _0x164
_0x165:
	RJMP _0x161
_0x164:
	CALL SUBOPT_0x57
	SUBI R30,LOW(-_user_en)
	SBCI R31,HIGH(-_user_en)
	MOVW R26,R30
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
; 0000 03E7         else if ((sw2==0 && sw1==2) || (sw2==1 && sw1==1)) user_en[user][0]=0;
	RJMP _0x168
_0x161:
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BRNE _0x16A
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BREQ _0x16C
_0x16A:
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BRNE _0x16D
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BREQ _0x16C
_0x16D:
	RJMP _0x169
_0x16C:
	CALL SUBOPT_0x57
	SUBI R30,LOW(-_user_en)
	SBCI R31,HIGH(-_user_en)
	MOVW R26,R30
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0000 03E8         else if ((sw2==0 && sw1==3) || (sw2==1 && sw1==2)) User_Control_Time();
	RJMP _0x170
_0x169:
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BRNE _0x172
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BREQ _0x174
_0x172:
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BRNE _0x175
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BREQ _0x174
_0x175:
	RJMP _0x171
_0x174:
	RCALL _User_Control_Time
; 0000 03E9         else if ((sw2==0 && sw1==4) || (sw2==1 && sw1==3)) User_Control_relay();
	RJMP _0x178
_0x171:
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BRNE _0x17A
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BREQ _0x17C
_0x17A:
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BRNE _0x17D
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BREQ _0x17C
_0x17D:
	RJMP _0x179
_0x17C:
	RCALL _User_Control_relay
; 0000 03EA        }
_0x179:
_0x178:
_0x170:
_0x168:
; 0000 03EB 
; 0000 03EC     }
_0x160:
	RJMP _0x14B
_0x14D:
; 0000 03ED  }
	RET
;/**************************************************************************************************/
;void User_Control (void)
; 0000 03F0  {
_User_Control:
; 0000 03F1   strcpy(disp[0],"User_1");
	CALL SUBOPT_0x74
	__POINTW1MN _0x180,0
	CALL SUBOPT_0x75
; 0000 03F2   strcpy(disp[1],"User_2");
	CALL SUBOPT_0x76
	__POINTW1MN _0x180,7
	CALL SUBOPT_0x75
; 0000 03F3   strcpy(disp[2],"User_3");
	CALL SUBOPT_0x77
	__POINTW1MN _0x180,14
	CALL SUBOPT_0x75
; 0000 03F4   strcpy(disp[3],"User_Time");
	CALL SUBOPT_0x78
	__POINTW1MN _0x180,21
	CALL SUBOPT_0x75
; 0000 03F5   strcpy(disp[4],"User_Phone");
	CALL SUBOPT_0x79
	__POINTW1MN _0x180,31
	CALL SUBOPT_0x75
; 0000 03F6   sw2=0;
	CALL SUBOPT_0x71
; 0000 03F7   sw1=1;
; 0000 03F8   while(T0)
_0x181:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x183
; 0000 03F9     {
; 0000 03FA      display_meno(sw1,5);
	CALL SUBOPT_0x7A
; 0000 03FB      lcd_gotoxy(0,sw2);
; 0000 03FC      lcd_putchar(2);
; 0000 03FD      delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 03FE      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 03FF      delay_ms(50);
; 0000 0400      if(key_pressed==14)  break;
	CALL SUBOPT_0x54
	BRNE _0x184
	RJMP _0x183
; 0000 0401      if(key_pressed==15)
_0x184:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0x185
; 0000 0402        {
; 0000 0403         if      ((sw1==5 && sw2==1) || (sw1==1 && sw2==0)) { user=0; User_Control_active(); }
	LDS  R26,_sw1
	CPI  R26,LOW(0x5)
	BRNE _0x187
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x189
_0x187:
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BRNE _0x18A
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x189
_0x18A:
	RJMP _0x186
_0x189:
	LDI  R30,LOW(0)
	STS  _user,R30
	STS  _user+1,R30
	RJMP _0x373
; 0000 0404         else if ((sw1==1 && sw2==1) || (sw1==2 && sw2==0)) { user=1; User_Control_active(); }
_0x186:
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BRNE _0x18F
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x191
_0x18F:
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BRNE _0x192
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x191
_0x192:
	RJMP _0x18E
_0x191:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x374
; 0000 0405         else if ((sw1==2 && sw2==1) || (sw1==3 && sw2==0)) { user=2; User_Control_active(); }
_0x18E:
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BRNE _0x197
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x199
_0x197:
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BRNE _0x19A
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x199
_0x19A:
	RJMP _0x196
_0x199:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x374
; 0000 0406         else if ((sw1==3 && sw2==1) || (sw1==4 && sw2==0)) { user=3; User_Control_active(); }
_0x196:
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BRNE _0x19F
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x1A1
_0x19F:
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BRNE _0x1A2
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x1A1
_0x1A2:
	RJMP _0x19E
_0x1A1:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x374
; 0000 0407         else if ((sw1==4 && sw2==1) || (sw1==5 && sw2==0)) { user=4; User_Control_active(); }
_0x19E:
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BRNE _0x1A7
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x1A9
_0x1A7:
	LDS  R26,_sw1
	CPI  R26,LOW(0x5)
	BRNE _0x1AA
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x1A9
_0x1AA:
	RJMP _0x1A6
_0x1A9:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
_0x374:
	STS  _user,R30
	STS  _user+1,R31
_0x373:
	RCALL _User_Control_active
; 0000 0408        }
_0x1A6:
; 0000 0409      if(key_pressed==10) sw_meno(0,5);
_0x185:
	CALL SUBOPT_0x55
	BRNE _0x1AD
	CALL SUBOPT_0x7B
; 0000 040A      if(key_pressed==11) sw_meno(1,5);
_0x1AD:
	CALL SUBOPT_0x56
	BRNE _0x1AE
	CALL SUBOPT_0x7C
; 0000 040B     }
_0x1AE:
	RJMP _0x181
_0x183:
; 0000 040C  }
	RET

	.DSEG
_0x180:
	.BYTE 0x2A
;/**************************************************************************************************/
;void Set_Password(void)
; 0000 040F  {

	.CSEG
_Set_Password:
; 0000 0410   strcpy(disp[0],"Admin");
	CALL SUBOPT_0x74
	__POINTW1MN _0x1AF,0
	CALL SUBOPT_0x75
; 0000 0411   strcpy(disp[1],"User-1");
	CALL SUBOPT_0x76
	__POINTW1MN _0x1AF,6
	CALL SUBOPT_0x75
; 0000 0412   strcpy(disp[2],"User-2");
	CALL SUBOPT_0x77
	__POINTW1MN _0x1AF,13
	CALL SUBOPT_0x75
; 0000 0413   strcpy(disp[3],"User-3");
	CALL SUBOPT_0x78
	__POINTW1MN _0x1AF,20
	CALL SUBOPT_0x75
; 0000 0414   strcpy(disp[4],"User-Time");
	CALL SUBOPT_0x79
	__POINTW1MN _0x1AF,27
	CALL SUBOPT_0x75
; 0000 0415   strcpy(disp[5],"User-Phone");
	__POINTW1MN _disp,65
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _0x1AF,37
	CALL SUBOPT_0x75
; 0000 0416   while(T0)
_0x1B0:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x1B2
; 0000 0417     {
; 0000 0418      display_meno(sw1,6);
	LDS  R30,_sw1
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _display_meno
; 0000 0419      lcd_gotoxy(0,sw2);
	CALL SUBOPT_0x6D
; 0000 041A      lcd_putchar(2);
; 0000 041B      delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 041C      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 041D      delay_ms(50);
; 0000 041E      if(key_pressed==14)  break;
	CALL SUBOPT_0x54
	BRNE _0x1B3
	RJMP _0x1B2
; 0000 041F      if(key_pressed==15)
_0x1B3:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0x1B4
; 0000 0420        {
; 0000 0421         if      ((sw1==6 && sw2==1) || (sw1==1 && sw2==0)) { user=0; change_pas(); }
	LDS  R26,_sw1
	CPI  R26,LOW(0x6)
	BRNE _0x1B6
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x1B8
_0x1B6:
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BRNE _0x1B9
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x1B8
_0x1B9:
	RJMP _0x1B5
_0x1B8:
	LDI  R30,LOW(0)
	STS  _user,R30
	STS  _user+1,R30
	RJMP _0x375
; 0000 0422         else if ((sw1==1 && sw2==1) || (sw1==2 && sw2==0)) { user=1; change_pas(); }
_0x1B5:
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BRNE _0x1BE
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x1C0
_0x1BE:
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BRNE _0x1C1
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x1C0
_0x1C1:
	RJMP _0x1BD
_0x1C0:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x376
; 0000 0423         else if ((sw1==2 && sw2==1) || (sw1==3 && sw2==0)) { user=2; change_pas(); }
_0x1BD:
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BRNE _0x1C6
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x1C8
_0x1C6:
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BRNE _0x1C9
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x1C8
_0x1C9:
	RJMP _0x1C5
_0x1C8:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x376
; 0000 0424         else if ((sw1==3 && sw2==1) || (sw1==4 && sw2==0)) { user=3; change_pas(); }
_0x1C5:
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BRNE _0x1CE
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x1D0
_0x1CE:
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BRNE _0x1D1
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x1D0
_0x1D1:
	RJMP _0x1CD
_0x1D0:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x376
; 0000 0425         else if ((sw1==4 && sw2==1) || (sw1==5 && sw2==0)) pass_time();
_0x1CD:
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BRNE _0x1D6
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x1D8
_0x1D6:
	LDS  R26,_sw1
	CPI  R26,LOW(0x5)
	BRNE _0x1D9
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x1D8
_0x1D9:
	RJMP _0x1D5
_0x1D8:
	RCALL _pass_time
; 0000 0426         else if ((sw1==5 && sw2==1) || (sw1==6 && sw2==0)) { user=4; change_pas(); }
	RJMP _0x1DC
_0x1D5:
	LDS  R26,_sw1
	CPI  R26,LOW(0x5)
	BRNE _0x1DE
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x1E0
_0x1DE:
	LDS  R26,_sw1
	CPI  R26,LOW(0x6)
	BRNE _0x1E1
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x1E0
_0x1E1:
	RJMP _0x1DD
_0x1E0:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
_0x376:
	STS  _user,R30
	STS  _user+1,R31
_0x375:
	RCALL _change_pas
; 0000 0427        }
_0x1DD:
_0x1DC:
; 0000 0428      if(key_pressed==10) sw_meno(0,6);
_0x1B4:
	CALL SUBOPT_0x55
	BRNE _0x1E4
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _sw_meno
; 0000 0429      if(key_pressed==11) sw_meno(1,6);
_0x1E4:
	CALL SUBOPT_0x56
	BRNE _0x1E5
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _sw_meno
; 0000 042A     }
_0x1E5:
	RJMP _0x1B0
_0x1B2:
; 0000 042B  }
	RET

	.DSEG
_0x1AF:
	.BYTE 0x30
;/**************************************************************************************************/
;void pass_time(void)
; 0000 042E  {

	.CSEG
_pass_time:
; 0000 042F   char str_pass[16],k2=0,k4[2];
; 0000 0430   lcd_clear();
	SBIW R28,18
	ST   -Y,R17
;	str_pass -> Y+3
;	k2 -> R17
;	k4 -> Y+1
	LDI  R17,0
	CALL SUBOPT_0x4C
; 0000 0431   lcd_gotoxy(0,0);
; 0000 0432   lcd_putsf("Y/MM/DD-HH:MM:SS");
	__POINTW1FN _0x0,388
	CALL SUBOPT_0x13
; 0000 0433   for (i=0,j=0;i<16;i++)
	CALL SUBOPT_0xE
	CALL SUBOPT_0x7D
_0x1E7:
	CALL SUBOPT_0xF
	SBIW R26,16
	BRGE _0x1E8
; 0000 0434     {
; 0000 0435      if (i!=1 && i!=4 && i!=7 && i!=10 && i!=13)
	CALL SUBOPT_0xF
	SBIW R26,1
	BREQ _0x1EA
	CALL SUBOPT_0xF
	SBIW R26,4
	BREQ _0x1EA
	CALL SUBOPT_0xF
	SBIW R26,7
	BREQ _0x1EA
	CALL SUBOPT_0xF
	SBIW R26,10
	BREQ _0x1EA
	CALL SUBOPT_0xF
	SBIW R26,13
	BRNE _0x1EB
_0x1EA:
	RJMP _0x1E9
_0x1EB:
; 0000 0436        {
; 0000 0437         str_pass[i]=pass_time_str[j];
	CALL SUBOPT_0x7E
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	CALL SUBOPT_0x60
	SUBI R26,LOW(-_pass_time_str)
	SBCI R27,HIGH(-_pass_time_str)
	CALL SUBOPT_0x49
; 0000 0438         j++;
	LDI  R26,LOW(_j)
	LDI  R27,HIGH(_j)
	CALL SUBOPT_0x2
; 0000 0439        }
; 0000 043A      else
	RJMP _0x1EC
_0x1E9:
; 0000 043B        str_pass[i]=' ';
	CALL SUBOPT_0x7E
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(32)
	ST   X,R30
; 0000 043C     }
_0x1EC:
	CALL SUBOPT_0x11
	RJMP _0x1E7
_0x1E8:
; 0000 043D   while(T0)
_0x1ED:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x1EF
; 0000 043E     {
; 0000 043F      lcd_gotoxy(0,1);
	CALL SUBOPT_0xD
	CALL _lcd_gotoxy
; 0000 0440      lcd_puts(str_pass);
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x5A
; 0000 0441      delay_ms(30);
; 0000 0442      key_pressed=refresh_key(1,k2,1);
	CALL SUBOPT_0x5B
; 0000 0443      delay_ms(50);
; 0000 0444      if (key_pressed==14)  break;
	CALL SUBOPT_0x54
	BRNE _0x1F0
	RJMP _0x1EF
; 0000 0445      if(0<=key_pressed && key_pressed<=9)
_0x1F0:
	CLR  R0
	CP   R4,R0
	CPC  R5,R0
	BRLT _0x1F2
	CALL SUBOPT_0x30
	BRGE _0x1F3
_0x1F2:
	RJMP _0x1F1
_0x1F3:
; 0000 0446        {
; 0000 0447         itoa(key_pressed,k4);
	CALL SUBOPT_0x5C
; 0000 0448         for (i=0;i<16;i++) if (str_pass[i]==toascii(k4[0])) break;
	CALL SUBOPT_0xE
_0x1F5:
	CALL SUBOPT_0xF
	SBIW R26,16
	BRGE _0x1F6
	CALL SUBOPT_0x7E
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	LDD  R30,Y+1
	ANDI R30,0x7F
	CP   R30,R26
	BREQ _0x1F6
; 0000 0449         if (i) str_pass[i]='N';
	CALL SUBOPT_0x11
	RJMP _0x1F5
_0x1F6:
	CALL SUBOPT_0x1B
	SBIW R30,0
	BREQ _0x1F8
	CALL SUBOPT_0x7E
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(78)
	ST   X,R30
; 0000 044A         str_pass[k2]=k4[0];
_0x1F8:
	CALL SUBOPT_0x25
	MOVW R26,R28
	ADIW R26,3
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+1
	STD  Z+0,R26
; 0000 044B        }
; 0000 044C      if (key_pressed==15)
_0x1F1:
	CALL SUBOPT_0x2E
	BRNE _0x1F9
; 0000 044D        {
; 0000 044E         for(i=0,j=0;i<16;i++)
	CALL SUBOPT_0xE
	CALL SUBOPT_0x7D
_0x1FB:
	CALL SUBOPT_0xF
	SBIW R26,16
	BRGE _0x1FC
; 0000 044F           {
; 0000 0450            if (i!=1 && i!=4 && i!=7 && i!=10 && i!=13)
	CALL SUBOPT_0xF
	SBIW R26,1
	BREQ _0x1FE
	CALL SUBOPT_0xF
	SBIW R26,4
	BREQ _0x1FE
	CALL SUBOPT_0xF
	SBIW R26,7
	BREQ _0x1FE
	CALL SUBOPT_0xF
	SBIW R26,10
	BREQ _0x1FE
	CALL SUBOPT_0xF
	SBIW R26,13
	BRNE _0x1FF
_0x1FE:
	RJMP _0x1FD
_0x1FF:
; 0000 0451              {
; 0000 0452               pass_time_str[j]=str_pass[i];
	CALL SUBOPT_0x7F
	SUBI R30,LOW(-_pass_time_str)
	SBCI R31,HIGH(-_pass_time_str)
	MOVW R0,R30
	CALL SUBOPT_0x7E
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	CALL SUBOPT_0x61
; 0000 0453               j++;
; 0000 0454              }
; 0000 0455           }
_0x1FD:
	CALL SUBOPT_0x11
	RJMP _0x1FB
_0x1FC:
; 0000 0456         key_pressed=16;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	MOVW R4,R30
; 0000 0457         break;
	RJMP _0x1EF
; 0000 0458        }
; 0000 0459      if (key_pressed==13)
_0x1F9:
	CALL SUBOPT_0x62
	BRNE _0x200
; 0000 045A        if (k2<15)
	CPI  R17,15
	BRSH _0x201
; 0000 045B           {
; 0000 045C            k2++;
	SUBI R17,-1
; 0000 045D            if (k2==1 || k2==4 || k2==7 || k2==10 || k2==13)
	CPI  R17,1
	BREQ _0x203
	CPI  R17,4
	BREQ _0x203
	CPI  R17,7
	BREQ _0x203
	CPI  R17,10
	BREQ _0x203
	CPI  R17,13
	BRNE _0x202
_0x203:
; 0000 045E              k2++;
	SUBI R17,-1
; 0000 045F           }
_0x202:
; 0000 0460      if (key_pressed==12)
_0x201:
_0x200:
	CALL SUBOPT_0x2D
	BRNE _0x205
; 0000 0461        if (k2)
	CPI  R17,0
	BREQ _0x206
; 0000 0462           {
; 0000 0463            k2--;
	SUBI R17,1
; 0000 0464            if (k2==1 || k2==4 || k2==7 || k2==10 || k2==13)
	CPI  R17,1
	BREQ _0x208
	CPI  R17,4
	BREQ _0x208
	CPI  R17,7
	BREQ _0x208
	CPI  R17,10
	BREQ _0x208
	CPI  R17,13
	BRNE _0x207
_0x208:
; 0000 0465              k2--;
	SUBI R17,1
; 0000 0466           }
_0x207:
; 0000 0467      if (key_pressed==10)
_0x206:
_0x205:
	CALL SUBOPT_0x55
	BRNE _0x20A
; 0000 0468        str_pass[k2]='N';
	CALL SUBOPT_0x25
	MOVW R26,R28
	ADIW R26,3
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(78)
	ST   X,R30
; 0000 0469     }
_0x20A:
	RJMP _0x1ED
_0x1EF:
; 0000 046A  }
	LDD  R17,Y+0
	ADIW R28,19
	RET
;/**************************************************************************************************/
;void compar_time()
; 0000 046D  {
_compar_time:
; 0000 046E   char str[2],str_time[11],str_pass[11]="0000000000";
; 0000 046F   int y,cc=0;
; 0000 0470   for(i=0;i<11;i++) str_time[i]='\0';
	SBIW R28,24
	LDI  R24,11
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x20B*2)
	LDI  R31,HIGH(_0x20B*2)
	CALL __INITLOCB
	CALL __SAVELOCR4
;	str -> Y+26
;	str_time -> Y+15
;	str_pass -> Y+4
;	y -> R16,R17
;	cc -> R18,R19
	__GETWRN 18,19,0
	CALL SUBOPT_0xE
_0x20D:
	CALL SUBOPT_0xF
	SBIW R26,11
	BRGE _0x20E
	CALL SUBOPT_0x80
	LDI  R30,LOW(0)
	ST   X,R30
	CALL SUBOPT_0x11
	RJMP _0x20D
_0x20E:
; 0000 0471 syear=shmdate.year;
	__GETB1MN _shmdate,2
	STS  _syear,R30
; 0000 0472   smonth=shmdate.month;
	__GETB1MN _shmdate,1
	STS  _smonth,R30
; 0000 0473   sday=shmdate.day;
	LDS  R30,_shmdate
	STS  _sday,R30
; 0000 0474   y=syear%10;
	LDS  R26,_syear
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	MOVW R16,R30
; 0000 0475   i=0;
	CALL SUBOPT_0xE
; 0000 0476   itoa(y,str);
	ST   -Y,R17
	ST   -Y,R16
	CALL SUBOPT_0x81
; 0000 0477   str_time[0]=str[0];
	LDD  R30,Y+26
	STD  Y+15,R30
; 0000 0478   if (smonth<10) str_time[1]='0';
	LDS  R26,_smonth
	CPI  R26,LOW(0xA)
	BRSH _0x20F
	LDI  R30,LOW(48)
	STD  Y+16,R30
; 0000 0479   itoa(smonth,str);
_0x20F:
	LDS  R30,_smonth
	CALL SUBOPT_0x48
	CALL SUBOPT_0x81
; 0000 047A   strcat(str_time,str);
	CALL SUBOPT_0x82
; 0000 047B   if (sday<10) str_time[3]='0';
	LDS  R26,_sday
	CPI  R26,LOW(0xA)
	BRSH _0x210
	LDI  R30,LOW(48)
	STD  Y+18,R30
; 0000 047C   itoa(sday,str);
_0x210:
	LDS  R30,_sday
	CALL SUBOPT_0x48
	CALL SUBOPT_0x81
; 0000 047D   strcat(str_time,str);
	CALL SUBOPT_0x82
; 0000 047E   if (hour<10) str_time[5]='0';
	LDS  R26,_hour
	CPI  R26,LOW(0xA)
	BRSH _0x211
	LDI  R30,LOW(48)
	STD  Y+20,R30
; 0000 047F   itoa(hour,str);
_0x211:
	LDS  R30,_hour
	CALL SUBOPT_0x48
	CALL SUBOPT_0x81
; 0000 0480   strcat(str_time,str);
	CALL SUBOPT_0x82
; 0000 0481   if (mino<10) str_time[7]='0';
	LDS  R26,_mino
	CPI  R26,LOW(0xA)
	BRSH _0x212
	LDI  R30,LOW(48)
	STD  Y+22,R30
; 0000 0482   itoa(mino,str);
_0x212:
	LDS  R30,_mino
	CALL SUBOPT_0x48
	CALL SUBOPT_0x81
; 0000 0483   strcat(str_time,str);
	CALL SUBOPT_0x82
; 0000 0484   if (sec<10) str_time[9]='0';
	LDS  R26,_sec
	CPI  R26,LOW(0xA)
	BRSH _0x213
	LDI  R30,LOW(48)
	STD  Y+24,R30
; 0000 0485   itoa(sec,str);
_0x213:
	LDS  R30,_sec
	CALL SUBOPT_0x48
	CALL SUBOPT_0x81
; 0000 0486   strcat(str_time,str);
	CALL SUBOPT_0x82
; 0000 0487   for (i=0;i<11;i++)
	CALL SUBOPT_0xE
_0x215:
	CALL SUBOPT_0xF
	SBIW R26,11
	BRGE _0x216
; 0000 0488      if (pass_time_str[i]!='N')
	CALL SUBOPT_0x83
	CPI  R30,LOW(0x4E)
	BREQ _0x217
; 0000 0489         {
; 0000 048A          j=pass_time_str[i]-48;
	CALL SUBOPT_0x83
	CALL SUBOPT_0x5F
	CALL SUBOPT_0x84
; 0000 048B          str_pass[j]=str_time[i];
	CALL SUBOPT_0x7F
	MOVW R26,R28
	ADIW R26,4
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	CALL SUBOPT_0x80
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
; 0000 048C          if (j>cc) cc=j;
	CALL SUBOPT_0x60
	CP   R18,R26
	CPC  R19,R27
	BRGE _0x218
	__GETWRMN 18,19,0,_j
; 0000 048D         }
_0x218:
; 0000 048E   str_pass[cc+1]='\0';
_0x217:
	CALL SUBOPT_0x11
	RJMP _0x215
_0x216:
	MOVW R30,R18
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,4
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
; 0000 048F   strcpy(main_password_load,str_pass);
	LDI  R30,LOW(_main_password_load)
	LDI  R31,HIGH(_main_password_load)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,6
	CALL SUBOPT_0x75
; 0000 0490  }
	CALL __LOADLOCR4
	ADIW R28,28
	RET
;/**************************************************************************************************/
;int chek_pass(void)
; 0000 0493  {
_chek_pass:
; 0000 0494   for(i=0;i<10;i++)
	CALL SUBOPT_0xE
_0x21A:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0x21B
; 0000 0495     {
; 0000 0496      main_password_load[i]=main_pass[i];
	CALL SUBOPT_0x85
	SUBI R26,LOW(-_main_pass)
	SBCI R27,HIGH(-_main_pass)
	CALL SUBOPT_0x49
; 0000 0497      delay_ms(4);
	CALL SUBOPT_0x86
; 0000 0498     }
	CALL SUBOPT_0x11
	RJMP _0x21A
_0x21B:
; 0000 0499   if (strcmp(pass_in,main_password_load)==0)
	CALL SUBOPT_0x19
	CALL SUBOPT_0x87
	CPI  R30,0
	BRNE _0x21C
; 0000 049A     {
; 0000 049B      result=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	MOVW R12,R30
; 0000 049C      goto end;
	RJMP _0x21D
; 0000 049D     }
; 0000 049E   for(i=0;i<10;i++)
_0x21C:
	CALL SUBOPT_0xE
_0x21F:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0x220
; 0000 049F     {
; 0000 04A0      main_password_load[i]=user_1_pass[i];
	CALL SUBOPT_0x85
	SUBI R26,LOW(-_user_1_pass)
	SBCI R27,HIGH(-_user_1_pass)
	CALL SUBOPT_0x49
; 0000 04A1      delay_ms(4);
	CALL SUBOPT_0x86
; 0000 04A2     }
	CALL SUBOPT_0x11
	RJMP _0x21F
_0x220:
; 0000 04A3   if (strcmp(pass_in,main_password_load)==0)
	CALL SUBOPT_0x19
	CALL SUBOPT_0x87
	CPI  R30,0
	BRNE _0x221
; 0000 04A4     {
; 0000 04A5      result=4;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	MOVW R12,R30
; 0000 04A6      goto end;
	RJMP _0x21D
; 0000 04A7     }
; 0000 04A8   for(i=0;i<10;i++)
_0x221:
	CALL SUBOPT_0xE
_0x223:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0x224
; 0000 04A9     {
; 0000 04AA      main_password_load[i]=user_2_pass[i];
	CALL SUBOPT_0x85
	SUBI R26,LOW(-_user_2_pass)
	SBCI R27,HIGH(-_user_2_pass)
	CALL SUBOPT_0x49
; 0000 04AB      delay_ms(4);
	CALL SUBOPT_0x86
; 0000 04AC     }
	CALL SUBOPT_0x11
	RJMP _0x223
_0x224:
; 0000 04AD   if (strcmp(pass_in,main_password_load)==0)
	CALL SUBOPT_0x19
	CALL SUBOPT_0x87
	CPI  R30,0
	BRNE _0x225
; 0000 04AE     {
; 0000 04AF      result=5;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	MOVW R12,R30
; 0000 04B0      goto end;
	RJMP _0x21D
; 0000 04B1     }
; 0000 04B2   for(i=0;i<10;i++)
_0x225:
	CALL SUBOPT_0xE
_0x227:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRGE _0x228
; 0000 04B3     {
; 0000 04B4      main_password_load[i]=user_3_pass[i];
	CALL SUBOPT_0x85
	SUBI R26,LOW(-_user_3_pass)
	SBCI R27,HIGH(-_user_3_pass)
	CALL SUBOPT_0x49
; 0000 04B5      delay_ms(4);
	CALL SUBOPT_0x86
; 0000 04B6     }
	CALL SUBOPT_0x11
	RJMP _0x227
_0x228:
; 0000 04B7   if (strcmp(pass_in,main_password_load)==0)
	CALL SUBOPT_0x19
	CALL SUBOPT_0x87
	CPI  R30,0
	BRNE _0x229
; 0000 04B8     {
; 0000 04B9      result=6;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	MOVW R12,R30
; 0000 04BA      goto end;
	RJMP _0x21D
; 0000 04BB     }
; 0000 04BC   compar_time();
_0x229:
	RCALL _compar_time
; 0000 04BD   if (strcmp(pass_in,main_password_load)==0)
	CALL SUBOPT_0x19
	CALL SUBOPT_0x87
	CPI  R30,0
	BRNE _0x22A
; 0000 04BE     {
; 0000 04BF      result=3;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	MOVW R12,R30
; 0000 04C0      goto end;
	RJMP _0x21D
; 0000 04C1     }
; 0000 04C2   result=0;
_0x22A:
	CLR  R12
	CLR  R13
; 0000 04C3   end:
_0x21D:
; 0000 04C4   return result;
	MOVW R30,R12
	RET
; 0000 04C5  }
;/**************************************************************************************************/
;char user_c_t_ok(char use)
; 0000 04C8  {
_user_c_t_ok:
; 0000 04C9   unsigned char user_et[5];
; 0000 04CA   int time_on,time_off,time_in;
; 0000 04CB   for (i=0;i<5;i++) user_et[i]=user_en[use][i];
	SBIW R28,5
	CALL __SAVELOCR6
;	use -> Y+11
;	user_et -> Y+6
;	time_on -> R16,R17
;	time_off -> R18,R19
;	time_in -> R20,R21
	CALL SUBOPT_0xE
_0x22C:
	CALL SUBOPT_0xF
	SBIW R26,5
	BRGE _0x22D
	CALL SUBOPT_0x1B
	MOVW R26,R28
	ADIW R26,6
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDD  R30,Y+11
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_user_en)
	SBCI R31,HIGH(-_user_en)
	CALL SUBOPT_0xF
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	MOVW R26,R22
	ST   X,R30
	CALL SUBOPT_0x11
	RJMP _0x22C
_0x22D:
; 0000 04CC if (user_et[0]==0) return 0;
	LDD  R30,Y+6
	CPI  R30,0
	BRNE _0x22E
	LDI  R30,LOW(0)
	RJMP _0x210000A
; 0000 04CD   else if (user_et[0]==1) return 1;
_0x22E:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0x230
	LDI  R30,LOW(1)
	RJMP _0x210000A
; 0000 04CE   else if (user_et[0]==2)
_0x230:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0x232
; 0000 04CF     {
; 0000 04D0      time_on=user_et[1]*100+user_et[2];
	LDD  R26,Y+7
	CALL SUBOPT_0x88
	LDD  R30,Y+8
	CALL SUBOPT_0x89
	MOVW R16,R30
; 0000 04D1      time_off=user_et[3]*100+user_et[4];
	LDD  R26,Y+9
	CALL SUBOPT_0x88
	LDD  R30,Y+10
	CALL SUBOPT_0x89
	MOVW R18,R30
; 0000 04D2      time_in= hour*100+mino;
	LDS  R26,_hour
	CALL SUBOPT_0x88
	LDS  R30,_mino
	CALL SUBOPT_0x89
	MOVW R20,R30
; 0000 04D3      if (time_on>time_off)
	__CPWRR 18,19,16,17
	BRGE _0x233
; 0000 04D4        {
; 0000 04D5         if (time_in>=time_on || time_in<time_off)
	__CPWRR 20,21,16,17
	BRGE _0x235
	__CPWRR 20,21,18,19
	BRGE _0x234
_0x235:
; 0000 04D6           return 1;
	LDI  R30,LOW(1)
	RJMP _0x210000A
; 0000 04D7         else
_0x234:
; 0000 04D8           return 0;
	LDI  R30,LOW(0)
	RJMP _0x210000A
; 0000 04D9        }
; 0000 04DA      else if (time_on<time_off)
_0x233:
	__CPWRR 16,17,18,19
	BRGE _0x239
; 0000 04DB        {
; 0000 04DC         if (time_in>=time_on && time_in<time_off)
	__CPWRR 20,21,16,17
	BRLT _0x23B
	__CPWRR 20,21,18,19
	BRLT _0x23C
_0x23B:
	RJMP _0x23A
_0x23C:
; 0000 04DD           return 1;
	LDI  R30,LOW(1)
	RJMP _0x210000A
; 0000 04DE         else
_0x23A:
; 0000 04DF           return 0;
	LDI  R30,LOW(0)
	RJMP _0x210000A
; 0000 04E0        }
; 0000 04E1      else  return 0;
_0x239:
	LDI  R30,LOW(0)
; 0000 04E2     }
; 0000 04E3  }
_0x232:
_0x210000A:
	CALL __LOADLOCR6
	ADIW R28,12
	RET
;/**************************************************************************************************/
;void compar_pass(void)
; 0000 04E6  {
_compar_pass:
; 0000 04E7   result=chek_pass();
	RCALL _chek_pass
	MOVW R12,R30
; 0000 04E8   if(result)
	MOV  R0,R12
	OR   R0,R13
	BRNE PC+3
	JMP _0x23F
; 0000 04E9     {
; 0000 04EA      lcd_clear();
	CALL _lcd_clear
; 0000 04EB      if (result==1)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R12
	CPC  R31,R13
	BRNE _0x240
; 0000 04EC        {
; 0000 04ED         lcd_putsf("OK  User Admin");
	__POINTW1FN _0x0,405
	CALL SUBOPT_0x13
; 0000 04EE         sw1=5;
	LDI  R30,LOW(5)
	STS  _sw1,R30
; 0000 04EF         goto home;
	RJMP _0x241
; 0000 04F0        }
; 0000 04F1      if (result==4)
_0x240:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R12
	CPC  R31,R13
	BRNE _0x242
; 0000 04F2        {
; 0000 04F3         if (user_c_t_ok(0))
	LDI  R30,LOW(0)
	CALL SUBOPT_0xC
	BREQ _0x243
; 0000 04F4           {
; 0000 04F5            lcd_putsf("OK   User 1");
	__POINTW1FN _0x0,420
	CALL SUBOPT_0x13
; 0000 04F6            sw1=0;
	LDI  R30,LOW(0)
	STS  _sw1,R30
; 0000 04F7            goto home;
	RJMP _0x241
; 0000 04F8           }
; 0000 04F9        }
_0x243:
; 0000 04FA      if (result==5)
_0x242:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CP   R30,R12
	CPC  R31,R13
	BRNE _0x244
; 0000 04FB        {
; 0000 04FC         if (user_c_t_ok(1))
	LDI  R30,LOW(1)
	CALL SUBOPT_0xC
	BREQ _0x245
; 0000 04FD           {
; 0000 04FE            lcd_putsf("OK   User 2");
	__POINTW1FN _0x0,432
	CALL SUBOPT_0x13
; 0000 04FF            sw1=1;
	LDI  R30,LOW(1)
	STS  _sw1,R30
; 0000 0500            goto home;
	RJMP _0x241
; 0000 0501           }
; 0000 0502        }
_0x245:
; 0000 0503      if (result==6)
_0x244:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CP   R30,R12
	CPC  R31,R13
	BRNE _0x246
; 0000 0504        {
; 0000 0505         if (user_c_t_ok(2))
	LDI  R30,LOW(2)
	CALL SUBOPT_0xC
	BREQ _0x247
; 0000 0506           {
; 0000 0507            lcd_putsf("OK   User 3");
	__POINTW1FN _0x0,444
	CALL SUBOPT_0x13
; 0000 0508            sw1=2;
	LDI  R30,LOW(2)
	STS  _sw1,R30
; 0000 0509            goto home;
	RJMP _0x241
; 0000 050A           }
; 0000 050B        }
_0x247:
; 0000 050C      if (result==3)
_0x246:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R30,R12
	CPC  R31,R13
	BRNE _0x248
; 0000 050D        {
; 0000 050E         if (user_c_t_ok(3))
	CALL SUBOPT_0xC
	BREQ _0x249
; 0000 050F           {
; 0000 0510            lcd_putsf("OK Based on Time");
	__POINTW1FN _0x0,456
	CALL SUBOPT_0x13
; 0000 0511            sw1=3;
	LDI  R30,LOW(3)
	STS  _sw1,R30
; 0000 0512            goto home;
	RJMP _0x241
; 0000 0513           }
; 0000 0514        }
_0x249:
; 0000 0515      lcd_clear();
_0x248:
	CALL _lcd_clear
; 0000 0516      lcd_putsf(" This password");
	__POINTW1FN _0x0,473
	CALL SUBOPT_0x13
; 0000 0517      lcd_gotoxy(0,1);
	CALL SUBOPT_0xD
	CALL _lcd_gotoxy
; 0000 0518      lcd_putsf("is a time limit");
	__POINTW1FN _0x0,488
	CALL SUBOPT_0x13
; 0000 0519      sound(2000,500);
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 051A      delay_ms(10);
	CALL SUBOPT_0x10
; 0000 051B      sound(1500,500);
	CALL SUBOPT_0x40
; 0000 051C      delay_ms(10);
	CALL SUBOPT_0x10
; 0000 051D      sound(1000,700);
	CALL SUBOPT_0x41
; 0000 051E      delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RJMP _0x377
; 0000 051F      goto end;
; 0000 0520 
; 0000 0521      home:
_0x241:
; 0000 0522      if(relay_mod[3]) {T4=0; light=1;}
	CALL SUBOPT_0x5
	SBIW R30,0
	BREQ _0x24B
	LDI  R30,LOW(0)
	STS  _T4,R30
	STS  _T4+1,R30
	SBI  0x12,0
; 0000 0523      user=sw1;
_0x24B:
	LDS  R30,_sw1
	LDI  R31,0
	CALL SUBOPT_0x44
; 0000 0524      lcd_gotoxy(2,1);
	CALL SUBOPT_0x51
; 0000 0525      lcd_putsf("1 , 2 , 3");
	__POINTW1FN _0x0,504
	CALL SUBOPT_0x13
; 0000 0526      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x8A
	MOV  R4,R30
	CLR  R5
; 0000 0527      if(key_pressed==14)  goto endl;
	CALL SUBOPT_0x54
	BRNE _0x24E
	RJMP _0x24F
; 0000 0528      if(key_pressed==13)
_0x24E:
	CALL SUBOPT_0x62
	BRNE _0x250
; 0000 0529        {
; 0000 052A         if (result==1)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R12
	CPC  R31,R13
	BRNE _0x251
; 0000 052B            meno();
	RCALL _meno
; 0000 052C         if(result==4 || result==5 || result==6)
_0x251:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R12
	CPC  R31,R13
	BREQ _0x253
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CP   R30,R12
	CPC  R31,R13
	BREQ _0x253
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CP   R30,R12
	CPC  R31,R13
	BRNE _0x252
_0x253:
; 0000 052D           {
; 0000 052E            user=result-3;
	MOVW R30,R12
	SBIW R30,3
	CALL SUBOPT_0x44
; 0000 052F            change_pas();
	CALL _change_pas
; 0000 0530           }
; 0000 0531         goto endl;
_0x252:
	RJMP _0x24F
; 0000 0532        }
; 0000 0533      if(key_pressed==1)
_0x250:
	CALL SUBOPT_0x8B
	BRNE _0x255
; 0000 0534        {
; 0000 0535         lcd_clear();
	CALL SUBOPT_0x50
; 0000 0536         lcd_gotoxy(2,0);
; 0000 0537         lcd_putsf("Relay 1 ON");
	__POINTW1FN _0x0,514
	CALL SUBOPT_0x13
; 0000 0538         relay(1);
	CALL SUBOPT_0x45
; 0000 0539         delay_ms(500);
	CALL SUBOPT_0x4F
; 0000 053A        }
; 0000 053B      if(key_pressed==2)
_0x255:
	CALL SUBOPT_0x8C
	BRNE _0x256
; 0000 053C        {
; 0000 053D         lcd_clear();
	CALL SUBOPT_0x50
; 0000 053E         lcd_gotoxy(2,0);
; 0000 053F         lcd_putsf("Relay 2 ON");
	__POINTW1FN _0x0,525
	CALL SUBOPT_0x13
; 0000 0540         relay(2);
	CALL SUBOPT_0x46
; 0000 0541         delay_ms(500);
	CALL SUBOPT_0x4F
; 0000 0542        }
; 0000 0543      if(key_pressed==3)
_0x256:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x257
; 0000 0544        {
; 0000 0545         lcd_clear();
	CALL SUBOPT_0x50
; 0000 0546         lcd_gotoxy(2,0);
; 0000 0547         lcd_putsf("Relay 3 ON");
	__POINTW1FN _0x0,536
	CALL SUBOPT_0x13
; 0000 0548         relay(3);
	CALL SUBOPT_0x47
; 0000 0549         delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
_0x377:
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 054A        }
; 0000 054B      end:
_0x257:
; 0000 054C      num_pass=0;
	RJMP _0x378
; 0000 054D     }
; 0000 054E   else
_0x23F:
; 0000 054F     {
; 0000 0550      lcd_clear();
	CALL _lcd_clear
; 0000 0551      lcd_putsf("Error password");
	__POINTW1FN _0x0,547
	CALL SUBOPT_0x13
; 0000 0552      sound(3000,700);
	CALL SUBOPT_0x35
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	CALL SUBOPT_0x36
; 0000 0553      delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 0554      sound(3000,1000);
	CALL SUBOPT_0x35
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL SUBOPT_0x36
; 0000 0555      num_pass++;
	LDS  R30,_num_pass
	SUBI R30,-LOW(1)
	STS  _num_pass,R30
; 0000 0556      if(num_pass>=4)
	LDS  R26,_num_pass
	CPI  R26,LOW(0x4)
	BRLO _0x259
; 0000 0557        {
; 0000 0558         delay_ms(500);
	CALL SUBOPT_0x4F
; 0000 0559         sound(3000,3500);
	CALL SUBOPT_0x35
	LDI  R30,LOW(3500)
	LDI  R31,HIGH(3500)
	CALL SUBOPT_0x36
; 0000 055A         GICR=0x80;
	LDI  R30,LOW(128)
	OUT  0x3B,R30
; 0000 055B         T0=180;
	LDI  R30,LOW(180)
	LDI  R31,HIGH(180)
	STS  _T0,R30
	STS  _T0+1,R31
; 0000 055C         lcd_clear();
	CALL _lcd_clear
; 0000 055D         lcd_putsf("warning");
	__POINTW1FN _0x0,562
	CALL SUBOPT_0x13
; 0000 055E         delay_ms(20);
	CALL SUBOPT_0x53
; 0000 055F         lcd_gotoxy(0,1);
	CALL SUBOPT_0xD
	CALL _lcd_gotoxy
; 0000 0560         lcd_putsf("Keypad disabled");
	__POINTW1FN _0x0,570
	CALL SUBOPT_0x13
; 0000 0561         while(T0) delay_ms(1000);
_0x25A:
	CALL SUBOPT_0x6
	BREQ _0x25C
	CALL SUBOPT_0x42
	RJMP _0x25A
_0x25C:
; 0000 0562 GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 0563         num_pass=0;
_0x378:
	LDI  R30,LOW(0)
	STS  _num_pass,R30
; 0000 0564        }
; 0000 0565     }
_0x259:
; 0000 0566   x=0;
	CLR  R10
	CLR  R11
; 0000 0567   T0=2;
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	STS  _T0,R30
	STS  _T0+1,R31
; 0000 0568   if(refresh_key(0,0,0)<16);
	CALL SUBOPT_0x8A
; 0000 0569   endl:
_0x24F:
; 0000 056A   T0=0;
	CALL SUBOPT_0x22
; 0000 056B  }
	RET
;/**************************************************************************************************/
;void Date_Time(void)
; 0000 056E  {
_Date_Time:
; 0000 056F   unsigned char hour1,mino1,sec1,year1,month1,day1;
; 0000 0570   char tim[9],dat[9],car[2];
; 0000 0571   i=4;
	SBIW R28,20
	CALL __SAVELOCR6
;	hour1 -> R17
;	mino1 -> R16
;	sec1 -> R19
;	year1 -> R18
;	month1 -> R21
;	day1 -> R20
;	tim -> Y+17
;	dat -> Y+8
;	car -> Y+6
	CALL SUBOPT_0x8D
; 0000 0572   j=0;
	CALL SUBOPT_0x7D
; 0000 0573   rtc_get_time(&hour1,&mino1,&sec1);
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R17
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R16
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R19
	CALL _rtc_get_time
	POP  R19
	POP  R16
	POP  R17
; 0000 0574   rtc_get_date(&day1,&month1,&year1);
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R20
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R21
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R18
	CALL _rtc_get_date
	POP  R18
	POP  R21
	POP  R20
; 0000 0575   if(!year1) year1=10;
	CPI  R18,0
	BRNE _0x25E
	LDI  R18,LOW(10)
; 0000 0576   miltosham(year1,month1,day1);
_0x25E:
	ST   -Y,R18
	ST   -Y,R21
	ST   -Y,R20
	CALL _miltosham
; 0000 0577   sprintf(tim,"%02u:%02u:%02u",hour1,mino1,sec1);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,586
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CALL SUBOPT_0x59
	MOV  R30,R16
	CALL SUBOPT_0x59
	MOV  R30,R19
	CALL SUBOPT_0x59
	CALL SUBOPT_0x8E
; 0000 0578   sprintf(dat,"%02u/%02u/%02u",shmdate.year,shmdate.month,shmdate.day);
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x8F
	__GETB1MN _shmdate,1
	CALL SUBOPT_0x59
	LDS  R30,_shmdate
	CALL SUBOPT_0x59
	CALL SUBOPT_0x8E
; 0000 0579   while(T0)
_0x25F:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x261
; 0000 057A     {
; 0000 057B      lcd_clear();
	CALL _lcd_clear
; 0000 057C      delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 057D      lcd_gotoxy(4,0);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL SUBOPT_0x1F
; 0000 057E      lcd_puts(tim);
	MOVW R30,R28
	ADIW R30,17
	CALL SUBOPT_0x90
; 0000 057F      lcd_gotoxy(4,1);
	LDI  R30,LOW(4)
	CALL SUBOPT_0x66
; 0000 0580      lcd_puts(dat);
	MOVW R30,R28
	ADIW R30,8
	CALL SUBOPT_0x90
; 0000 0581      key_pressed=refresh_key(1,i,j);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_i
	ST   -Y,R30
	LDS  R30,_j
	CALL SUBOPT_0x91
; 0000 0582      delay_ms(50);
; 0000 0583      if (key_pressed==14)  break;
	CALL SUBOPT_0x54
	BRNE _0x262
	RJMP _0x261
; 0000 0584      if(0<=key_pressed && key_pressed<=9)
_0x262:
	CLR  R0
	CP   R4,R0
	CPC  R5,R0
	BRLT _0x264
	CALL SUBOPT_0x30
	BRGE _0x265
_0x264:
	RJMP _0x263
_0x265:
; 0000 0585        {
; 0000 0586         itoa(key_pressed,car);
	ST   -Y,R5
	ST   -Y,R4
	MOVW R30,R28
	ADIW R30,8
	CALL SUBOPT_0x31
; 0000 0587         if(j)
	CALL SUBOPT_0x7F
	SBIW R30,0
	BRNE PC+3
	JMP _0x266
; 0000 0588           {
; 0000 0589            if(i==7)
	CALL SUBOPT_0xF
	SBIW R26,7
	BRNE _0x267
; 0000 058A              {
; 0000 058B               if(key_pressed>1) goto cancel;
	CALL SUBOPT_0x8B
	BRGE _0x268
	RJMP _0x269
; 0000 058C               if(key_pressed==0 && dat[4]<55 && dat[6]==51 && dat[7]==49) dat[7]=48;
_0x268:
	CLR  R0
	CP   R0,R4
	CPC  R0,R5
	BRNE _0x26B
	LDD  R26,Y+12
	CPI  R26,LOW(0x37)
	BRSH _0x26B
	LDD  R26,Y+14
	CPI  R26,LOW(0x33)
	BRNE _0x26B
	LDD  R26,Y+15
	CPI  R26,LOW(0x31)
	BREQ _0x26C
_0x26B:
	RJMP _0x26A
_0x26C:
	LDI  R30,LOW(48)
	STD  Y+15,R30
; 0000 058D              }
_0x26A:
; 0000 058E            if(i==8)
_0x267:
	CALL SUBOPT_0xF
	SBIW R26,8
	BRNE _0x26D
; 0000 058F              {
; 0000 0590               if(dat[3]>48)
	LDD  R26,Y+11
	CPI  R26,LOW(0x31)
	BRLO _0x26E
; 0000 0591                  if(key_pressed>2) goto cancel;
	CALL SUBOPT_0x8C
	BRGE _0x26F
	RJMP _0x269
; 0000 0592               if(key_pressed>6 && dat[3]<49 && dat[6]==51 && dat[7]==49) dat[7]=48;
_0x26F:
_0x26E:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CP   R30,R4
	CPC  R31,R5
	BRGE _0x271
	LDD  R26,Y+11
	CPI  R26,LOW(0x31)
	BRSH _0x271
	LDD  R26,Y+14
	CPI  R26,LOW(0x33)
	BRNE _0x271
	LDD  R26,Y+15
	CPI  R26,LOW(0x31)
	BREQ _0x272
_0x271:
	RJMP _0x270
_0x272:
	LDI  R30,LOW(48)
	STD  Y+15,R30
; 0000 0593              }
_0x270:
; 0000 0594            if(i==10)
_0x26D:
	CALL SUBOPT_0xF
	SBIW R26,10
	BRNE _0x273
; 0000 0595              {
; 0000 0596               if(key_pressed<4)
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R4,R30
	CPC  R5,R31
	BRGE _0x274
; 0000 0597                 {
; 0000 0598                  if(key_pressed>2)
	CALL SUBOPT_0x8C
	BRGE _0x275
; 0000 0599                    {
; 0000 059A                     if(dat[3]<49 && dat[4]<55 && dat[7]>49) dat[7]=49;
	LDD  R26,Y+11
	CPI  R26,LOW(0x31)
	BRSH _0x277
	LDD  R26,Y+12
	CPI  R26,LOW(0x37)
	BRSH _0x277
	LDD  R26,Y+15
	CPI  R26,LOW(0x32)
	BRSH _0x278
_0x277:
	RJMP _0x276
_0x278:
	LDI  R30,LOW(49)
	STD  Y+15,R30
; 0000 059B                     if(dat[3]<49 && dat[4]>54 && dat[7]>48) dat[7]=48;
_0x276:
	LDD  R26,Y+11
	CPI  R26,LOW(0x31)
	BRSH _0x27A
	LDD  R26,Y+12
	CPI  R26,LOW(0x37)
	BRLO _0x27A
	LDD  R26,Y+15
	CPI  R26,LOW(0x31)
	BRSH _0x27B
_0x27A:
	RJMP _0x279
_0x27B:
	LDI  R30,LOW(48)
	STD  Y+15,R30
; 0000 059C                     if(dat[3]>48 && dat[7]>48) dat[7]=48;
_0x279:
	LDD  R26,Y+11
	CPI  R26,LOW(0x31)
	BRLO _0x27D
	LDD  R26,Y+15
	CPI  R26,LOW(0x31)
	BRSH _0x27E
_0x27D:
	RJMP _0x27C
_0x27E:
	LDI  R30,LOW(48)
	STD  Y+15,R30
; 0000 059D                    }
_0x27C:
; 0000 059E                  }
_0x275:
; 0000 059F               else
	RJMP _0x27F
_0x274:
; 0000 05A0                  goto cancel;
	RJMP _0x269
; 0000 05A1              }
_0x27F:
; 0000 05A2            if(i==11)
_0x273:
	CALL SUBOPT_0xF
	SBIW R26,11
	BRNE _0x280
; 0000 05A3              {
; 0000 05A4               if(dat[6]==51)
	LDD  R26,Y+14
	CPI  R26,LOW(0x33)
	BRNE _0x281
; 0000 05A5                 {
; 0000 05A6                  if(dat[3]<49 && dat[4]<55)
	LDD  R26,Y+11
	CPI  R26,LOW(0x31)
	BRSH _0x283
	LDD  R26,Y+12
	CPI  R26,LOW(0x37)
	BRLO _0x284
_0x283:
	RJMP _0x282
_0x284:
; 0000 05A7                     if(key_pressed>1) goto cancel;
	CALL SUBOPT_0x8B
	BRGE _0x285
	RJMP _0x269
; 0000 05A8                  else
_0x285:
; 0000 05A9                     if(key_pressed>0) goto cancel;
	CLR  R0
	CP   R0,R4
	CPC  R0,R5
	BRGE _0x287
	RJMP _0x269
; 0000 05AA                 }
_0x287:
_0x282:
; 0000 05AB              }
_0x281:
; 0000 05AC            dat[i-4]=car[0];
_0x280:
	CALL SUBOPT_0x1B
	SBIW R30,4
	MOVW R26,R28
	ADIW R26,8
	RJMP _0x379
; 0000 05AD           }
; 0000 05AE         else
_0x266:
; 0000 05AF           {
; 0000 05B0            if(i==4)
	CALL SUBOPT_0xF
	SBIW R26,4
	BRNE _0x289
; 0000 05B1              {
; 0000 05B2               if(key_pressed>2) goto cancel;
	CALL SUBOPT_0x8C
	BRGE _0x28A
	RJMP _0x269
; 0000 05B3               if(key_pressed>1 && tim[1]>51) tim[1]=48;
_0x28A:
	CALL SUBOPT_0x8B
	BRGE _0x28C
	LDD  R26,Y+18
	CPI  R26,LOW(0x34)
	BRSH _0x28D
_0x28C:
	RJMP _0x28B
_0x28D:
	LDI  R30,LOW(48)
	STD  Y+18,R30
; 0000 05B4              }
_0x28B:
; 0000 05B5            if(i==5)
_0x289:
	CALL SUBOPT_0xF
	SBIW R26,5
	BRNE _0x28E
; 0000 05B6               if(tim[0]>49)
	LDD  R26,Y+17
	CPI  R26,LOW(0x32)
	BRLO _0x28F
; 0000 05B7                  if(key_pressed>3) goto cancel;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R30,R4
	CPC  R31,R5
	BRLT _0x269
; 0000 05B8            if(i==7 || i==10)
_0x28F:
_0x28E:
	CALL SUBOPT_0xF
	SBIW R26,7
	BREQ _0x292
	CALL SUBOPT_0xF
	SBIW R26,10
	BRNE _0x291
_0x292:
; 0000 05B9               if(key_pressed>5) goto cancel;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CP   R30,R4
	CPC  R31,R5
	BRLT _0x269
; 0000 05BA            tim[i-4]=car[0];
_0x291:
	CALL SUBOPT_0x1B
	SBIW R30,4
	MOVW R26,R28
	ADIW R26,17
_0x379:
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+6
	STD  Z+0,R26
; 0000 05BB           }
; 0000 05BC         i++;
	CALL SUBOPT_0x11
; 0000 05BD         if(i==6 || i==9)i++;
	CALL SUBOPT_0xF
	SBIW R26,6
	BREQ _0x296
	CALL SUBOPT_0xF
	SBIW R26,9
	BRNE _0x295
_0x296:
	CALL SUBOPT_0x11
; 0000 05BE         if(i>11)
_0x295:
	CALL SUBOPT_0xF
	SBIW R26,12
	BRLT _0x298
; 0000 05BF           {
; 0000 05C0            i=4;
	CALL SUBOPT_0x8D
; 0000 05C1            j=!j;
	CALL SUBOPT_0x92
; 0000 05C2           }
; 0000 05C3         cancel:
_0x298:
_0x269:
; 0000 05C4        }
; 0000 05C5      else if (key_pressed==13)
	RJMP _0x299
_0x263:
	CALL SUBOPT_0x62
	BRNE _0x29A
; 0000 05C6        {
; 0000 05C7         i++;
	CALL SUBOPT_0x11
; 0000 05C8         if(i==6 || i==9)i++;
	CALL SUBOPT_0xF
	SBIW R26,6
	BREQ _0x29C
	CALL SUBOPT_0xF
	SBIW R26,9
	BRNE _0x29B
_0x29C:
	CALL SUBOPT_0x11
; 0000 05C9         if(i>11)i=4;
_0x29B:
	CALL SUBOPT_0xF
	SBIW R26,12
	BRLT _0x29E
	CALL SUBOPT_0x8D
; 0000 05CA        }
_0x29E:
; 0000 05CB      else if (key_pressed==12)
	RJMP _0x29F
_0x29A:
	CALL SUBOPT_0x2D
	BRNE _0x2A0
; 0000 05CC        {
; 0000 05CD         i--;
	CALL SUBOPT_0x93
; 0000 05CE         if(i==6 || i==9)i--;
	CALL SUBOPT_0xF
	SBIW R26,6
	BREQ _0x2A2
	CALL SUBOPT_0xF
	SBIW R26,9
	BRNE _0x2A1
_0x2A2:
	CALL SUBOPT_0x93
; 0000 05CF         if(i<4)i=11;
_0x2A1:
	CALL SUBOPT_0xF
	SBIW R26,4
	BRGE _0x2A4
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	CALL SUBOPT_0xA
; 0000 05D0        }
_0x2A4:
; 0000 05D1      else if (key_pressed==10 || key_pressed==11) j=!j;
	RJMP _0x2A5
_0x2A0:
	CALL SUBOPT_0x55
	BREQ _0x2A7
	CALL SUBOPT_0x56
	BRNE _0x2A6
_0x2A7:
	CALL SUBOPT_0x92
; 0000 05D2      else if (key_pressed==15)
	RJMP _0x2A9
_0x2A6:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0x2AA
; 0000 05D3        {
; 0000 05D4         for(i=0;i<8;i++)
	CALL SUBOPT_0xE
_0x2AC:
	CALL SUBOPT_0xF
	SBIW R26,8
	BRGE _0x2AD
; 0000 05D5           {
; 0000 05D6            tim[i]-=48;
	CALL SUBOPT_0x1B
	MOVW R26,R28
	ADIW R26,17
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CALL SUBOPT_0x5F
	ST   X,R30
; 0000 05D7            dat[i]-=48;
	CALL SUBOPT_0x1B
	MOVW R26,R28
	ADIW R26,8
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CALL SUBOPT_0x5F
	ST   X,R30
; 0000 05D8           }
	CALL SUBOPT_0x11
	RJMP _0x2AC
_0x2AD:
; 0000 05D9         hour1=tim[0]*10+tim[1];
	LDD  R30,Y+17
	LDI  R26,LOW(10)
	MULS R30,R26
	MOVW R30,R0
	LDD  R26,Y+18
	ADD  R30,R26
	MOV  R17,R30
; 0000 05DA         mino1=tim[3]*10+tim[4];
	LDD  R30,Y+20
	LDI  R26,LOW(10)
	MULS R30,R26
	MOVW R30,R0
	LDD  R26,Y+21
	ADD  R30,R26
	MOV  R16,R30
; 0000 05DB         sec1=tim[6]*10+tim[7];
	LDD  R30,Y+23
	LDI  R26,LOW(10)
	MULS R30,R26
	MOVW R30,R0
	LDD  R26,Y+24
	ADD  R30,R26
	MOV  R19,R30
; 0000 05DC         year1=dat[0]*10+dat[1];
	LDD  R30,Y+8
	LDI  R26,LOW(10)
	MULS R30,R26
	MOVW R30,R0
	LDD  R26,Y+9
	ADD  R30,R26
	MOV  R18,R30
; 0000 05DD         month1=dat[3]*10+dat[4];
	LDD  R30,Y+11
	LDI  R26,LOW(10)
	MULS R30,R26
	MOVW R30,R0
	LDD  R26,Y+12
	ADD  R30,R26
	MOV  R21,R30
; 0000 05DE         day1=dat[6]*10+dat[7];
	LDD  R30,Y+14
	LDI  R26,LOW(10)
	MULS R30,R26
	MOVW R30,R0
	LDD  R26,Y+15
	ADD  R30,R26
	MOV  R20,R30
; 0000 05DF         shamtomil(year1,month1,day1);
	ST   -Y,R18
	ST   -Y,R21
	ST   -Y,R20
	CALL _shamtomil
; 0000 05E0         rtc_set_time(hour1,mino1,sec1);
	ST   -Y,R17
	ST   -Y,R16
	ST   -Y,R19
	CALL _rtc_set_time
; 0000 05E1         rtc_set_date(mildate.day,mildate.month,mildate.year);
	LDS  R30,_mildate
	ST   -Y,R30
	__GETB1MN _mildate,1
	ST   -Y,R30
	__GETB1MN _mildate,2
	ST   -Y,R30
	CALL _rtc_set_date
; 0000 05E2         break;
	RJMP _0x261
; 0000 05E3        }
; 0000 05E4     }
_0x2AA:
_0x2A9:
_0x2A5:
_0x29F:
_0x299:
	RJMP _0x25F
_0x261:
; 0000 05E5  }
	CALL __LOADLOCR6
	ADIW R28,26
	RET
;/**************************************************************************************************/
;void clock(void)
; 0000 05E8  {
_clock:
; 0000 05E9   PORTB=0xF0;
	LDI  R30,LOW(240)
	OUT  0x18,R30
; 0000 05EA   i=20;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL SUBOPT_0xA
; 0000 05EB   S=0;
	CLT
	BLD  R2,0
; 0000 05EC   while (!T0)
_0x2AE:
	CALL SUBOPT_0x6
	BREQ PC+3
	JMP _0x2B0
; 0000 05ED     {
; 0000 05EE      rtc_get_time(&hour,&mino,&sec);
	LDI  R30,LOW(_hour)
	LDI  R31,HIGH(_hour)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_mino)
	LDI  R31,HIGH(_mino)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_sec)
	LDI  R31,HIGH(_sec)
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_time
; 0000 05EF      rtc_get_date(&sday,&smonth,&syear);
	LDI  R30,LOW(_sday)
	LDI  R31,HIGH(_sday)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_smonth)
	LDI  R31,HIGH(_smonth)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_syear)
	LDI  R31,HIGH(_syear)
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_date
; 0000 05F0      miltosham(syear,smonth,sday);
	LDS  R30,_syear
	ST   -Y,R30
	LDS  R30,_smonth
	ST   -Y,R30
	LDS  R30,_sday
	ST   -Y,R30
	CALL _miltosham
; 0000 05F1      lcd_clear();
	CALL _lcd_clear
; 0000 05F2      lcd_gotoxy(4,0);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL SUBOPT_0x1F
; 0000 05F3      if (S) {sprintf(buffer,"%02u:%02u:%02u",hour,mino,sec); S=0; }
	SBRS R2,0
	RJMP _0x2B1
	CALL SUBOPT_0x1D
	__POINTW1FN _0x0,586
	CALL SUBOPT_0x94
	LDS  R30,_mino
	CALL SUBOPT_0x59
	LDS  R30,_sec
	CALL SUBOPT_0x59
	CALL SUBOPT_0x8E
	CLT
	RJMP _0x37A
; 0000 05F4      else   {sprintf(buffer,"%02u %02u %02u",hour,mino,sec); S=1; }
_0x2B1:
	CALL SUBOPT_0x1D
	__POINTW1FN _0x0,616
	CALL SUBOPT_0x94
	LDS  R30,_mino
	CALL SUBOPT_0x59
	LDS  R30,_sec
	CALL SUBOPT_0x59
	CALL SUBOPT_0x8E
	SET
_0x37A:
	BLD  R2,0
; 0000 05F5      lcd_puts(buffer);
	CALL SUBOPT_0x1D
	CALL _lcd_puts
; 0000 05F6      lcd_gotoxy(4,1);
	LDI  R30,LOW(4)
	CALL SUBOPT_0x66
; 0000 05F7      sprintf(buffer,"%02u/%02u/%02u",shmdate.year,shmdate.month,shmdate.day);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x8F
	__GETB1MN _shmdate,1
	CALL SUBOPT_0x59
	LDS  R30,_shmdate
	CALL SUBOPT_0x59
	CALL SUBOPT_0x8E
; 0000 05F8      lcd_puts(buffer);
	CALL SUBOPT_0x1D
	CALL _lcd_puts
; 0000 05F9      delay_ms(495);
	LDI  R30,LOW(495)
	LDI  R31,HIGH(495)
	CALL SUBOPT_0xB
; 0000 05FA      if(i>1)i--;
	CALL SUBOPT_0xF
	SBIW R26,2
	BRLT _0x2B3
	CALL SUBOPT_0x93
; 0000 05FB      else light_LCD=0;
	RJMP _0x2B4
_0x2B3:
	CBI  0x15,5
; 0000 05FC     }
_0x2B4:
	RJMP _0x2AE
_0x2B0:
; 0000 05FD   S=0;
	CLT
	BLD  R2,0
; 0000 05FE   if(conect_tel) tel_conect();
	SBIS 0x1B,3
	RJMP _0x2B7
	CALL _tel_conect
; 0000 05FF   pass_in_clean();
_0x2B7:
	RCALL _pass_in_clean
; 0000 0600   light_LCD=1;
	SBI  0x15,5
; 0000 0601   lcd_clear();
	CALL _lcd_clear
; 0000 0602   lcd_putsf("Insert Password");
	__POINTW1FN _0x0,63
	CALL SUBOPT_0x13
; 0000 0603  }
	RET
;/**************************************************************************************************/
;void pass_in_clean(void)
; 0000 0606  {
_pass_in_clean:
; 0000 0607   char j,b;
; 0000 0608   b=strlen(pass_in);
	ST   -Y,R17
	ST   -Y,R16
;	j -> R17
;	b -> R16
	CALL SUBOPT_0x19
	CALL _strlen
	MOV  R16,R30
; 0000 0609   for(j=0;j<b;j++)pass_in[j]='\0';
	LDI  R17,LOW(0)
_0x2BB:
	CP   R17,R16
	BRSH _0x2BC
	CALL SUBOPT_0x25
	SUBI R30,LOW(-_pass_in)
	SBCI R31,HIGH(-_pass_in)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	SUBI R17,-1
	RJMP _0x2BB
_0x2BC:
; 0000 060A x=0;
	CLR  R10
	CLR  R11
; 0000 060B  }
	RJMP _0x2100008
;/**************************************************************************************************/
;void display_meno(char sw_1,char sw_2)
; 0000 060E  {
_display_meno:
; 0000 060F   if (sw_1<sw_2)
;	sw_1 -> Y+1
;	sw_2 -> Y+0
	LD   R30,Y
	LDD  R26,Y+1
	CP   R26,R30
	BRSH _0x2BD
; 0000 0610     {
; 0000 0611      sw_2=sw_1;
	LDD  R30,Y+1
	RJMP _0x37B
; 0000 0612      sw_1=sw_1-1;
; 0000 0613     }
; 0000 0614   else
_0x2BD:
; 0000 0615     {
; 0000 0616      sw_2=0;
	LDI  R30,LOW(0)
_0x37B:
	ST   Y,R30
; 0000 0617      sw_1=sw_1-1;
	LDD  R30,Y+1
	LDI  R31,0
	SBIW R30,1
	STD  Y+1,R30
; 0000 0618     }
; 0000 0619   lcd_clear();
	CALL SUBOPT_0x50
; 0000 061A   lcd_gotoxy(2,0);
; 0000 061B   lcd_puts(disp[sw_1]);
	LDD  R30,Y+1
	CALL SUBOPT_0x95
; 0000 061C   lcd_gotoxy(2,1);
	CALL SUBOPT_0x51
; 0000 061D   lcd_puts(disp[sw_2]);
	LD   R30,Y
	CALL SUBOPT_0x95
; 0000 061E   lcd_gotoxy(15,0);
	CALL SUBOPT_0x65
; 0000 061F   lcd_putchar(1);
	CALL SUBOPT_0x6B
; 0000 0620   delay_ms(20);
	CALL SUBOPT_0x53
; 0000 0621   lcd_gotoxy(15,1);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x66
; 0000 0622   lcd_putchar(0);
	CALL SUBOPT_0x6C
; 0000 0623  }
	RJMP _0x2100009
;/**************************************************************************************************/
;void sw_meno(char ud,char con)
; 0000 0626  {
_sw_meno:
; 0000 0627   if(ud)
;	ud -> Y+1
;	con -> Y+0
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2BF
; 0000 0628     {
; 0000 0629      if (sw2) sw2=0;
	LDS  R30,_sw2
	CPI  R30,0
	BREQ _0x2C0
	LDI  R30,LOW(0)
	STS  _sw2,R30
; 0000 062A      else if (!sw2) sw1--;
	RJMP _0x2C1
_0x2C0:
	LDS  R30,_sw2
	CPI  R30,0
	BRNE _0x2C2
	LDS  R30,_sw1
	SUBI R30,LOW(1)
	STS  _sw1,R30
; 0000 062B      if (sw1<1) sw1=con;
_0x2C2:
_0x2C1:
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BRSH _0x2C3
	LD   R30,Y
	STS  _sw1,R30
; 0000 062C     }
_0x2C3:
; 0000 062D   else
	RJMP _0x2C4
_0x2BF:
; 0000 062E     {
; 0000 062F      if (!sw2) sw2=1;
	LDS  R30,_sw2
	CPI  R30,0
	BRNE _0x2C5
	LDI  R30,LOW(1)
	STS  _sw2,R30
; 0000 0630      else if (sw2) sw1++;
	RJMP _0x2C6
_0x2C5:
	LDS  R30,_sw2
	CPI  R30,0
	BREQ _0x2C7
	LDS  R30,_sw1
	SUBI R30,-LOW(1)
	STS  _sw1,R30
; 0000 0631      if (sw1>con) sw1=1;
_0x2C7:
_0x2C6:
	LD   R30,Y
	LDS  R26,_sw1
	CP   R30,R26
	BRSH _0x2C8
	LDI  R30,LOW(1)
	STS  _sw1,R30
; 0000 0632     }
_0x2C8:
_0x2C4:
; 0000 0633  }
_0x2100009:
	ADIW R28,2
	RET
;/**************************************************************************************************/
;void meno(void)
; 0000 0636  {
_meno:
; 0000 0637   sw1=1;
	LDI  R30,LOW(1)
	STS  _sw1,R30
; 0000 0638   S=0;
	CLT
	BLD  R2,0
; 0000 0639   while(T0)
_0x2C9:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x2CB
; 0000 063A     {
; 0000 063B      if(!S)
	SBRC R2,0
	RJMP _0x2CC
; 0000 063C        {
; 0000 063D         strcpy(disp[0],"Security");
	CALL SUBOPT_0x74
	__POINTW1MN _0x2CD,0
	CALL SUBOPT_0x75
; 0000 063E         strcpy(disp[1],"Date&Time");
	CALL SUBOPT_0x76
	__POINTW1MN _0x2CD,9
	CALL SUBOPT_0x75
; 0000 063F         strcpy(disp[2],"Display");
	CALL SUBOPT_0x77
	__POINTW1MN _0x2CD,19
	CALL SUBOPT_0x75
; 0000 0640         strcpy(disp[3],"Relay mod");
	CALL SUBOPT_0x78
	__POINTW1MN _0x2CD,27
	CALL SUBOPT_0x75
; 0000 0641         strcpy(disp[4],"Ring Phone");
	CALL SUBOPT_0x79
	__POINTW1MN _0x2CD,37
	CALL SUBOPT_0x75
; 0000 0642         sw1=1;
	LDI  R30,LOW(1)
	STS  _sw1,R30
; 0000 0643         sw2=0;
	LDI  R30,LOW(0)
	STS  _sw2,R30
; 0000 0644         S=1;
	SET
	BLD  R2,0
; 0000 0645        }
; 0000 0646      display_meno(sw1,5);
_0x2CC:
	CALL SUBOPT_0x7A
; 0000 0647      lcd_gotoxy(0,sw2);
; 0000 0648      lcd_putchar(2);
; 0000 0649      delay_ms(50);
	CALL SUBOPT_0x3D
; 0000 064A      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 064B      delay_ms(50);
; 0000 064C      if(key_pressed==14)  break;
	CALL SUBOPT_0x54
	BRNE _0x2CE
	RJMP _0x2CB
; 0000 064D      if(key_pressed==15)
_0x2CE:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0x2CF
; 0000 064E        {
; 0000 064F         if      ((sw1==5 && sw2==1) || (sw1==1 && sw2==0)) {Security_meno(); S=0;}
	LDS  R26,_sw1
	CPI  R26,LOW(0x5)
	BRNE _0x2D1
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x2D3
_0x2D1:
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BRNE _0x2D4
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x2D3
_0x2D4:
	RJMP _0x2D0
_0x2D3:
	CALL _Security_meno
	RJMP _0x37C
; 0000 0650         else if ((sw1==1 && sw2==1) || (sw1==2 && sw2==0)) {Date_Time();     S=0;}
_0x2D0:
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BRNE _0x2D9
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x2DB
_0x2D9:
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BRNE _0x2DC
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x2DB
_0x2DC:
	RJMP _0x2D8
_0x2DB:
	RCALL _Date_Time
	RJMP _0x37C
; 0000 0651         else if ((sw1==2 && sw2==1) || (sw1==3 && sw2==0)) {Display();       S=0;}
_0x2D8:
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BRNE _0x2E1
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x2E3
_0x2E1:
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BRNE _0x2E4
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x2E3
_0x2E4:
	RJMP _0x2E0
_0x2E3:
	RCALL _Display
	RJMP _0x37C
; 0000 0652         else if ((sw1==3 && sw2==1) || (sw1==4 && sw2==0)) {Relay_seting();  S=0;}
_0x2E0:
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BRNE _0x2E9
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x2EB
_0x2E9:
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BRNE _0x2EC
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x2EB
_0x2EC:
	RJMP _0x2E8
_0x2EB:
	RCALL _Relay_seting
	RJMP _0x37C
; 0000 0653         else if ((sw1==4 && sw2==1) || (sw1==5 && sw2==0)) {Ring_Phone();    S=0;}
_0x2E8:
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BRNE _0x2F1
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BREQ _0x2F3
_0x2F1:
	LDS  R26,_sw1
	CPI  R26,LOW(0x5)
	BRNE _0x2F4
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BREQ _0x2F3
_0x2F4:
	RJMP _0x2F0
_0x2F3:
	RCALL _Ring_Phone
_0x37C:
	CLT
	BLD  R2,0
; 0000 0654        }
_0x2F0:
; 0000 0655      if(key_pressed==10) sw_meno(0,5);
_0x2CF:
	CALL SUBOPT_0x55
	BRNE _0x2F7
	CALL SUBOPT_0x7B
; 0000 0656      if(key_pressed==11) sw_meno(1,5);
_0x2F7:
	CALL SUBOPT_0x56
	BRNE _0x2F8
	CALL SUBOPT_0x7C
; 0000 0657     }
_0x2F8:
	RJMP _0x2C9
_0x2CB:
; 0000 0658  }
	RET

	.DSEG
_0x2CD:
	.BYTE 0x30
;/**************************************************************************************************/
;void Ring_Phone(void)
; 0000 065B  {

	.CSEG
_Ring_Phone:
; 0000 065C   while(T0)
_0x2F9:
	CALL SUBOPT_0x6
	BREQ _0x2FB
; 0000 065D     {
; 0000 065E      lcd_clear();
	CALL SUBOPT_0x4C
; 0000 065F      lcd_gotoxy(0,0);
; 0000 0660      lcd_putsf("Ring Phone:");
	__POINTW1FN _0x0,679
	CALL SUBOPT_0x13
; 0000 0661      lcd_gotoxy(11,0);
	CALL SUBOPT_0x96
; 0000 0662      itoa(countring,buffer);
	LDI  R26,LOW(_countring)
	LDI  R27,HIGH(_countring)
	CALL __EEPROMRDW
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x1D
	CALL _itoa
; 0000 0663      lcd_puts(buffer);
	CALL SUBOPT_0x1D
	CALL _lcd_puts
; 0000 0664      key_pressed=refresh_key(1,11,0);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(0)
	CALL SUBOPT_0x91
; 0000 0665      delay_ms(50);
; 0000 0666      if(key_pressed==14 || key_pressed==15)  break;
	CALL SUBOPT_0x54
	BREQ _0x2FD
	CALL SUBOPT_0x2E
	BRNE _0x2FC
_0x2FD:
	RJMP _0x2FB
; 0000 0667      if(0<key_pressed && key_pressed<=9)
_0x2FC:
	CLR  R0
	CP   R0,R4
	CPC  R0,R5
	BRGE _0x300
	CALL SUBOPT_0x30
	BRGE _0x301
_0x300:
	RJMP _0x2FF
_0x301:
; 0000 0668        {
; 0000 0669         countring=key_pressed;
	MOVW R30,R4
	LDI  R26,LOW(_countring)
	LDI  R27,HIGH(_countring)
	CALL __EEPROMWRW
; 0000 066A         delay_ms(100);
	CALL SUBOPT_0x3A
; 0000 066B        }
; 0000 066C     }
_0x2FF:
	RJMP _0x2F9
_0x2FB:
; 0000 066D  }
	RET
;/**************************************************************************************************/
;void Moment(void)
; 0000 0670  {
_Moment:
; 0000 0671   char k[1];
; 0000 0672   sw1=11;
	SBIW R28,1
;	k -> Y+0
	LDI  R30,LOW(11)
	STS  _sw1,R30
; 0000 0673   sprintf(buffer,"%3d",relay_mod[j]);
	CALL SUBOPT_0x1D
	__POINTW1FN _0x0,691
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x97
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	CALL SUBOPT_0x98
; 0000 0674   for(i=0;i<3;i++) if(buffer[i]==32) buffer[i]=48;
	CALL SUBOPT_0xE
_0x303:
	CALL SUBOPT_0xF
	SBIW R26,3
	BRGE _0x304
	CALL SUBOPT_0x5E
	LD   R26,Z
	CPI  R26,LOW(0x20)
	BRNE _0x305
	CALL SUBOPT_0x5E
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 0675   i=0;
_0x305:
	CALL SUBOPT_0x11
	RJMP _0x303
_0x304:
	CALL SUBOPT_0xE
; 0000 0676   while(T0)
_0x306:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x308
; 0000 0677     {
; 0000 0678      lcd_clear();
	CALL SUBOPT_0x4C
; 0000 0679      lcd_gotoxy(0,0);
; 0000 067A      lcd_putsf("Moment for:");
	__POINTW1FN _0x0,695
	CALL SUBOPT_0x13
; 0000 067B      lcd_gotoxy(11,0);
	CALL SUBOPT_0x96
; 0000 067C      lcd_puts(buffer);
	CALL SUBOPT_0x1D
	CALL _lcd_puts
; 0000 067D      key_pressed=refresh_key(1,sw1,0);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDS  R30,_sw1
	ST   -Y,R30
	LDI  R30,LOW(0)
	CALL SUBOPT_0x91
; 0000 067E      delay_ms(50);
; 0000 067F      if (key_pressed==14) break;
	CALL SUBOPT_0x54
	BRNE _0x309
	RJMP _0x308
; 0000 0680      if(0<=key_pressed && key_pressed<=9)
_0x309:
	CLR  R0
	CP   R4,R0
	CPC  R5,R0
	BRLT _0x30B
	CALL SUBOPT_0x30
	BRGE _0x30C
_0x30B:
	RJMP _0x30A
_0x30C:
; 0000 0681         {
; 0000 0682          itoa(key_pressed,k);
	ST   -Y,R5
	ST   -Y,R4
	MOVW R30,R28
	ADIW R30,2
	CALL SUBOPT_0x31
; 0000 0683          buffer[i]=k[0];
	CALL SUBOPT_0x5E
	LD   R26,Y
	STD  Z+0,R26
; 0000 0684          sw1++;
	LDS  R30,_sw1
	SUBI R30,-LOW(1)
	STS  _sw1,R30
; 0000 0685          i++;
	CALL SUBOPT_0x11
; 0000 0686          if (sw1==14) {sw1=11; i=0;}
	LDS  R26,_sw1
	CPI  R26,LOW(0xE)
	BRNE _0x30D
	LDI  R30,LOW(11)
	STS  _sw1,R30
	CALL SUBOPT_0xE
; 0000 0687         }
_0x30D:
; 0000 0688      if (key_pressed==15)
_0x30A:
	CALL SUBOPT_0x2E
	BRNE _0x30E
; 0000 0689         {
; 0000 068A          relay_mod[j]=((buffer[0]-48)*100)+((buffer[1]-48)*10)+(buffer[2]-48);
	CALL SUBOPT_0x97
	ADD  R30,R26
	ADC  R31,R27
	MOVW R24,R30
	LDS  R30,_buffer
	CALL SUBOPT_0x5F
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	CALL __MULW12
	MOVW R22,R30
	__GETB1MN _buffer,1
	CALL SUBOPT_0x5F
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	CALL __MULW12
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	__GETB1MN _buffer,2
	CALL SUBOPT_0x5F
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R24
	CALL __EEPROMWRW
; 0000 068B          break;
	RJMP _0x308
; 0000 068C         }
; 0000 068D     }
_0x30E:
	RJMP _0x306
_0x308:
; 0000 068E   sw2=0;
	CALL SUBOPT_0x71
; 0000 068F   sw1=1;
; 0000 0690  }
	JMP  _0x2100005
;/**************************************************************************************************/
;void Relay_set()
; 0000 0693  {
_Relay_set:
	PUSH R15
; 0000 0694   bit rs=0;
; 0000 0695   while(T0)
;	rs -> R15.0
	CLR  R15
_0x30F:
	CALL SUBOPT_0x6
	BREQ _0x311
; 0000 0696     {
; 0000 0697      lcd_clear();
	CALL SUBOPT_0x50
; 0000 0698      lcd_gotoxy(2,0);
; 0000 0699      lcd_putsf("Moment");   //  
	__POINTW1FN _0x0,707
	CALL SUBOPT_0x13
; 0000 069A      lcd_gotoxy(2,1);
	CALL SUBOPT_0x51
; 0000 069B      lcd_putsf("Permanent"); // 
	__POINTW1FN _0x0,714
	CALL SUBOPT_0x13
; 0000 069C      lcd_gotoxy(0,rs);
	CALL SUBOPT_0x52
; 0000 069D      lcd_putchar(2);
; 0000 069E      if (relay_mod[j]) {lcd_gotoxy(13,0); lcd_putchar(3);}
	CALL SUBOPT_0x97
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	SBIW R30,0
	BREQ _0x312
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP _0x37D
; 0000 069F      else              {lcd_gotoxy(13,1); lcd_putchar(3);}
_0x312:
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(1)
_0x37D:
	ST   -Y,R30
	CALL SUBOPT_0x6F
; 0000 06A0      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 06A1      delay_ms(50);
; 0000 06A2      if(key_pressed==14)  break;
	CALL SUBOPT_0x54
	BREQ _0x311
; 0000 06A3      if(key_pressed==10 || key_pressed==11 )  rs=!rs;
	CALL SUBOPT_0x55
	BREQ _0x316
	CALL SUBOPT_0x56
	BRNE _0x315
_0x316:
	LDI  R30,LOW(1)
	EOR  R15,R30
; 0000 06A4      if(key_pressed==15)
_0x315:
	CALL SUBOPT_0x2E
	BRNE _0x318
; 0000 06A5        {
; 0000 06A6         if (rs) relay_mod[j]=0;
	SBRS R15,0
	RJMP _0x319
	CALL SUBOPT_0x97
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __EEPROMWRW
; 0000 06A7         else Moment();
	RJMP _0x31A
_0x319:
	RCALL _Moment
; 0000 06A8        }
_0x31A:
; 0000 06A9     }
_0x318:
	RJMP _0x30F
_0x311:
; 0000 06AA  }
	POP  R15
	RET
;/**************************************************************************************************/
;void Relay_seting(void)
; 0000 06AD  {
_Relay_seting:
; 0000 06AE   strcpy(disp[0],"Relay 1");
	CALL SUBOPT_0x74
	__POINTW1MN _0x31B,0
	CALL SUBOPT_0x75
; 0000 06AF   strcpy(disp[1],"Relay 2");
	CALL SUBOPT_0x76
	__POINTW1MN _0x31B,8
	CALL SUBOPT_0x75
; 0000 06B0   strcpy(disp[2],"Relay 3");
	CALL SUBOPT_0x77
	__POINTW1MN _0x31B,16
	CALL SUBOPT_0x75
; 0000 06B1   strcpy(disp[3],"Relay 0*");
	CALL SUBOPT_0x78
	__POINTW1MN _0x31B,24
	CALL SUBOPT_0x75
; 0000 06B2   sw2=0;
	CALL SUBOPT_0x71
; 0000 06B3   sw1=1;
; 0000 06B4   while(T0)
_0x31C:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x31E
; 0000 06B5     {
; 0000 06B6      display_meno(sw1,4);
	LDS  R30,_sw1
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _display_meno
; 0000 06B7      lcd_gotoxy(0,sw2);
	CALL SUBOPT_0x6D
; 0000 06B8      lcd_putchar(2);
; 0000 06B9      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 06BA      delay_ms(50);
; 0000 06BB      if(key_pressed==14)  break;
	CALL SUBOPT_0x54
	BRNE _0x31F
	RJMP _0x31E
; 0000 06BC      if(key_pressed==10) sw_meno(0,4);
_0x31F:
	CALL SUBOPT_0x55
	BRNE _0x320
	CALL SUBOPT_0x72
; 0000 06BD      if(key_pressed==11) sw_meno(1,4);
_0x320:
	CALL SUBOPT_0x56
	BRNE _0x321
	CALL SUBOPT_0x73
; 0000 06BE      if(key_pressed==15)
_0x321:
	CALL SUBOPT_0x2E
	BREQ PC+3
	JMP _0x322
; 0000 06BF        {
; 0000 06C0         if      ((sw2==0 && sw1==1) || (sw2==1 && sw1==4)){ j=0; Relay_set(); }
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BRNE _0x324
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BREQ _0x326
_0x324:
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BRNE _0x327
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BREQ _0x326
_0x327:
	RJMP _0x323
_0x326:
	CALL SUBOPT_0x7D
	RCALL _Relay_set
; 0000 06C1         else if ((sw2==0 && sw1==2) || (sw2==1 && sw1==1)){ j=1; Relay_set(); }
	RJMP _0x32A
_0x323:
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BRNE _0x32C
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BREQ _0x32E
_0x32C:
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BRNE _0x32F
	LDS  R26,_sw1
	CPI  R26,LOW(0x1)
	BREQ _0x32E
_0x32F:
	RJMP _0x32B
_0x32E:
	CALL SUBOPT_0x5D
	RCALL _Relay_set
; 0000 06C2         else if ((sw2==0 && sw1==3) || (sw2==1 && sw1==2)){ j=2; Relay_set(); }
	RJMP _0x332
_0x32B:
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BRNE _0x334
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BREQ _0x336
_0x334:
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BRNE _0x337
	LDS  R26,_sw1
	CPI  R26,LOW(0x2)
	BREQ _0x336
_0x337:
	RJMP _0x333
_0x336:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL SUBOPT_0x84
	RCALL _Relay_set
; 0000 06C3         else if ((sw2==0 && sw1==4) || (sw2==1 && sw1==3)){ j=3; Moment(); }
	RJMP _0x33A
_0x333:
	LDS  R26,_sw2
	CPI  R26,LOW(0x0)
	BRNE _0x33C
	LDS  R26,_sw1
	CPI  R26,LOW(0x4)
	BREQ _0x33E
_0x33C:
	LDS  R26,_sw2
	CPI  R26,LOW(0x1)
	BRNE _0x33F
	LDS  R26,_sw1
	CPI  R26,LOW(0x3)
	BREQ _0x33E
_0x33F:
	RJMP _0x33B
_0x33E:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CALL SUBOPT_0x84
	RCALL _Moment
; 0000 06C4        }
_0x33B:
_0x33A:
_0x332:
_0x32A:
; 0000 06C5     }
_0x322:
	RJMP _0x31C
_0x31E:
; 0000 06C6  }
	RET

	.DSEG
_0x31B:
	.BYTE 0x21
;/**************************************************************************************************/
;void Display(void)
; 0000 06C9  {

	.CSEG
_Display:
	PUSH R15
; 0000 06CA   bit sc=0;
; 0000 06CB   while(T0)
;	sc -> R15.0
	CLR  R15
_0x342:
	CALL SUBOPT_0x6
	BREQ _0x344
; 0000 06CC     {
; 0000 06CD      lcd_clear();
	CALL SUBOPT_0x50
; 0000 06CE      lcd_gotoxy(2,0);
; 0000 06CF      lcd_putsf("Brightness");
	__POINTW1FN _0x0,757
	CALL SUBOPT_0x13
; 0000 06D0      lcd_gotoxy(2,1);
	CALL SUBOPT_0x51
; 0000 06D1      lcd_putsf("TimeScreen");
	__POINTW1FN _0x0,768
	CALL SUBOPT_0x13
; 0000 06D2      lcd_gotoxy(0,sc);
	CALL SUBOPT_0x52
; 0000 06D3      lcd_putchar(2);
; 0000 06D4      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 06D5      delay_ms(50);
; 0000 06D6      if(key_pressed==14)  break;
	CALL SUBOPT_0x54
	BREQ _0x344
; 0000 06D7      if(key_pressed==10 || key_pressed==11 ) sc=!sc;
	CALL SUBOPT_0x55
	BREQ _0x347
	CALL SUBOPT_0x56
	BRNE _0x346
_0x347:
	LDI  R30,LOW(1)
	EOR  R15,R30
; 0000 06D8      if(key_pressed==15)
_0x346:
	CALL SUBOPT_0x2E
	BRNE _0x349
; 0000 06D9        {
; 0000 06DA         if (sc) TimeScreen();
	SBRS R15,0
	RJMP _0x34A
	RCALL _TimeScreen
; 0000 06DB         else Brightness();
	RJMP _0x34B
_0x34A:
	RCALL _Brightness
; 0000 06DC        }
_0x34B:
; 0000 06DD     }
_0x349:
	RJMP _0x342
_0x344:
; 0000 06DE  }
	POP  R15
	RET
;/**************************************************************************************************/
; void Brightness(void)
; 0000 06E1  {
_Brightness:
; 0000 06E2   while(T0)
_0x34C:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x34E
; 0000 06E3     {
; 0000 06E4      lcd_clear();
	CALL _lcd_clear
; 0000 06E5      lcd_gotoxy(14,0);
	LDI  R30,LOW(14)
	ST   -Y,R30
	CALL SUBOPT_0x1F
; 0000 06E6      sprintf(buffer,"\x7f");
	CALL SUBOPT_0x1D
	__POINTW1FN _0x0,779
	CALL SUBOPT_0x99
; 0000 06E7      lcd_puts(buffer);
	CALL _lcd_puts
; 0000 06E8      lcd_gotoxy(15,0);
	CALL SUBOPT_0x65
; 0000 06E9      sprintf(buffer,"\x7e");
	CALL SUBOPT_0x1D
	__POINTW1FN _0x0,781
	CALL SUBOPT_0x99
; 0000 06EA      lcd_puts(buffer);
	CALL _lcd_puts
; 0000 06EB      lcd_gotoxy(0,0);
	CALL SUBOPT_0x12
; 0000 06EC      lcd_putsf("Brightness:");
	__POINTW1FN _0x0,783
	CALL SUBOPT_0x13
; 0000 06ED      for (i=0;i<=Brightcount/8;i++)
	CALL SUBOPT_0xE
_0x350:
	LDS  R26,_Brightcount
	LDI  R27,0
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL __DIVW21
	CALL SUBOPT_0xF
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x351
; 0000 06EE        {
; 0000 06EF         lcd_gotoxy(i,1);
	CALL SUBOPT_0x14
; 0000 06F0         lcd_putsf("\xff");
	CALL SUBOPT_0x15
; 0000 06F1        }
	CALL SUBOPT_0x11
	SBIW R30,1
	RJMP _0x350
_0x351:
; 0000 06F2      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 06F3      delay_ms(50);
; 0000 06F4      if(key_pressed==15 || key_pressed==14)   break;
	CALL SUBOPT_0x2E
	BREQ _0x353
	CALL SUBOPT_0x54
	BRNE _0x352
_0x353:
	RJMP _0x34E
; 0000 06F5      if(key_pressed==12) if(Brightcount>7) Brightcount-=8;
_0x352:
	CALL SUBOPT_0x2D
	BRNE _0x355
	LDS  R26,_Brightcount
	CPI  R26,LOW(0x8)
	BRLO _0x356
	LDS  R30,_Brightcount
	LDI  R31,0
	SBIW R30,8
	STS  _Brightcount,R30
; 0000 06F6      if(key_pressed==13)  if(Brightcount<121) Brightcount+=8;
_0x356:
_0x355:
	CALL SUBOPT_0x62
	BRNE _0x357
	LDS  R26,_Brightcount
	CPI  R26,LOW(0x79)
	BRSH _0x358
	LDS  R30,_Brightcount
	SUBI R30,-LOW(8)
	STS  _Brightcount,R30
; 0000 06F7      OCR2=128-Brightcount;
_0x358:
_0x357:
	LDS  R30,_Brightcount
	LDI  R31,0
	LDI  R26,LOW(128)
	LDI  R27,HIGH(128)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	OUT  0x23,R30
; 0000 06F8     }
	RJMP _0x34C
_0x34E:
; 0000 06F9  }
	RET
;/**************************************************************************************************/
; void TimeScreen(void)
; 0000 06FC  {
_TimeScreen:
; 0000 06FD   int counter_1;
; 0000 06FE   counter_1=counter;
	ST   -Y,R17
	ST   -Y,R16
;	counter_1 -> R16,R17
	MOVW R16,R6
; 0000 06FF   while(T0)
_0x359:
	CALL SUBOPT_0x6
	BRNE PC+3
	JMP _0x35B
; 0000 0700     {
; 0000 0701      lcd_clear();
	CALL SUBOPT_0x4C
; 0000 0702      lcd_gotoxy(0,0);
; 0000 0703      lcd_putsf("TimeScreen:");
	__POINTW1FN _0x0,795
	CALL SUBOPT_0x13
; 0000 0704      lcd_gotoxy(15,0);
	CALL SUBOPT_0x65
; 0000 0705      lcd_putchar(1);
	CALL SUBOPT_0x6B
; 0000 0706      lcd_gotoxy(15,1);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x66
; 0000 0707      lcd_putchar(0);
	CALL SUBOPT_0x6C
; 0000 0708      lcd_gotoxy(11,0);
	CALL SUBOPT_0x96
; 0000 0709      sprintf(buffer,"%3u",counter_1);
	CALL SUBOPT_0x1D
	__POINTW1FN _0x0,807
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R16
	CALL SUBOPT_0x98
; 0000 070A      lcd_puts(buffer);
	CALL SUBOPT_0x1D
	CALL _lcd_puts
; 0000 070B      key_pressed=refresh_key(0,0,0);
	CALL SUBOPT_0x2F
; 0000 070C      delay_ms(50);
; 0000 070D      if(key_pressed==14) break;
	CALL SUBOPT_0x54
	BREQ _0x35B
; 0000 070E      if(key_pressed==10) {counter_1--; if (counter_1==0) counter_1=60;}
	CALL SUBOPT_0x55
	BRNE _0x35D
	__SUBWRN 16,17,1
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x35E
	__GETWRN 16,17,60
_0x35E:
; 0000 070F      else if(key_pressed==11) {counter_1++; if (counter_1==60) counter_1=1;}
	RJMP _0x35F
_0x35D:
	CALL SUBOPT_0x56
	BRNE _0x360
	__ADDWRN 16,17,1
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x361
	__GETWRN 16,17,1
_0x361:
; 0000 0710      else if(key_pressed==15) {counter=counter_1; break;}
	RJMP _0x362
_0x360:
	CALL SUBOPT_0x2E
	BRNE _0x363
	MOVW R6,R16
	RJMP _0x35B
; 0000 0711     }
_0x363:
_0x362:
_0x35F:
	RJMP _0x359
_0x35B:
; 0000 0712  }
_0x2100008:
	LD   R16,Y+
	LD   R17,Y+
	RET
;/**************************************************************************************************/
; void d_char(unsigned char flash *pc,unsigned char char_code)
; 0000 0715  {
_d_char:
; 0000 0716   unsigned char a;
; 0000 0717   a=(char_code<<3) | 0x40;
	ST   -Y,R17
;	*pc -> Y+2
;	char_code -> Y+1
;	a -> R17
	LDD  R30,Y+1
	LSL  R30
	LSL  R30
	LSL  R30
	ORI  R30,0x40
	MOV  R17,R30
; 0000 0718   for (i=0;i<8;i++) lcd_write_byte(a++,*pc++);
	CALL SUBOPT_0xE
_0x365:
	CALL SUBOPT_0xF
	SBIW R26,8
	BRGE _0x366
	ST   -Y,R17
	INC  R17
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ADIW R30,1
	STD  Y+3,R30
	STD  Y+3+1,R31
	SBIW R30,1
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
	CALL SUBOPT_0x11
	RJMP _0x365
_0x366:
; 0000 0719 }
	LDD  R17,Y+0
	ADIW R28,4
	RET
;

	.CSEG
_strcat:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcat0:
    ld   r22,x+
    tst  r22
    brne strcat0
    sbiw r26,1
strcat1:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcat1
    movw r30,r24
    ret
_strcmp:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
strcmp0:
    ld   r22,x+
    ld   r23,z+
    cp   r22,r23
    brne strcmp1
    tst  r22
    brne strcmp0
strcmp3:
    clr  r30
    ret
strcmp1:
    sub  r22,r23
    breq strcmp3
    ldi  r30,1
    brcc strcmp2
    subi r30,2
strcmp2:
    ret
_strcpy:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpy0:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcpy0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret

	.DSEG

	.CSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G103:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2060010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2060012
	__CPWRN 16,17,2
	BRLO _0x2060013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2060012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x2
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2060014
	CALL SUBOPT_0x2
_0x2060014:
_0x2060013:
	RJMP _0x2060015
_0x2060010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2060015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G103:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2060016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2060018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x206001C
	CPI  R18,37
	BRNE _0x206001D
	LDI  R17,LOW(1)
	RJMP _0x206001E
_0x206001D:
	CALL SUBOPT_0x9A
_0x206001E:
	RJMP _0x206001B
_0x206001C:
	CPI  R30,LOW(0x1)
	BRNE _0x206001F
	CPI  R18,37
	BRNE _0x2060020
	CALL SUBOPT_0x9A
	RJMP _0x20600C9
_0x2060020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2060021
	LDI  R16,LOW(1)
	RJMP _0x206001B
_0x2060021:
	CPI  R18,43
	BRNE _0x2060022
	LDI  R20,LOW(43)
	RJMP _0x206001B
_0x2060022:
	CPI  R18,32
	BRNE _0x2060023
	LDI  R20,LOW(32)
	RJMP _0x206001B
_0x2060023:
	RJMP _0x2060024
_0x206001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2060025
_0x2060024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2060026
	ORI  R16,LOW(128)
	RJMP _0x206001B
_0x2060026:
	RJMP _0x2060027
_0x2060025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x206001B
_0x2060027:
	CPI  R18,48
	BRLO _0x206002A
	CPI  R18,58
	BRLO _0x206002B
_0x206002A:
	RJMP _0x2060029
_0x206002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x206001B
_0x2060029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x206002F
	CALL SUBOPT_0x9B
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x9C
	RJMP _0x2060030
_0x206002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2060032
	CALL SUBOPT_0x9B
	CALL SUBOPT_0x9D
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2060033
_0x2060032:
	CPI  R30,LOW(0x70)
	BRNE _0x2060035
	CALL SUBOPT_0x9B
	CALL SUBOPT_0x9D
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2060033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2060036
_0x2060035:
	CPI  R30,LOW(0x64)
	BREQ _0x2060039
	CPI  R30,LOW(0x69)
	BRNE _0x206003A
_0x2060039:
	ORI  R16,LOW(4)
	RJMP _0x206003B
_0x206003A:
	CPI  R30,LOW(0x75)
	BRNE _0x206003C
_0x206003B:
	LDI  R30,LOW(_tbl10_G103*2)
	LDI  R31,HIGH(_tbl10_G103*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x206003D
_0x206003C:
	CPI  R30,LOW(0x58)
	BRNE _0x206003F
	ORI  R16,LOW(8)
	RJMP _0x2060040
_0x206003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2060071
_0x2060040:
	LDI  R30,LOW(_tbl16_G103*2)
	LDI  R31,HIGH(_tbl16_G103*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x206003D:
	SBRS R16,2
	RJMP _0x2060042
	CALL SUBOPT_0x9B
	CALL SUBOPT_0x9E
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2060043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2060043:
	CPI  R20,0
	BREQ _0x2060044
	SUBI R17,-LOW(1)
	RJMP _0x2060045
_0x2060044:
	ANDI R16,LOW(251)
_0x2060045:
	RJMP _0x2060046
_0x2060042:
	CALL SUBOPT_0x9B
	CALL SUBOPT_0x9E
_0x2060046:
_0x2060036:
	SBRC R16,0
	RJMP _0x2060047
_0x2060048:
	CP   R17,R21
	BRSH _0x206004A
	SBRS R16,7
	RJMP _0x206004B
	SBRS R16,2
	RJMP _0x206004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x206004D
_0x206004C:
	LDI  R18,LOW(48)
_0x206004D:
	RJMP _0x206004E
_0x206004B:
	LDI  R18,LOW(32)
_0x206004E:
	CALL SUBOPT_0x9A
	SUBI R21,LOW(1)
	RJMP _0x2060048
_0x206004A:
_0x2060047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x206004F
_0x2060050:
	CPI  R19,0
	BREQ _0x2060052
	SBRS R16,3
	RJMP _0x2060053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2060054
_0x2060053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2060054:
	CALL SUBOPT_0x9A
	CPI  R21,0
	BREQ _0x2060055
	SUBI R21,LOW(1)
_0x2060055:
	SUBI R19,LOW(1)
	RJMP _0x2060050
_0x2060052:
	RJMP _0x2060056
_0x206004F:
_0x2060058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x206005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x206005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x206005A
_0x206005C:
	CPI  R18,58
	BRLO _0x206005D
	SBRS R16,3
	RJMP _0x206005E
	SUBI R18,-LOW(7)
	RJMP _0x206005F
_0x206005E:
	SUBI R18,-LOW(39)
_0x206005F:
_0x206005D:
	SBRC R16,4
	RJMP _0x2060061
	CPI  R18,49
	BRSH _0x2060063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2060062
_0x2060063:
	RJMP _0x20600CA
_0x2060062:
	CP   R21,R19
	BRLO _0x2060067
	SBRS R16,0
	RJMP _0x2060068
_0x2060067:
	RJMP _0x2060066
_0x2060068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2060069
	LDI  R18,LOW(48)
_0x20600CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x206006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x9C
	CPI  R21,0
	BREQ _0x206006B
	SUBI R21,LOW(1)
_0x206006B:
_0x206006A:
_0x2060069:
_0x2060061:
	CALL SUBOPT_0x9A
	CPI  R21,0
	BREQ _0x206006C
	SUBI R21,LOW(1)
_0x206006C:
_0x2060066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2060059
	RJMP _0x2060058
_0x2060059:
_0x2060056:
	SBRS R16,0
	RJMP _0x206006D
_0x206006E:
	CPI  R21,0
	BREQ _0x2060070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x9C
	RJMP _0x206006E
_0x2060070:
_0x206006D:
_0x2060071:
_0x2060030:
_0x20600C9:
	LDI  R17,LOW(0)
_0x206001B:
	RJMP _0x2060016
_0x2060018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x9F
	SBIW R30,0
	BRNE _0x2060072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2100007
_0x2060072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x9F
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G103)
	LDI  R31,HIGH(_put_buff_G103)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G103
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2100007:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G104:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G104
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G104
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G104
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G104
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G104:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G104
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G104
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G104
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G104
    sbi   __lcd_port,__lcd_rd     ;RD=1
	JMP  _0x2100005
_lcd_write_byte:
	CALL __lcd_ready
	LDD  R30,Y+1
	CALL SUBOPT_0xA0
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	RJMP _0x2100006
__lcd_read_nibble_G104:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G104
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G104
    andi  r30,0xf0
	RET
_lcd_read_byte0_G104:
	CALL __lcd_delay_G104
	RCALL __lcd_read_nibble_G104
    mov   r26,r30
	RCALL __lcd_read_nibble_G104
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G104)
	SBCI R31,HIGH(-__base_y_G104)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x2100006:
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	CALL SUBOPT_0xA0
	LDI  R30,LOW(12)
	CALL SUBOPT_0xA0
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2080004
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2080004:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	JMP  _0x2100005
_lcd_puts:
	ST   -Y,R17
_0x2080005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2080007
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2080005
_0x2080007:
	LDD  R17,Y+0
	JMP  _0x2100003
_lcd_putsf:
	ST   -Y,R17
_0x2080008:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x208000A
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2080008
_0x208000A:
	LDD  R17,Y+0
	JMP  _0x2100003
__long_delay_G104:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G104:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G104
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2100005
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G104,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G104,3
	CALL SUBOPT_0xA1
	CALL SUBOPT_0xA1
	CALL SUBOPT_0xA1
	RCALL __long_delay_G104
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G104
	RCALL __long_delay_G104
	LDI  R30,LOW(40)
	CALL SUBOPT_0xA2
	LDI  R30,LOW(4)
	CALL SUBOPT_0xA2
	LDI  R30,LOW(133)
	CALL SUBOPT_0xA2
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G104
	CPI  R30,LOW(0x5)
	BREQ _0x208000B
	LDI  R30,LOW(0)
	RJMP _0x2100005
_0x208000B:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x2100005:
	ADIW R28,1
	RET

	.CSEG
_rtc_init:
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x20A0003
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0x20A0003:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x20A0004
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x20A0004:
	CALL SUBOPT_0xA3
	LDI  R30,LOW(7)
	CALL SUBOPT_0xA4
	RJMP _0x2100002
_rtc_get_time:
	CALL SUBOPT_0xA3
	LDI  R30,LOW(0)
	CALL SUBOPT_0xA5
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0xA6
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RJMP _0x2100004
_rtc_set_time:
	CALL SUBOPT_0xA3
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	CALL SUBOPT_0xA7
	CALL SUBOPT_0xA4
	RJMP _0x2100001
_rtc_get_date:
	CALL SUBOPT_0xA3
	LDI  R30,LOW(4)
	CALL SUBOPT_0xA5
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL SUBOPT_0xA6
	LD   R26,Y
	LDD  R27,Y+1
_0x2100004:
	ST   X,R30
	CALL _i2c_stop
	ADIW R28,6
	RET
_rtc_set_date:
	CALL SUBOPT_0xA3
	LDI  R30,LOW(4)
	CALL SUBOPT_0xA4
	CALL SUBOPT_0xA7
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
_0x2100001:
	ST   -Y,R30
	CALL _bin2bcd
_0x2100002:
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_stop
_0x2100003:
	ADIW R28,3
	RET

	.CSEG

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.DSEG
_user:
	.BYTE 0x2
_i:
	.BYTE 0x2
_j:
	.BYTE 0x2
_T0:
	.BYTE 0x2
_T1:
	.BYTE 0x2
_T2:
	.BYTE 0x2
_T3:
	.BYTE 0x2
_T4:
	.BYTE 0x2
_T5:
	.BYTE 0x2
_disp:
	.BYTE 0x4E
_pass_in:
	.BYTE 0xB
_str_key_pressed:
	.BYTE 0x1
_main_password_load:
	.BYTE 0xB
_num_pass:
	.BYTE 0x1
_tel_pas_ok:
	.BYTE 0x1
_tel_pas_load:
	.BYTE 0xB
_tel_pas_in:
	.BYTE 0xB
_tel_key:
	.BYTE 0x1
_tel_dtmf:
	.BYTE 0x1
_result_tel:
	.BYTE 0x1
_Brightcount:
	.BYTE 0x1
_sw1:
	.BYTE 0x1
_sw2:
	.BYTE 0x1
_buffer:
	.BYTE 0x10
_hour:
	.BYTE 0x1
_mino:
	.BYTE 0x1
_sec:
	.BYTE 0x1
_syear:
	.BYTE 0x1
_smonth:
	.BYTE 0x1
_sday:
	.BYTE 0x1
_shmdate:
	.BYTE 0x3
_mildate:
	.BYTE 0x3

	.ESEG
_relay_mod:
	.DB  LOW(0x10001),HIGH(0x10001),BYTE3(0x10001),BYTE4(0x10001)
	.DB  LOW(0x10001),HIGH(0x10001),BYTE3(0x10001),BYTE4(0x10001)
_countring:
	.DW  0x3
_main_pass:
	.DB  LOW(0x30),HIGH(0x30),BYTE3(0x30),BYTE4(0x30)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DW  0x0
	.DB  0x0
_user_1_pass:
	.DB  LOW(0x31),HIGH(0x31),BYTE3(0x31),BYTE4(0x31)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DW  0x0
	.DB  0x0
_user_2_pass:
	.DB  LOW(0x32),HIGH(0x32),BYTE3(0x32),BYTE4(0x32)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DW  0x0
	.DB  0x0
_user_3_pass:
	.DB  LOW(0x33),HIGH(0x33),BYTE3(0x33),BYTE4(0x33)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DW  0x0
	.DB  0x0
_pass_time_str:
	.DB  LOW(0x4E4E4E4E),HIGH(0x4E4E4E4E),BYTE3(0x4E4E4E4E),BYTE4(0x4E4E4E4E)
	.DB  LOW(0x4E4E4E4E),HIGH(0x4E4E4E4E),BYTE3(0x4E4E4E4E),BYTE4(0x4E4E4E4E)
	.DB  LOW(0x4E304E),HIGH(0x4E304E),BYTE3(0x4E304E),BYTE4(0x4E304E)
_phone_pass:
	.DB  LOW(0x34),HIGH(0x34),BYTE3(0x34),BYTE4(0x34)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DW  0x0
	.DB  0x0
_relay_user:
	.DB  LOW(0x1010101),HIGH(0x1010101),BYTE3(0x1010101),BYTE4(0x1010101)
	.DB  LOW(0x1010101),HIGH(0x1010101),BYTE3(0x1010101),BYTE4(0x1010101)
	.DB  LOW(0x1010101),HIGH(0x1010101),BYTE3(0x1010101),BYTE4(0x1010101)
	.DB  LOW(0x1010101),HIGH(0x1010101),BYTE3(0x1010101),BYTE4(0x1010101)
	.DW  0x101
_user_en:
	.DB  LOW(0x1),HIGH(0x1),BYTE3(0x1),BYTE4(0x1)
	.DB  LOW(0x100),HIGH(0x100),BYTE3(0x100),BYTE4(0x100)
	.DB  LOW(0x10000),HIGH(0x10000),BYTE3(0x10000),BYTE4(0x10000)
	.DB  LOW(0x1000000),HIGH(0x1000000),BYTE3(0x1000000),BYTE4(0x1000000)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x1),HIGH(0x1),BYTE3(0x1),BYTE4(0x1)
	.DB  0x0

	.DSEG
__seed_G101:
	.BYTE 0x4
__base_y_G104:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(11)
	OUT  0x2D,R30
	LDI  R30,LOW(220)
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R26,LOW(_relay_mod)
	LDI  R27,HIGH(_relay_mod)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 43 TIMES, CODE SIZE REDUCTION:123 WORDS
SUBOPT_0x2:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	__POINTW2MN _relay_mod,2
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	__POINTW2MN _relay_mod,4
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	__POINTW2MN _relay_mod,6
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:66 WORDS
SUBOPT_0x6:
	LDS  R30,_T0
	LDS  R31,_T0+1
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7:
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x8:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	__PUTWMRN _T0,0,6,7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xA:
	STS  _i,R30
	STS  _i+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 105 TIMES, CODE SIZE REDUCTION:205 WORDS
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC:
	ST   -Y,R30
	CALL _user_c_t_ok
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 30 TIMES, CODE SIZE REDUCTION:84 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(0)
	STS  _i,R30
	STS  _i+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 72 TIMES, CODE SIZE REDUCTION:139 WORDS
SUBOPT_0xF:
	LDS  R26,_i
	LDS  R27,_i+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 34 TIMES, CODE SIZE REDUCTION:63 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(_i)
	LDI  R27,HIGH(_i)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 55 TIMES, CODE SIZE REDUCTION:105 WORDS
SUBOPT_0x13:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x14:
	LDS  R30,_i
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	__POINTW1FN _0x0,17
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	LDS  R30,_i
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(_pass_in)
	LDI  R31,HIGH(_pass_in)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1A:
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpy
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 36 TIMES, CODE SIZE REDUCTION:67 WORDS
SUBOPT_0x1B:
	LDS  R30,_i
	LDS  R31,_i+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(_buffer)
	LDI  R31,HIGH(_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	LDS  R30,_i
	SUBI R30,-LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 31 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x20:
	RCALL SUBOPT_0x1B
	SUBI R30,LOW(-_buffer)
	SBCI R31,HIGH(-_buffer)
	LD   R30,Z
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _sound

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(0)
	STS  _T0,R30
	STS  _T0+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x23:
	CALL __SAVELOCR4
	LDD  R26,Y+6
	CLR  R27
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL __MODW21
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x24:
	LDI  R26,LOW(12)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_miltable*2)
	SBCI R31,HIGH(-_miltable*2)
	MOVW R26,R30
	LDD  R30,Y+5
	LDI  R31,0
	SBIW R30,1
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x25:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x26:
	LDI  R26,LOW(12)
	LDI  R27,HIGH(12)
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x27:
	MOVW R26,R30
	LDD  R30,Y+5
	LDI  R31,0
	SBIW R30,1
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	STS  _shmdate,R30
	LDD  R30,Y+5
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x29:
	LDD  R26,Y+4
	CLR  R27
	MOV  R30,R16
	LDI  R31,0
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	SUBI R30,LOW(-_shmtable*2)
	SBCI R31,HIGH(-_shmtable*2)
	RJMP SUBOPT_0x27

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	STS  _mildate,R30
	LDD  R30,Y+5
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2C:
	CALL _key
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x2D:
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x2E:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:129 WORDS
SUBOPT_0x2F:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	ST   -Y,R30
	CALL _refresh_key
	MOV  R4,R30
	CLR  R5
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x30:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x31:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _itoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x32:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcat

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	__POINTW1FN _0x0,79
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x34:
	OUT  0x18,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x35:
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 45 TIMES, CODE SIZE REDUCTION:85 WORDS
SUBOPT_0x36:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _sound

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x37:
	LDS  R26,_user
	LDS  R27,_user+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x38:
	MOVW R26,R30
	CALL __EEPROMRDB
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:65 WORDS
SUBOPT_0x39:
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x3A:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0x3B:
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x3C:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RJMP SUBOPT_0x36

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x3D:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3E:
	CALL _lcd_clear
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3F:
	__POINTW1FN _0x0,81
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x40:
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x3C

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x41:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	RJMP SUBOPT_0x36

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x42:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x43:
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x44:
	STS  _user,R30
	STS  _user+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x45:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _relay

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x46:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _relay

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x47:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _relay

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x48:
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x49:
	CALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4A:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcmp

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x4B:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4C:
	CALL _lcd_clear
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:49 WORDS
SUBOPT_0x4D:
	MOVW R0,R30
	RCALL SUBOPT_0x1B
	MOVW R26,R28
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	CALL __EEPROMWRB
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:35 WORDS
SUBOPT_0x4E:
	LDS  R26,_user
	LDS  R27,_user+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4F:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x50:
	CALL _lcd_clear
	RJMP SUBOPT_0x4B

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x51:
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x52:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,0
	SBRC R15,0
	LDI  R30,1
	ST   -Y,R30
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x53:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x54:
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x55:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x56:
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x57:
	RCALL SUBOPT_0x4E
	LDI  R30,LOW(5)
	CALL __MULB1W2U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x58:
	MOVW R26,R30
	CALL __EEPROMRDB
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RJMP SUBOPT_0x57

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x59:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5A:
	CALL _lcd_puts
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5B:
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R30
	CALL _refresh_key
	MOV  R4,R30
	CLR  R5
	RJMP SUBOPT_0x3D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5C:
	ST   -Y,R5
	ST   -Y,R4
	MOVW R30,R28
	ADIW R30,3
	RJMP SUBOPT_0x31

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5D:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _j,R30
	STS  _j+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5E:
	RCALL SUBOPT_0x1B
	SUBI R30,LOW(-_buffer)
	SBCI R31,HIGH(-_buffer)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x5F:
	LDI  R31,0
	SBIW R30,48
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x60:
	LDS  R26,_j
	LDS  R27,_j+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x61:
	CALL __EEPROMWRB
	LDI  R26,LOW(_j)
	LDI  R27,HIGH(_j)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x62:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x63:
	MOVW R26,R30
	CALL __EEPROMRDB
	CPI  R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x64:
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x65:
	LDI  R30,LOW(15)
	ST   -Y,R30
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x66:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x67:
	ST   -Y,R30
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x68:
	__PUTW1R 23,24
	MOVW R26,R30
	CALL __EEPROMRDB
	CALL __LNEGB1
	__GETW2R 23,24
	CALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x69:
	SUBI R30,LOW(-_user_en)
	SBCI R31,HIGH(-_user_en)
	RJMP SUBOPT_0x63

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6A:
	SUBI R30,LOW(-_user_en)
	SBCI R31,HIGH(-_user_en)
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6B:
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6C:
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x6D:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,_sw2
	RJMP SUBOPT_0x67

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6E:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6F:
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x70:
	SUBI R30,LOW(-_user_en)
	SBCI R31,HIGH(-_user_en)
	MOVW R26,R30
	CALL __EEPROMRDB
	CPI  R30,LOW(0x2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x71:
	LDI  R30,LOW(0)
	STS  _sw2,R30
	LDI  R30,LOW(1)
	STS  _sw1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x72:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	JMP  _sw_meno

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x73:
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	JMP  _sw_meno

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x74:
	LDI  R30,LOW(_disp)
	LDI  R31,HIGH(_disp)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x75:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcpy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x76:
	__POINTW1MN _disp,13
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x77:
	__POINTW1MN _disp,26
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x78:
	__POINTW1MN _disp,39
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x79:
	__POINTW1MN _disp,52
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7A:
	LDS  R30,_sw1
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _display_meno
	RJMP SUBOPT_0x6D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7B:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	JMP  _sw_meno

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7C:
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	JMP  _sw_meno

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x7D:
	LDI  R30,LOW(0)
	STS  _j,R30
	STS  _j+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7E:
	RCALL SUBOPT_0x1B
	MOVW R26,R28
	ADIW R26,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7F:
	LDS  R30,_j
	LDS  R31,_j+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x80:
	RCALL SUBOPT_0x1B
	MOVW R26,R28
	ADIW R26,15
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x81:
	MOVW R30,R28
	ADIW R30,28
	RJMP SUBOPT_0x31

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x82:
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,28
	RJMP SUBOPT_0x32

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x83:
	RCALL SUBOPT_0xF
	SUBI R26,LOW(-_pass_time_str)
	SBCI R27,HIGH(-_pass_time_str)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x84:
	STS  _j,R30
	STS  _j+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x85:
	RCALL SUBOPT_0x1B
	SUBI R30,LOW(-_main_password_load)
	SBCI R31,HIGH(-_main_password_load)
	MOVW R0,R30
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x86:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x87:
	LDI  R30,LOW(_main_password_load)
	LDI  R31,HIGH(_main_password_load)
	RJMP SUBOPT_0x4A

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x88:
	LDI  R30,LOW(100)
	MUL  R30,R26
	MOVW R30,R0
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x89:
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8A:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	ST   -Y,R30
	JMP  _refresh_key

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8B:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8C:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8D:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8E:
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8F:
	__POINTW1FN _0x0,601
	ST   -Y,R31
	ST   -Y,R30
	__GETB1MN _shmdate,2
	RJMP SUBOPT_0x59

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x90:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x91:
	ST   -Y,R30
	CALL _refresh_key
	MOV  R4,R30
	CLR  R5
	RJMP SUBOPT_0x3D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x92:
	RCALL SUBOPT_0x7F
	CALL __LNEGW1
	LDI  R31,0
	RJMP SUBOPT_0x84

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x93:
	LDI  R26,LOW(_i)
	LDI  R27,HIGH(_i)
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x94:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_hour
	RJMP SUBOPT_0x59

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x95:
	LDI  R26,LOW(13)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_disp)
	SBCI R31,HIGH(-_disp)
	RJMP SUBOPT_0x90

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x96:
	LDI  R30,LOW(11)
	ST   -Y,R30
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x97:
	RCALL SUBOPT_0x7F
	LDI  R26,LOW(_relay_mod)
	LDI  R27,HIGH(_relay_mod)
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x98:
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x99:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x9A:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x9B:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x9C:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x9D:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9E:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9F:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA0:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA1:
	CALL __long_delay_G104
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G104

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA2:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G104

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xA3:
	CALL _i2c_start
	LDI  R30,LOW(208)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA4:
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xA5:
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	LDI  R30,LOW(209)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	JMP  _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xA6:
	ST   X,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	CALL _bcd2bin
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	JMP  _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA7:
	ST   -Y,R30
	CALL _bin2bcd
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	JMP  _bin2bcd


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,27
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,53
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__LNEGW1:
	OR   R30,R31
	LDI  R30,1
	BREQ __LNEGW1F
	LDI  R30,0
__LNEGW1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
